﻿/*
 *	2012.4.9
 *		1:1 대화의 정의
 *			- 순수하게 1:1 대화로 시작해서 1:1 대화로 종료되는 상황을 1:1대화로 정의
 *			- 다중채팅도중 참여자가 나가서 1:1의 상황이 되는건 1:1대화가 아님
 *			- 1:1 도중 참여자가 추가되면 그때부터는 다중채팅
 *			  (이때 참여자가 나가서 다시 1:1의 상황이 되어도 1:1대화가 아님)
 */

#include "stdafx.h"
#include "ChatDlg.h"
#include "NeMessengerDlg.h"
#include "WorkGroupController.h"
#include "SendNoteMananger.h"
#include "XHyperLink.h"
#include "ChatDialogManager.h"
#include <algorithm>
#include <atltypes.h>
#include <mmsystem.h> 
#include "NfontWindow.h"
#include "StickersWindow.h"
#include "DialPadManager.h"
#include "nTalkUploadFileJob.h"
#include "nTalkDownloadFileJob.h"
#include "ChatMainViewElementList.h"
#include "FTImageMap.h"
#include "FileTraslateAbnormalHandler.h"
#include "main_frame.hpp"
#include "ChatLeftList.hpp"
#include "ChatToolBar.h"
#include "AddChatWnd.h"
#include "ChatSearchWnd.h"
#include "WorkGroupView.h"
#include "WorkGroupDlg.h"
#include "UnReadChatMessage.h"
#include "ProfileWnd.h"
#include "RecentMessageSqlite.h"
#include "DuiTrayPopup.h"
#include "ServerAddrConfig.h"
//#include <ftlWindow.h>

class CBuddyUser;


#define USE_TRANSLATE_FILE_IN_CHAT
#define RETRY_COUNT		6
#define RETRY_SLEEP		500
#define SPLIT_STATUSWND_DIS_LEFT 88 
#define CHAT_TITLE_HEIGHT 33
#define CHAT_WINDOW_BOTTOM_HEIGHT 6
#define EDGE_WIDTH	1
#define CHAT_LIST_MIN_WIDTH 131
#define CHAT_CONTENT_MIN_WIDTH 351
#define FONTBTN_TO_STATUSWND_DIS_TOP 5
#define SPLIT_LINE_WIDTH 1
#define CHAT_WINDOW_LEFT_NOT_SHOW__MIN_WIDTH (EDGE_WIDTH + CHAT_CONTENT_MIN_WIDTH + EDGE_WIDTH)
#define CHAT_WINDOW_LEFTSHOW__MIN_WIDTH (EDGE_WIDTH + CHAT_LIST_MIN_WIDTH + SPLIT_LINE_WIDTH + CHAT_CONTENT_MIN_WIDTH + EDGE_WIDTH)
#define CHAT_WIDOW_MIN_HEIGHT 423

#define INTERVAL_CHECK_SESSIONSTATUS		3000
#define INTERVAL_CHECK_PING					30000	// 30 Sec
#define INTERVAL_WAS_REQUEST				1000
#define INTERVAL_CHECK_TYPEING              1000    // 1 Sec
#define INTERVAL_CHECK_RECV_TYPEING         2000    // 2 Sec
#define MIN_SEND_TYPEING_TIMEOUT            2000    // 2 Sec
#define MAX_CHECK_RECV_TYPEING_TIMEOUT      (MIN_SEND_TYPEING_TIMEOUT * 2)

#define USERLIST_RESIZING_MINIMUM_USER_NO	1
#define USERLIST_RESIZING_MAXIMUM_USER_NO	5

#define NTALK_CLIENT_AGENT		TEXT("Ntalk/1.0 (PC Client)")

#define MIN_ALPHA_VALUE 50

#define DEFAULT_TYPESTATUS_FONTSIZE (11.0)
#define  DEFAULT_EDITCHAT_FONTSIZE  (12)

#define SQLITE3 m_pChatMainView->GetRecentMessageSqlite()

//#define UM_SHOW_CHAT_LIST WM_USER + 100

IMPLEMENT_DYNAMIC(CFileDialogEx, CFileDialog)

BEGIN_MESSAGE_MAP(CFileDialogEx, CFileDialog)

END_MESSAGE_MAP()

CFileDialogEx::CFileDialogEx(CPoint pt,CString strFilter,CWnd* parent):
CFileDialog(TRUE, NULL, NULL, OFN_EXPLORER | OFN_HIDEREADONLY | OFN_ALLOWMULTISELECT | OFN_ENABLESIZING , strFilter, parent, 0, FALSE)  {
  m_point = pt;
  //m_bVistaStyle = FALSE;
}

CFileDialogEx::~CFileDialogEx(){
   //m_bVistaStyle = TRUE;
}

void CFileDialogEx::OnInitDone()
{
	//CFileDialog::OnInitDone();
	GetParent()->SetWindowPos(NULL, m_point.x,m_point.y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);

	/*CRect rc;
	GetWindowRect(&rc);
	int width = rc.Width();
	int height = rc.Height();
	GetParent()->SetWindowPos(&wndTopMost, m_point.x,m_point.y, width, height, SWP_SHOWWINDOW);*/
}

DUI_BEGIN_MESSAGE_MAP(CChatDlg, WindowImplBase, FALSE)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_WINDOWINIT, OnPrepare)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_VALUECHANGED, OnNotifyAlphaChange)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_VALUECHANGING, OnNotifyAlphaChange)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_SET_CURSOR, OnNotifySetCursor)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_RETURN, OnNotifyReturn)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_SETFOCUS, OnNotifySetFocus)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_KILLFOCUS, OnNotifyKillFocus)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_CLICK, OnNotifyClick)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_ITEMCLICK, OnNotifyItemClick)
    //DUI_ON_CLICK_CTRNAME(_T("btn_pin"), OnNotifyClickMenuTopMost);
DUI_END_MESSAGE_MAP()

DUI_BEGIN_CUSTOM_MSG_MAP(CChatDlg)
    ON_CUSTOM_MSG(WM_CHATDLGSENDFILE, OnMsgChatDlgSendFile)
    //ON_CUSTOM_MSG(UM_CHAT_EDIT_KILLFOCUS, OnMsgChatEditKillFocus)
    //ON_CUSTOM_MSG(UM_CHAT_EDIT_FOCUS, OnMsgChatEditFocus)
    ON_CUSTOM_MSG(WM_SYSKEYDOWN, OnMsgSysKeyDown)
    ON_CUSTOM_MSG(WM_ACTIVATE, OnMsgActivate)
    ON_CUSTOM_MSG(WM_KEYUP, OnMsgKeyUp)

	BEGIN_CUSTOM_COMMAND_GROUP()
		ON_CUSTOM_COMMAND_MSG(ID_CHAT_TOPMOST, _OnCommandMenuTopMost)
		ON_CUSTOM_COMMAND_MSG(ID_CHAT_SEND_MEMO, _OnCommandMenuSendMemo)
		ON_CUSTOM_COMMAND_MSG(ID_CHAT_SEND_FILES, _OnCommandMenuSendFiles)
		ON_CUSTOM_COMMAND_MSG(ID_CHAT_INVITE, _OnCommandMenuInvite)
		ON_CUSTOM_COMMAND_MSG(ID_CHAT_HISTORY, _OnCommandMenuChatHistory)
		ON_CUSTOM_COMMAND_MSG(ID_MENU_KICK_USER, _OnCommandMenuKickUser)
	END_CUSTOM_COMMAND_GROUP()

    ON_CUSTOM_MSG(WM_CHAT_FONT_DLG_CLOSED, OnMsgChatFontDlgClosed)
    ON_CUSTOM_MSG(WM_POPUPTRAYDLG, OnMsgPopupTrayDlg)
    ON_CUSTOM_MSG(WM_CLICKTRAY, OnMsgClickTray)
    ON_CUSTOM_MSG(WM_CHATMSGPOPUPTRAYDLG, OnMsgChatMsgPopupTrayDlg)
    ON_CUSTOM_MSG(WM_CHAT_STICKER_SELECTED, OnMsgChatStickerSelected)
    ON_CUSTOM_MSG(WM_CHAT_STICKER_DLG_CLOSED, OnMsgChatStickerDlgClosed)
    ON_CUSTOM_MSG(UM_NOTIFY_STATUS_POPUP, OnMsgNotifyStatusPopup)
    ON_CUSTOM_MSG(WM_ADD_USER_CHAT, OnMsgAddUserChat)
    ON_CUSTOM_MSG(WM_TIMER, OnMsgTimer)
	ON_CUSTOM_MSG(WM_SIZING, OnSizing)
    ON_CUSTOM_MSG(MSG_CLICK_MAIN_VIEW, OnMsgClickMainView)
    ON_CUSTOM_MSG(MSG_CLOSE_CHAT_SEARCH, OnMsgCloseChatSearch)
    ON_CUSTOM_MSG(MSG_CLOSE_INVITE_WINDOWN, OnMsgCloseInviteWindow)
	
DUI_END_CUSTOM_MSG_MAP()

CChatDlg::CChatDlg():
	m_bFlashFlag(false), 
	m_bEnableDragAndDrop(TRUE),
	m_bPrepared(FALSE),
	m_pSendMsgThread(NULL),
	m_pInternetTransfer(NULL),
	m_nInviteRetryCount(0),
	m_bTryRecoverySession(TRUE),
	m_nPingPongCount(0), 
	m_creationTime(0),
	m_pSearchChatItem(NULL),
	m_bForceLeave(FALSE),
    m_bReadOnlyByNetwork(FALSE),
    m_bRoomEnd(FALSE),
	m_pStickerDlg(NULL),
	m_pFontDlg(NULL),
	m_trid(0),
	m_nFileTransIndex(0),
	m_channel(0),
	m_bScrollock(false),
	m_bshowtip(false),
	m_bHideOnEscEtc(false),
	m_bBeforeStatusOfTyping(FALSE),
	m_OnGoingAction(SENDACTION_NONE),
	m_bNeedRestoreRoomID(true),
	m_bRestoreLeftWindow(true),
    m_qChatMsg(LONG_MAX)
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);
	EnableCascade(true);

	//m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_pNtalk = NULL;	 	
	m_bOnceTrayPopup = FALSE;
	
	m_strTitle = _T("");
	m_strChatUserNames = _T("");

	m_rtTitle.SetRectEmpty();
	m_rtSlideBar.SetRectEmpty();
	m_nSlidePos = 0;
	m_bSlideCapture = FALSE;
	m_nChatUserFontHeight = DEF_CHAT_USER_FONT_HEIGHT;
	m_nChatUserCountFontHeight = DEF_CHAT_USER_COUNT_FONT_HEIGHT;
	m_nFixedTitleFontHeight = DEF_CHAT_FIXED_TITLE_FONT_HEIGHT;

	m_crChatUserTxt = DEF_CHAT_USER_TXT_COLOR;
	m_crChatUserCountTxt = DEF_CHAT_USER_CNT_TXT_COLOR;
	m_crFixedTitleTxt = DEF_CHAT_FIXED_TITLE_TXT_COLOR;

	m_creationTime = CTime::GetCurrentTime();
	GetLocaleTime(&m_creationTime);
	m_bTopMost = false;
	m_pChatMainView = NULL;
	m_bRemoveChatDlgWhenChatClose = false;
	//m_pWorkStatusLayerDlg = NULL;
	m_bSplitterClicked = FALSE;
	m_nCursor = 0;
	m_rtSplitter.SetRectEmpty();

	m_rtSplitter.left = EDGE_WIDTH + CHAT_LIST_MIN_WIDTH + SPLIT_LINE_WIDTH;
	m_rtSplitter.right = m_rtSplitter.left;
	m_rtSplitter.top = CHAT_TITLE_HEIGHT;
	m_TileHeight = CHAT_TITLE_HEIGHT;

	m_pChatSearchWnd = NULL;
	//m_pMainFrame = NULL;
	m_strFileOrStickerMsg = _T("");

    m_pEditChat = NULL;
    m_pBtnFile = NULL;
    m_pBtnSticker = NULL;
    m_pBtnText = NULL;
    m_pBtnSearch = NULL;
    m_pBtnAddUser = NULL;

    m_pBtnMin = NULL;
    m_pBtnMax = NULL;
    m_pBtnClose = NULL;
    m_pBtnRestore = NULL;

    m_pBtnPin = NULL;
    m_pSliderOpacity = NULL;

    m_pSearchEdit = NULL;
    m_pSearchLabel = NULL;
    m_pChatNumLabel = NULL;
    m_dwLastTypingTicket = 0;
    m_dwLastSendTypingTicket = 0;

	SetMyInfo();

    wnd = NULL;
    ZeroMemory(&m_cf, sizeof(m_cf));    //lint !e1415
    //m_editColor = RGB(...);
    m_qChatMsg.Start();
}

CChatDlg::~CChatDlg()
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);

	if (m_pInternetTransfer)
	{
		m_pInternetTransfer->Stop();
		delete m_pInternetTransfer;
		m_pInternetTransfer = NULL;
	}

	m_ilStatus.DeleteImageList();
	m_ilIPTStatus.DeleteImageList();

	// 대화 전송 쓰레드 종료 시까지 대기
	if( m_pSendMsgThread != NULL )
	{
        m_qChatMsg.Stop();
		m_pSendMsgThread->CloseThread(FALSE);
		m_pSendMsgThread->PostThreadMessage(WM_QUIT, 0, 0);

		if(WaitForSingleObject(m_pSendMsgThread->m_hThread, 3000) == WAIT_TIMEOUT)
		{
			// 타임아웃까지 종료되지 않으면 강제종료
			m_pSendMsgThread->SuspendThread();
			m_pSendMsgThread->ExitInstance();
		}
		else  
		{
			// 자동종료되어 객체가 자동 삭제된다. 
			// 자동삭제를 방지하려면 m_pSendMsgThread->m_bAutoDelete = FALSE 로 설정하면
			// 객체를 삭제되지 않고 남아있다.
			// 현재 쓰레드의 상태를 알기 위해서는 ::GetExitCodeThread( m_pSendMsgThread, &dwExitCode ); 를 사용하면 된다.
		}
		m_pSendMsgThread = NULL;

        P_SEND_CHAT_MESSAGE pSendChatMessage = NULL;
        while (m_qChatMsg.RemoveAfterStop(pSendChatMessage))
        {
            delete pSendChatMessage;
        }
	}

	// 초대 쓰레드 종료 시까지 대기
	for (std::list<HANDLE>::iterator iter = m_hInviteThreadList.begin(); iter != m_hInviteThreadList.end(); iter++)
	{
		HANDLE hInviteThread = (HANDLE)*iter;
		if (hInviteThread != NULL)
		{
			WaitForSingleObject(hInviteThread, INFINITE); 
			CloseHandle(hInviteThread);
		}
	}
	m_hInviteThreadList.clear();

//	CloseStickerDlg();

	try
	{
		if (m_pNtalk)
		{
			m_chatModel.RemoveChatUserMap();
			m_pNtalk->RequestChatLeave();
			m_pNtalk->DestroyChatSession();
			delete m_pNtalk;
			m_pNtalk = NULL;
		}

		ProcUregFavoriteFromPOI();

	}
	catch (...)
	{
        TRACE(TEXT("ERROR: CChatDlg::~CChatDlg exception\n"));
        //NTALK_LOG->Debug(L"[CHAT]ERROR: CChatDlg::~CChatDlg exception");
	}	
    wnd = NULL;
    ASSERT(NULL == m_pFontDlg);
    ASSERT(NULL == m_pStickerDlg);
    ASSERT(NULL == m_pChatMainView);
    ASSERT(NULL == m_pChatSearchWnd);
    m_pSearchChatItem = NULL;

    //Dui Control
    m_pEditChat = NULL;
    m_pBtnFile = NULL;
    m_pBtnSticker = NULL;
    m_pBtnText = NULL;
    m_pBtnSearch = NULL;
    m_pBtnAddUser = NULL;
    m_pBtnMin = NULL;
    m_pBtnMax = NULL;
    m_pBtnClose = NULL;
    m_pBtnRestore = NULL;
    m_pBtnPin = NULL;
    m_pSliderOpacity = NULL;
    m_pSearchEdit = NULL;
    m_pSearchLabel = NULL;
    m_pChatNumLabel = NULL;
}//lint !e1579

BOOL CChatDlg::UserGivenRect(LPRECT lpRect)
{
	CVerticalLayoutUI* pLeftWnd = static_cast<CChatLeftList*>(m_PaintManager.FindControl(_T("chat_list_bg")));
	CButtonUI* pSplitLine = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("split_line")));
	
	if (!pLeftWnd || !pSplitLine)
	{
		return FALSE;
	}

	int nWidth = 0;
	if (m_bRestoreLeftWindow)
	{
		nWidth = pLeftWnd->GetFixedWidth() + ((pSplitLine != NULL)? pSplitLine->GetFixedWidth():0);
	}
	
	lpRect->left += nWidth;
	return TRUE;
}


CControlUI* CChatDlg::CreateControl(LPCTSTR pstrClass)
{
	if (_tcsicmp(pstrClass, _T("ChatList")) == 0)
	{
		return new CChatLeftList(m_PaintManager);
	}

	return NULL;
}

LPCTSTR CChatDlg::GetWindowClassName() const
{
	return _T("nTalk_ChatDlg");
}
  
CDuiString CChatDlg::GetSkinFile()
{
	return _T("chatdlg.xml");
}

CDuiString CChatDlg::GetSkinFolder()
{
	return _T("skin\\nTalkRes");
}

void CChatDlg::LoadSkin()
{
	m_PaintManager.Init(m_hWnd);
	CDialogBuilder dlgBuilder;
	CDialogBuilderCallbackChatEx cb(this);
	CControlUI* pRoot = dlgBuilder.Create(_T("chatdlg.xml"), (UINT)0,  &cb, &m_PaintManager);
	ASSERT(pRoot);
	m_PaintManager.AttachDialog(pRoot);
	m_PaintManager.AddNotifier(this);
}

void CChatDlg::InitChannel(int channel/* =0 */)
{
	m_channel  = channel;
}



void CChatDlg::OnPrepare(TNotifyUI& msg)
{
    //logical -- add tooltip and init
	if (m_pSearchLabel != NULL)
	{
		m_pSearchLabel->SetVisible(true);
		m_pSearchLabel->SetText(LoadStringFromResource(IDS_STRING_CHAT_DEFAULT_SEARCH));
		m_pSearchLabel->SetToolTip(LoadStringFromResource(IDS_STRING_CHAT_DEFAULT_SEARCH));
	}
	if (m_pBtnSearch != NULL)
	{
		m_pBtnSearch->SetToolTip(LoadStringFromResource(IDS_STRING_CHAT_TOOLTIP_14));
	}
	// chat tool bar
    if(m_pBtnFile){
		m_pBtnFile->SetToolTip(LoadStringFromResource(IDS_STRING_CHAT_TOOLTIP_9));
    }
    if(m_pBtnSticker){ 
        m_pBtnSticker->SetToolTip(LoadStringFromResource(IDS_STRING_CHAT_TOOLTIP_10));
    }
    if(m_pBtnText){
		m_pBtnText->SetToolTip(LoadStringFromResource(IDS_STRING_CHAT_TOOLTIP_11));
    }
    if(m_pBtnPin){ 
    	m_pBtnPin->SetToolTip(LoadStringFromResource(IDS_STRING_CHAT_TOOLTIP_3_1));
    }
    if(m_pBtnAddUser){
		m_pBtnAddUser->SetToolTip(LoadStringFromResource(IDS_STRING_CHAT_TOOLTIP_2));
    }

    if(m_pBtnMin){ 
		m_pBtnMin->SetToolTip(LoadStringFromResource(IDS_STRING_CHAT_TOOLTIP_5));
    }
    if (m_pBtnMax){
		m_pBtnMax->SetToolTip(LoadStringFromResource(IDS_STRING_CHAT_TOOLTIP_6));
    }
    if(m_pBtnRestore){ 
		m_pBtnRestore->SetToolTip(LoadStringFromResource(IDS_STRING_CHAT_TOOLTIP_6_1));
    }
    if(m_pBtnClose){ 
		m_pBtnClose->SetToolTip(LoadStringFromResource(IDS_STRING_CHAT_TOOLTIP_7));
    }
    if(m_pSliderOpacity){ 
		m_pSliderOpacity->SetToolTip(LoadStringFromResource(IDS_STRING_CHAT_TOOLTIP_4));
    }
	m_bPrepared = TRUE;

    SetTimer(m_hWnd, TIMER_CHAT_CHECK_INPUTTING, INTERVAL_CHECK_TYPEING, NULL);
    SetTimer(m_hWnd, TIMER_CHAT_CHECK_RECV_INPUTTING, INTERVAL_CHECK_RECV_TYPEING, NULL);
}

void CChatDlg::__ResourceLoad(BOOL bInit)
{
}

BOOL CChatDlg::CheckSendFileInfos(const std::vector<CString>& attachFileVector, std::vector<AttachFileInfo>& attachFileFileVector)
{
	if (attachFileVector.size() > MAX_TRANSLATE_FILES_COUNT)
	{
		NMessageBox(this->wnd, LoadStringFromResource(IDS_CHAT_FILE_MAX_COUNT));
		return FALSE;
	}

	BOOL bHasDir = FALSE;
	BOOL bHasFile = FALSE;

	TRY
	{
		for (std::vector<CString>::const_iterator iter = attachFileVector.begin();
			iter != attachFileVector.end(); 
			++iter)
		{
			const CString& strFilePath = *iter;
			CFileStatus status;
			if (CFile::GetStatus(strFilePath, status))
			{
				BOOL bIsFile = ((status.m_attribute & CFile::directory) == 0);
				if (!bIsFile)
				{
					bHasDir = TRUE;
					continue;
				}
			}
			
			AttachFileInfo attachFileInfo;
			attachFileInfo.flepath = strFilePath;
			LPCTSTR pszFileName = ::PathFindFileName( strFilePath );
			if (pszFileName)
			{
				attachFileInfo.fileName = pszFileName;

				CFile file(strFilePath, CFile::modeRead | CFile::shareDenyNone);
				attachFileInfo.fileSize = file.GetLength();
				if (attachFileInfo.fileSize > MAX_TRANSLATE_FILE_SIZE)
				{
					NMessageBox(this->wnd, LoadStringFromResource(IDS_CHAT_FILE_MAX_SINGLE_FILE_SIZE));
					return FALSE;
				}

				bHasFile = TRUE;
				attachFileFileVector.push_back(attachFileInfo);
			}
		}
		if (bHasDir)
		{
			if (!bHasFile)
			{
				//only dir
				NMessageBox(this->wnd, LoadStringFromResource(IDS_CHAT_SEND_ONLY_DIR));
				return FALSE;
			}
			else
			{
				NMessageBox(this->wnd, LoadStringFromResource(IDS_CHAT_SEND_ONLY_DIR));
			}
		}
		return TRUE;
	}
	CATCH_ALL(e)
	{
		TCHAR szErrorMsg[MAX_PATH] = {0}; //MAX_ERROR_TEXT_LEN
		if(e->GetErrorMessage(szErrorMsg, _countof(szErrorMsg)))
		{
			NMessageBox(this->wnd, szErrorMsg);
		}
		return FALSE;
	}
	END_CATCH_ALL
}

BOOL CChatDlg::SetSendFile(const std::vector<CString>& attachFileVector)
{
	if (_IsReadOnlyStatus())
	{
		//can not send file when readonly(such as offline)
		return FALSE;
	}

	std::vector<AttachFileInfo> attachFileInfoVector;
	BOOL bRet = CheckSendFileInfos(attachFileVector, attachFileInfoVector);
	if (!bRet)
	{
		return bRet;
	}

	std::vector<wstring> receiverIdsVector;
	int nUserCnt = m_chatModel.GetChatUserMapCount();

	for(int i = 0; i < nUserCnt; i++)
	{
		if (m_chatModel.GetMyID().CompareNoCase(m_chatModel.GetChatUserID(i)) == 0)
			continue;
		std::wstring wstrReceiverId = m_chatModel.GetChatUserID(i);
		receiverIdsVector.push_back( wstrReceiverId);	
	}
	for (size_t i = 0; i < attachFileInfoVector.size(); i++)
	{
		//translate one file each time
		TranslateFileInfoPtr pUploadFileInfo(new TranslateFileInfo(attachFileInfoVector[i], receiverIdsVector, TRUE));
		pUploadFileInfo->m_TidRequestFileTranslate= m_chatModel.GetChatMsgTid();
		pUploadFileInfo->m_strSenderID = m_chatModel.GetMyID();
		pUploadFileInfo->m_strName = m_chatModel.GetMyName();
		pUploadFileInfo->m_strNickName = m_chatModel.GetMyTalkName();
		pUploadFileInfo->m_nSqliteSeq = 0;
		MakeUploadFileJob(pUploadFileInfo);
	}

	return TRUE;
}

CChatMainView* CChatDlg::GetChatMainViewPtr()
{
	return m_pChatMainView;
}

UIElement* CChatDlg::MakeUploadFileJob(TranslateFileInfoPtr& pUploadFileInfo, bool bRestore)
{
	UIElement *pUIElement = NULL;
	CAtlString strTicket = CFConversion().MBCS_TO_TCHAR(g_pMessengerActor->GetMessengerTicket());
	strTicket.Replace(TEXT("%3D%3D"), TEXT("=="));
	
	CString strUserNickName = g_pMessengerActor->GetTalkName();	
	if(m_pNtalk)
	{
		m_pNtalk->SetNickname(strUserNickName);
	}

	if (IsScrollLocked())
	{
		SetScrollLock(false);
	}

	CTime time(CTime::GetCurrentTime());
	GetLocaleTime(&time);

	//add upload file task
	FTL::FTransferJobInfoPtr pUploadJobInfo(new FTL::FTransferJobInfo(TEXT("api-nnote.ncloudbiz.com"),
		TEXT("/api/talk/file/upload.nhn")));
	if (pUploadJobInfo)
	{
		pUploadJobInfo->m_TransferJobType = tjtUpload;
		pUploadJobInfo->m_strVerb = TEXT("POST");

		pUploadJobInfo->AddTransferParam(FTL::tptPostArgument, TEXT("ticket"),strTicket, FTL::toNeedCallback);
		pUploadJobInfo->AddTransferParam(FTL::tptPostArgument, TEXT("defaultLanguage"), GetLanguageStringUnicode());
		pUploadJobInfo->AddTransferParam(FTL::tptLocalFile, TEXT("file"), pUploadFileInfo->m_fileInfo.flepath.c_str());
		//pUploadJobInfo->m_dwUserParam = trid;
		pUploadFileInfo->m_tmTime = time;
		{
			FTL::CFAutoLock<CFLockObject>	locker(&m_lockSendFileJobInfos);
			
			CNTalkUploadFileJob* pNTalkUploadJob = new CNTalkUploadFileJob(NTALK_CLIENT_AGENT, TRUE);
			if (pNTalkUploadJob)
			{
				pNTalkUploadJob->SetWriteBufferSize(64 * 1024); //64K
				pNTalkUploadJob->m_JobParam = pUploadJobInfo;
				INT nJobIndex = m_pInternetTransfer->AddTask(pNTalkUploadJob);
				pUploadFileInfo->m_nJobIndex = nJobIndex;

// 				if(bRestore)
// 				{
// 					pUploadFileInfo->m_nSqliteSeq = 1 + 
// 						SQLITE3.GetMaxSequence(m_chatModel.GetRoomID());
// 				}
				m_chatModel.AddMyTranslateFileInfo(nJobIndex, pUploadFileInfo);
				ChatItemInfo stItemInfo;
				stItemInfo.eMsgGB = CHAT_MSG_FTP;
				stItemInfo.strUserID = m_chatModel.GetMyID();
				stItemInfo.strUserName = m_chatModel.GetMyName();
				stItemInfo.strNameTalkName = strUserNickName;
				stItemInfo.time = time;
				stItemInfo.nTid = pUploadFileInfo->m_TidRequestFileTranslate;
				stItemInfo.nMsgSeq = pUploadFileInfo->m_nFileSeq;// pUploadFileInfo->m_nSqliteSeq;
				stItemInfo.nUserCount = m_chatModel.GetUserCount();

				pUIElement = m_pChatMainView->AddTranslateFileItem(&stItemInfo, pUploadFileInfo, bRestore);
				
				//CFileTranslateAbnormalHandler::Store(m_chatModel.GetRoomID(), pUploadFileInfo);
				AddRecentContact();

				m_strFileOrStickerMsg = LoadStringFromResource(IDS_STRING_SEND_FILE);
				if (bRestore){
					m_creationTime = CTime::GetCurrentTime();
					GetLocaleTime(&m_creationTime);
				}
				
				pNTalkUploadJob->Resume();//make sure have SetTranslateCallback(pTransCallBack)
				//m_pChatMainView->AddTranslateFileItem(m_chatModel.GetMyID(), m_chatModel.GetMyName(), 
				//	strUserNickName, time, pUploadFileInfo, 0, 0, msgType);
			}
		}//lint !e429
	}

	return pUIElement;
}

UIElement* CChatDlg::MakeDownloadFileJob(TranslateFileInfoPtr& pDownloadFileInfo, bool bRestore)
{
	UIElement *pUIElement = NULL;
	//BYTE msgType = DEF_FTP_MSG_TYPE;
	CString strUserNickName = g_pMessengerActor->GetTalkName();	
	if(m_pNtalk)
	{
		m_pNtalk->SetNickname(strUserNickName);
	}

	//CTime tmSave = pDownloadFileInfo->m_tmTime;

	ChatItemInfo stItemInfo;
	stItemInfo.eMsgGB = CHAT_MSG_FTP;
	stItemInfo.strUserID = pDownloadFileInfo->m_strSenderID;
	stItemInfo.strUserName = pDownloadFileInfo->m_strName;
	stItemInfo.strNameTalkName = pDownloadFileInfo->m_strNickName;
	//GetLocaleTime(&pDownloadFileInfo->m_tmTime);
	stItemInfo.time = pDownloadFileInfo->m_tmTime;
	stItemInfo.nTid = pDownloadFileInfo->m_TidRequestFileTranslate;
    stItemInfo.nMsgSeq = pDownloadFileInfo->m_nFileSeq;
// 	if(bRestore)
// 	{
// 	pDownloadFileInfo->m_nSqliteSeq = 1 + 
// 		SQLITE3.GetMaxSequence(m_chatModel.GetRoomID());
// 	}

	pUIElement = m_pChatMainView->AddTranslateFileItem(&stItemInfo, pDownloadFileInfo, bRestore);
// 	{
// 		pDownloadFileInfo->m_tmTime = tmSave;
// 		stItemInfo.time = tmSave;
// 		//CFileTranslateAbnormalHandler::Store(m_chatModel.GetRoomID(), pDownloadFileInfo);
// 	}
	AddRecentContact();

	m_strFileOrStickerMsg = LoadStringFromResource(IDS_STRING_RECEIVE_FILE);

	return pUIElement;
}

bool CChatDlg::CancelTransferJob(LONG nJobIndex)
{
	if (m_pInternetTransfer)
	{
		m_pInternetTransfer->CancelTask(nJobIndex);
	}
	return true;
}

char *Utf8URLencode(char *str)
{
	char *encstr, buf[2+1];
	unsigned char c;
	int i, j;

	if(str == NULL) return NULL;
	if((encstr = (char *)malloc((strlen(str) * 3) + 1)) == NULL) 
		return NULL;

	for(i = j = 0; str[i]; i++) 
	{
		c = (unsigned char)str[i];
		if((c >= '0') && (c <= '9')) encstr[j++] = c;
		else if((c >= 'A') && (c <= 'Z')) encstr[j++] = c;
		else if((c >= 'a') && (c <= 'z')) encstr[j++] = c;
		else if((c == '@') || (c == '.') || (c == '/') || (c == '\\')
			|| (c == '-') || (c == '_') || (c == ':') ) 
			encstr[j++] = c;
		else 
		{
			StringCchPrintfA(buf, _countof(buf), "%02x", c);
			encstr[j++] = '%';
			encstr[j++] = buf[0];
			encstr[j++] = buf[1];
		}
	}
	encstr[j] = '\0';

	return encstr;
}

bool CChatDlg::StartDownloadFile(TranslateFileInfoPtr& pDownloadFileInfo)
{
	if(pDownloadFileInfo->GetStatus() == sReceiving)
	{
		//Already downloading
		return false;
	}

	//add download task after ChatItem Save or SaveAs
	CString strTicket = CFConversion().MBCS_TO_TCHAR(g_pMessengerActor->GetMessengerTicket());
	CFConversion convUtf8(CP_UTF8);
	LPSTR pszUtf8 = convUtf8.TCHAR_TO_UTF8(pDownloadFileInfo->m_fileInfo.downloadUrl.c_str());

	CString strUrl;
	char* pUrlConv = Utf8URLencode(pszUtf8);
	if (pUrlConv)
	{
		strUrl.Format(TEXT("/api/talk/file/download.nhn?ticket=%s&filePath=%s&defaultLanguage=%s"),
			strTicket, //UrlEncode(pDownloadFileInfo->m_fileInfo.downloadUrl.c_str()),
			CFConversion(CP_UTF8).UTF8_TO_TCHAR(pUrlConv),
			GetLanguageStringUnicode());
		free(pUrlConv);
	}
	FTLTRACEEX(tlTrace, TEXT("DownloadURL=http://api-nnote.ncloudbiz.com%s\n"), strUrl);

	if (!strUrl.IsEmpty())
	{
		FTL::FTransferJobInfoPtr pDownloadJobInfo(new FTL::FTransferJobInfo(TEXT("api-nnote.ncloudbiz.com"), strUrl));
		if (pDownloadJobInfo)
		{
			pDownloadJobInfo->m_TransferJobType = tjtDownload;
			pDownloadJobInfo->m_strVerb = TEXT("POST"); //download.nhn doesn't support GET
			pDownloadJobInfo->AddTransferParam(FTL::tptLocalFile, TEXT("file"), pDownloadFileInfo->m_fileInfo.flepath.c_str());
			//pDownloadJobInfo->m_dwUserParam = (DWORD_PTR)pDownloadFileInfo.get();

			CTime time(CTime::GetCurrentTime());
			GetLocaleTime(&time);
			pDownloadFileInfo->m_tmTime = time;
			pDownloadFileInfo->ResetProgressInfo();

			FTL::CFAutoLock<CFLockObject>	locker(&m_lockSendFileJobInfos);

			CNTalkDownloadFileJob* pNTalkDownloadJob = new CNTalkDownloadFileJob(NTALK_CLIENT_AGENT, TRUE);
			if (pNTalkDownloadJob)
			{
				pNTalkDownloadJob->SetReadBufferSize(4 * 1024); //4K
				pNTalkDownloadJob->m_JobParam = pDownloadJobInfo;
				INT nJobIndex = m_pInternetTransfer->AddTask(pNTalkDownloadJob);
				//INT nJobIndex = m_pInternetTransfer->AddDownloadTask(pDownloadJobInfo);
				m_chatModel.AddMyTranslateFileInfo(nJobIndex, pDownloadFileInfo);
				pDownloadFileInfo->m_nJobIndex = nJobIndex;

				pDownloadFileInfo->SetStatus(sReceiving);

				pNTalkDownloadJob->Resume();
				return true;    //lint !e429
			}
		}//lint !e429
	}
	return false;
}

void CChatDlg::OnJobProgress(LONG nJobIndex, CFJobBase<FTransferJobInfoPtr>* pJob, 
							 LONGLONG nCurPos, LONGLONG nTotalSize)
{
	//FTLTRACEEX(FTL::tlTrace, TEXT("CChatDlg::OnJobProgress, nId=%d, nCurPos=%lld, nTotalSize=%lld\n"), 
	//	nJobIndex, nCurPos, nTotalSize);

	BOOL bNameChanged = FALSE;
	TranslateFileInfoPtr pTranslateFileInfo = m_chatModel.GetMyTranslateFileInfo(nJobIndex, FALSE);
	if (pTranslateFileInfo)
	{
		if (!pTranslateFileInfo->IsUploadJob())
		{
			//download job, check file name have changed

			FTL::CFDownloadJob* pDownloadJob = dynamic_cast<FTL::CFDownloadJob*>(pJob);
			ASSERT(pDownloadJob);
			if (pDownloadJob && pDownloadJob->GetDownloadedFilePath() != pTranslateFileInfo->m_fileInfo.flepath.c_str())
			{
				bNameChanged = TRUE;
				pTranslateFileInfo->m_fileInfo.flepath = pDownloadJob->GetDownloadedFilePath();
				pTranslateFileInfo->m_fileInfo.fileName = ::PathFindFileName(pDownloadJob->GetDownloadedFilePath());
			}
		}
		if (nCurPos > 0)
		{
			//make sure will note 100% when in OnJobProgress to avoid long time wait for SendFileNotify
			nCurPos -= 1;
		}
		pTranslateFileInfo->SetProgress((LONG)nCurPos, (LONG)nTotalSize, bNameChanged);
	}
};

void CChatDlg::OnJobBegin(LONG nJobIndex, CFJobBase<FTL::FTransferJobInfoPtr>* pJob)
{
	TranslateFileInfoPtr pTranslateFileInfo = m_chatModel.GetMyTranslateFileInfo(nJobIndex, FALSE);
	if (pTranslateFileInfo)
	{
		if (pTranslateFileInfo->IsUploadJob())
		{
			pTranslateFileInfo->SetStatus(sUploading);
			SQLITE3.UpdateMsgStatus(m_chatModel.GetRoomID(),m_chatModel.GetMyID(),pTranslateFileInfo->m_TidRequestFileTranslate,sUploading);
		}
		else 
		{
			pTranslateFileInfo->SetStatus(sReceiving);
			SQLITE3.UpdateMsgStatus(m_chatModel.GetRoomID(),pTranslateFileInfo->m_strSenderID,pTranslateFileInfo->m_TidRequestFileTranslate,sReceiving);
		}
	}
}

bool IsInDoubleQuotes(const CAtlStringA& str, int nPos)
{
	bool bRet = true;
	CAtlStringA strTarget = str;
	int nFound = strTarget.Find('"');
	bool bNotEnd = true;
	while (false != (bNotEnd = (nFound != -1)))
	{
		bRet = !bRet;
		if(nFound < nPos)
		{
			nFound = strTarget.Find('"', nFound + 1);
		}
		else
		{
			break;
		}
	}
	if(!bNotEnd)
	{
		bRet = !bRet;
	}

	return bRet;
}

//Parse Json(lib runtime is wrong)
typedef std::list< std::pair< CAtlStringA, CAtlStringA > >	JsonNameValuePairs;
int _TempInnerParseResults(const CAtlStringA& strResponse, JsonNameValuePairs& pairs)
{
	pairs.clear();

	int nResultStart = strResponse.ReverseFind(TEXT('{')); //find last {
	int nResultEnd = strResponse.Find(TEXT('}'), 0);	//find first }
	if (-1 < nResultStart && nResultStart < nResultEnd)
	{
		//find result position
		CAtlStringA strTempResult = strResponse.Mid(nResultStart + 1, nResultEnd - nResultStart - 1);
		strTempResult += TEXT(",");

		CAtlStringA strResultName;
		CAtlStringA strResultValue;
		int nFound = 0;
		while (true/*nFound != -1*/)
		{
			if(nFound == -1)
			{
				break;
			}
			nFound = strTempResult.Find(',', nFound);  // TEXT(":,")
			int nLeft = nFound;
			if(nFound == -1)
			{
				break;
			}
			if(IsInDoubleQuotes(strTempResult, nFound))
			{
				nFound++;
				continue;
			}
			else
			{
				nFound= 0;
			}
			CAtlStringA strTmpPair = strTempResult.Left(nLeft);
			int nPairDivPos = strTmpPair.Find(':');
			if (nPairDivPos != -1)
			{
				strResultName = strTmpPair.Left(nPairDivPos);
				strResultValue = strTmpPair.Mid(nPairDivPos + 1);
				strResultName.Trim("\"\t\n ");
				strResultValue.Trim("\"");

				if (!strResultName.IsEmpty() && !strResultValue.IsEmpty())
				{
					pairs.push_back(make_pair(strResultName, strResultValue));
				}
			}
			strTempResult = strTempResult.Mid(nLeft + 1);
			nFound = strTempResult.FindOneOf(",");
		}
	}

	return pairs.size();
}

void CChatDlg::OnJobEnd(LONG nJobIndex, CFJobBase<FTransferJobInfoPtr>* pJob)
{
	FUNCTION_BLOCK_TRACE(DEFAULT_BLOCK_TRACE_THRESHOLD);

	FTL::FTransferJobInfoPtr pTransferJobInfo = pJob->m_JobParam;
    NTALK_LOG->Debug(TEXT("[CHAT] FILEJOBEND %d:%d:%d"),
        m_chatModel.GetRoomID(), nJobIndex, pTransferJobInfo->m_TransferJobType);

    FTLTRACE(TEXT("CChatDlg::OnJobEnd, RoomId=%d, nJobIndex=%d, JobType=%d, strResponseData=%s\n"), 
        m_chatModel.GetRoomID(), nJobIndex, pTransferJobInfo->m_TransferJobType,
        CFConversion().UTF8_TO_TCHAR(pTransferJobInfo->m_strResponseData));

	TranslateFileInfoPtr pTranslateFileInfo;
	{
		FTL::CFAutoLock<CFLockObject>	locker(&m_lockSendFileJobInfos);
		pTranslateFileInfo = m_chatModel.GetMyTranslateFileInfo(nJobIndex, TRUE);
	}
	
	if (pTranslateFileInfo)
	{
		//FTLASSERT(pTranslateFileInfo->m_nCurPos == pTranslateFileInfo->m_nTotalSize);
		
		if (pTranslateFileInfo->IsUploadJob())
		{
#if 0
			//Json lib and exe lib runtime is different, 
			Json::Value jsonValue;
			Json::Reader jsonReader;
			if( jsonReader.parse((LPCSTR) pJob->m_JobParam->m_strResponseData, jsonValue ) )
			{
				//CallWasResponse(true, pHttpFacade, strResultCode, &jsonValue);
				std::string strJsonResult = jsonValue.get("Result","").asString();
				std::string strJsonFilePath = jsonValue.get("filePath","").asString();
			}
#endif 
			FTLASSERT(pTransferJobInfo->m_TransferJobType == tjtUpload);

			CAtlStringA& strResponse = pTransferJobInfo->m_strResponseData;
			JsonNameValuePairs pairs;

			_TempInnerParseResults(strResponse, pairs);
			BOOL bSuccess = FALSE;
			wstring strErrorInfo;
			for (JsonNameValuePairs::iterator iter = pairs.begin();
				iter != pairs.end(); 
				++iter)
			{
				CAtlStringA& strTmpName = iter->first;
				CAtlStringA strTmpValue = iter->second;
				if (strTmpName == "Message")
				{
					strErrorInfo = Conversion::Utf8ToWide((LPCSTR)strTmpValue);
				}
				if (strTmpName == "filePath")
				{
					bSuccess = TRUE;
					pTranslateFileInfo->m_fileInfo.downloadUrl = Conversion::Utf8ToWide((LPCSTR)strTmpValue);
					break;
				}
			}
			
			bool bUpdateUI =  false;
			if (bSuccess)
            {
                //when file upload completed, set progress to near 99% and wait for SendFileNotify Result
                LONG nTotalSize = (LONG)pTranslateFileInfo->m_fileInfo.fileSize;
                LONG nCurPos = nTotalSize - 1;
                if (nCurPos < 0)
                {
                    nCurPos = 0;
                }
                pTranslateFileInfo->SetProgress(nCurPos, (LONG)nTotalSize, FALSE);

                //do not update to sUploadSuccess now -- update status in OnMsgResult after SendFileNotify

				//if (pTranslateFileInfo->GetResult() == eSuccess)
				//{
				//	pTranslateFileInfo->SetStatus( sUploadSuccess );
				//	//CFileTranslateAbnormalHandler::Store(m_chatModel.GetRoomID(), pTranslateFileInfo);
				//	SQLITE3.UpdateMsgStatus(m_chatModel.GetRoomID(),m_chatModel.GetMyID(),pTranslateFileInfo->m_TidRequestFileTranslate,sUploadSuccess);
				//	m_chatModel.UpdateMsgStatus(m_chatModel.GetMyID(),pTranslateFileInfo->m_TidRequestFileTranslate,sUploadSuccess);
				//}
				SendFileNotify(pTranslateFileInfo, pJob);
			}
			else if(!strErrorInfo.empty())
			{
				//TODO: Notify ChatItem display Error Information
				TRACE(TEXT("CChatDlg::OnJobEnd, JsonError=%s\n"), strErrorInfo.c_str());
				//NMessageBox(this, strErrorInfo.c_str());
				pTranslateFileInfo->SetResultByLastError(ERROR_LOST_WRITEBEHIND_DATA_NETWORK_SERVER_ERROR);
				SQLITE3.UpdateMsgStatus(m_chatModel.GetRoomID(),m_chatModel.GetMyID(),pTranslateFileInfo->m_TidRequestFileTranslate,sUploadError);
				m_chatModel.UpdateMsgStatus(m_chatModel.GetMyID(),pTranslateFileInfo->m_TidRequestFileTranslate,sUploadError);
			}
		}
		else
		{
			//Download Job end
			FTLASSERT(pTransferJobInfo->m_TransferJobType == tjtDownload);
			if (pTranslateFileInfo->GetResult() == eSuccess)
			{
				FTL::CFDownloadJob* pDownloadJob = dynamic_cast<FTL::CFDownloadJob*>(pJob);
				ASSERT(pDownloadJob);
				if (pDownloadJob && pDownloadJob->GetDownloadedFilePath() != pTranslateFileInfo->m_fileInfo.flepath.c_str())
				{
					pTranslateFileInfo->m_fileInfo.flepath = pDownloadJob->GetDownloadedFilePath();
					pTranslateFileInfo->m_fileInfo.fileName = ::PathFindFileName(pDownloadJob->GetDownloadedFilePath());
				}
				pTranslateFileInfo->SetStatus( sRecvSuccess );
				SQLITE3.UpdateMsgStatus(m_chatModel.GetRoomID(),pTranslateFileInfo->m_strSenderID,pTranslateFileInfo->m_TidRequestFileTranslate,sRecvSuccess);
				m_chatModel.UpdateMsgStatus(pTranslateFileInfo->m_strSenderID,pTranslateFileInfo->m_TidRequestFileTranslate,sRecvSuccess);
				//CFileTranslateAbnormalHandler::Store(m_chatModel.GetRoomID(), pTranslateFileInfo);
			}
		}
	}
}

void CChatDlg::OnJobCancel(LONG nJobIndex, CFJobBase<FTL::FTransferJobInfoPtr>* pJob)
{
	FTLTRACE(TEXT("CChatDlg::OnJobCancel, nJobIndex=%d\n"), nJobIndex);
	TranslateFileInfoPtr pTranslateFileInfo;
	{
		FTL::CFAutoLock<CFLockObject>	locker(&m_lockSendFileJobInfos);
		pTranslateFileInfo = m_chatModel.GetMyTranslateFileInfo(nJobIndex, TRUE);
		pTranslateFileInfo->SetResultByLastError(ERROR_CANCELLED);
	}

	if (pTranslateFileInfo->IsUploadJob())
	{
		SQLITE3.UpdateMsgStatus(m_chatModel.GetRoomID(),m_chatModel.GetMyID(),pTranslateFileInfo->m_TidRequestFileTranslate,sUploadCancle);
		m_chatModel.UpdateMsgStatus(m_chatModel.GetMyID(),pTranslateFileInfo->m_TidRequestFileTranslate,sUploadCancle);
	}
	else
	{
		SQLITE3.UpdateMsgStatus(m_chatModel.GetRoomID(),pTranslateFileInfo->m_strSenderID,pTranslateFileInfo->m_TidRequestFileTranslate,sRecvCancle);
		m_chatModel.UpdateMsgStatus(pTranslateFileInfo->m_strSenderID,pTranslateFileInfo->m_TidRequestFileTranslate,sRecvCancle);
	}
}

void CChatDlg::OnJobError(LONG nJobIndex, CFJobBase<FTL::FTransferJobInfoPtr>* pJob, DWORD dwError, LPCTSTR pszDescription)
{
	FTLTRACE(TEXT("CChatDlg::OnJobError, nJobIndex=%d, dwError=%d, pszDescription=%s\n"), 
		nJobIndex, dwError, pszDescription);

	TranslateFileInfoPtr pTranslateFileInfo;
	{
		FTL::CFAutoLock<CFLockObject>	locker(&m_lockSendFileJobInfos);
		pTranslateFileInfo = m_chatModel.GetMyTranslateFileInfo(nJobIndex, FALSE);
		if (pTranslateFileInfo)
		{
			pTranslateFileInfo->SetResultByLastError(dwError);
			//CTime t(pTranslateFileInfo->m_tmFailTime);
			CTime t(CTime::GetCurrentTime());
			GetLocaleTime(&t);
			CString strFailMsg;
			if (pTranslateFileInfo->IsUploadJob())
			{
				strFailMsg = LoadStringFromResource(IDS_CHAT_FILE_SEND_ERROR);
				SQLITE3.UpdateMsgStatus(m_chatModel.GetRoomID(),m_chatModel.GetMyID(),pTranslateFileInfo->m_TidRequestFileTranslate,sUploadError);
				m_chatModel.UpdateMsgStatus(m_chatModel.GetMyID(),pTranslateFileInfo->m_TidRequestFileTranslate,sUploadError);
			}
			else
			{
				if (ERROR_DISK_FULL == dwError)
				{
					strFailMsg = LoadStringFromResource(IDS_CHAT_FILE_ERROR_LOCAL_DISK_FULL);
				}
				else
				{
					strFailMsg = LoadStringFromResource(IDS_CHAT_FILE_RECV_ERROR);
				}

				SQLITE3.UpdateMsgStatus(m_chatModel.GetRoomID(),pTranslateFileInfo->m_strSenderID,pTranslateFileInfo->m_TidRequestFileTranslate,sRecvError);
				m_chatModel.UpdateMsgStatus(pTranslateFileInfo->m_strSenderID,pTranslateFileInfo->m_TidRequestFileTranslate,sRecvError);
			}

			ChatItemInfo stChatItemInfo(strFailMsg, t, m_cf);
			m_pChatMainView->AddChatItem(&stChatItemInfo, true);
		}
	}

}

BOOL CChatDlg::SendFileNotify(TranslateFileInfoPtr& pTranslateFileInfo, CFJobBase<FTransferJobInfoPtr>* pJob)
{
	BOOL bRet = FALSE;
    BOOL bUserStop = FALSE;
	FUNCTION_BLOCK_TRACE(DEFAULT_BLOCK_TRACE_THRESHOLD);

    //try to send file notify for more than once
    INT nTryCount = 2;
    const AttachFileInfo& fileInfo = pTranslateFileInfo->m_fileInfo;
    pTranslateFileInfo->m_vecReceiverIds.push_back((LPCTSTR)m_chatModel.GetMyID());

    NTALK_LOG->Debug(TEXT("[CHAT] SendFileNotify  %d:%d:%d:%d:%d:%s"),
        m_chatModel.GetRoomID(), pTranslateFileInfo->m_vecReceiverIds.size(), 
        pTranslateFileInfo->m_TidRequestFileTranslate, pTranslateFileInfo->m_nFileSeq,
        (INT)fileInfo.fileSize, fileInfo.downloadUrl.c_str());

    do 
    {
        if (pJob->GetJobWaitType(0) == ftwtStop)
        {
            bUserStop = TRUE;
            break;
        }

        nTryCount--;
        //pTranslateFileInfo->m_TidRequestFileTranslate= m_chatModel.GetChatMsgTid();

        bRet = InitChatRoom();
        if( !bRet)
        {
            NTALK_LOG->Debug(TEXT("[CHAT] SendFileNotify InitChatRoom Fail"));
            continue;
        }

        bRet = InviteChatUser();
        if (!bRet)
        {
            NTALK_LOG->Debug(TEXT("[CHAT] SendFileNotify InviteChatUser Fail"));
            continue;
        }

        if (pJob->GetJobWaitType(0) == ftwtStop)
        {
            //InitChatRoom and InviteChatUser will spend lots of time, so add check again here again
            bUserStop = TRUE;
            break;
        }

        CTime time(CTime::GetCurrentTime());
        GetLocaleTime(&time);
        pTranslateFileInfo->m_tmSendNotify = time;

        ASSERT(m_pNtalk);
        if (m_pNtalk)
        {
            bRet = m_pNtalk->RequestFileSend(pTranslateFileInfo->m_vecReceiverIds, fileInfo.fileName.c_str(),
                (UINT)fileInfo.fileSize,  fileInfo.downloadUrl.c_str(), pTranslateFileInfo->m_TidRequestFileTranslate, 
                pTranslateFileInfo->m_nFileSeq);
            if (!bRet)
            {
                NTALK_LOG->Debug(TEXT("[CHAT] RequestFileSend Fail"));
                continue;
            }
        }

        m_chatModel.AddMyTranslateTid(pTranslateFileInfo->m_TidRequestFileTranslate, pTranslateFileInfo);

    } while (!bRet && nTryCount > 0);

    if (bUserStop)
    {
        NTALK_LOG->Debug(TEXT("[CHAT] SendFileNotify  Canceled"));

        pTranslateFileInfo->SetResultByLastError(ERROR_CANCELLED);
        SQLITE3.UpdateMsgStatus(m_chatModel.GetRoomID(),m_chatModel.GetMyID(),pTranslateFileInfo->m_TidRequestFileTranslate,sUploadCancle);
        m_chatModel.UpdateMsgStatus(m_chatModel.GetMyID(),pTranslateFileInfo->m_TidRequestFileTranslate,sUploadCancle);

        return FALSE;
    }

    if (!bRet)
    {
        pTranslateFileInfo->SetResultByLastError(ERROR_LOST_WRITEBEHIND_DATA_NETWORK_SERVER_ERROR);
        SQLITE3.UpdateMsgStatus(m_chatModel.GetRoomID(),m_chatModel.GetMyID(),pTranslateFileInfo->m_TidRequestFileTranslate,sUploadError);
        m_chatModel.UpdateMsgStatus(m_chatModel.GetMyID(),pTranslateFileInfo->m_TidRequestFileTranslate,sUploadError);

        DisplayNetworkErrorMessage();
    }

	return bRet;
}

LRESULT CChatDlg::OnPopupTrayDlg(WPARAM wParam, LPARAM lParam)
{	
	if(!m_bOnceTrayPopup)
	{
		TRAYPOPUP_CHAT(TDT_USEAGE, m_chatModel.GetTrayPopupInfo(), this->wnd, WM_CLICKTRAY, 0);
		m_bOnceTrayPopup=TRUE;
	}
	return 0L;
}


LRESULT CChatDlg::OnChatMsgPopupTrayDlg(WPARAM wParam, LPARAM lParam)
{	
	if(!m_bOnceTrayPopup)
	{
		TRAYPOPUP_CHAT(TDT_IM_CHAT, m_chatModel.GetTrayPopupInfo(), this->wnd, WM_CLICKTRAY, 0);
		m_bOnceTrayPopup=TRUE;
	}
	return 0L;
}

LRESULT CChatDlg::OnClickTray(WPARAM wParam, LPARAM lParam)
{
	if (IsIconic())
	{
		::ShowWindow(m_hWnd, SW_SHOW);		
	}
	CalcCascade();
	BOOL bMax = IsZoomed();
	if (IsZoomed())
	{
		::ShowWindow(m_hWnd, SW_SHOWMAXIMIZED);
	}
	else
	{
		::ShowWindow(m_hWnd, SW_SHOWNOACTIVATE);
	}
	
	EnableWindow(TRUE);
	if(m_pEditChat && m_bPrepared)
	{
		m_PaintManager.SetFocus(NULL);
		m_PaintManager.SetFocus(m_pEditChat);
	}
	StopChatFlash();
	
	SetForegroundWindowForce(m_hWnd);

	return 0L;
}

LRESULT CChatDlg::OnStickerSelected(WPARAM wParam, LPARAM lParam)
{
	CStickerItem *pStickerItem = (CStickerItem*)wParam;
	if (!pStickerItem)
	{
		return 0;
	}

	CString strStickerID;
	strStickerID.Format(_T("%02d_%03d"),pStickerItem->GetGroupId(),pStickerItem->GetStickerId()); // format like:03:03_010
	//int recentSticker = pitem->m_gid * 1000 +  pitem->m_sid;
	SendChatMsg(DEF_CHAT_MSG_TYPE_STICKER, strStickerID);

	return 0L;
}

LRESULT CChatDlg::OnStickerDlgClosed(WPARAM wParam, LPARAM lParam)
{
//	CloseStickerDlg();
	return 0L;
}

LRESULT CChatDlg::OnFontDlgClosed(WPARAM wParam, LPARAM lParam)
{
	CHARFORMAT2 userCharacterFormat;
	if (wParam == IDOK)
	{		
		ZeroMemory(&userCharacterFormat, sizeof(CHARFORMAT2));  //lint !e1415
		//userCharacterFormat = m_chatModel.GetSendChatViewUserFont();

		m_pFontDlg->GetCharFormat(userCharacterFormat);
		m_chatModel.SetSendChatViewUserFont(&userCharacterFormat);

		GET_CONFIG()->SaveChatFont(&userCharacterFormat);
		if (m_pEditChat)
		{
		    userCharacterFormat.yHeight = 9*20;
			m_pEditChat->SetDefaultCharFormat(userCharacterFormat);
			//pEditChat->SetTextColor(userCharacterFormat.crTextColor);
			m_pEditChat->SetTextColor(0xFF000000);
		}		
	}

	//CloseFontDlg();

	return 0L;
}

BOOL CChatDlg::InviteChatUser()
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);
	BOOL result = TRUE;
	vector<wstring> vecUsers;	

	CSingleLock lock(&m_csInviteUserThd);
	lock.Lock();

	if (lock.IsLocked())
	{
		int nChatUser = m_chatModel.GetChatUserMapCount();

		for (int i = 0; i < nChatUser; i++)
		{
			CString strID = m_chatModel.GetChatUserID(i);
			if (strID.CompareNoCase(m_chatModel.GetMyID()) == 0)
				continue;
			
			if ((m_chatModel.IsInvitedUser(strID) == FALSE) && (m_chatModel.IsOfflineUser(strID) == FALSE))
			{
				if (m_chatModel.FindUserMap(strID) < 0)
				{
					AddChatUserToListCtrl(strID, m_chatModel.GetChatUserName(strID), m_chatModel.GetChatUserNickName(strID), 
						m_chatModel.GetChatUserStatus(strID), m_chatModel.GetChatUserExtensionTel(strID), m_chatModel.GetChatUserCellphone(strID), 
						m_chatModel.GetChatUserJobPos(strID), m_chatModel.GetChatUserJobDuty(strID), m_chatModel.GetChatUserDeptName(strID));
					ProcRegiFavoriteToPOI( strID );
				}

				vecUsers.push_back(strID.GetBuffer());
			}
		}

		ProcChatUserNickName();

		if (vecUsers.size() > 0)
		{
			//ProcRegiFavoriteToPOI();
			result = InviteUsers(vecUsers);
		}

		lock.Unlock();
	}

	return result;
}

BOOL CChatDlg::InviteUsers(vector<wstring> vecUser)
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);
    
    std::wostringstream os;
    std::copy(vecUser.begin(), vecUser.end(), std::ostream_iterator<const wstring, wchar_t>(os, L","));
    const std::wstring& strUsers = os.str();

    NTALK_LOG->Debug(L"[CHAT] Enter InviteUsers, %d:%d:%d:%s", 
        GetRoomID(), m_chatModel.IsGroupRoom(), (int)vecUser.size(), strUsers.c_str());

	if (vecUser.size() <= 0 || m_chatModel.GetRoomID() <= 0 || m_chatModel.GetSrvAddress().GetLength() <= 0)
	{
		NTALK_LOG->Debug(L"[CHAT] InviteUsers - INVALID_DATA");
		return FALSE;
	}

	vector<PINVITE_USER> vecInvites;
	vector<wstring>::const_iterator iter = vecUser.begin();

	m_vecSendMemoExUser.clear();
	
	for (; iter != vecUser.end(); ++iter)
	{
		NTALK_LOG->Debug(L"[CHAT] InviteUsers [%s] %d", iter->c_str(), GetRoomID());

		// m_vecSendMemoExUser에 지역변수를 넣을 경우 초대되는 부분에서 메모리가 해제되어 문제가 발생하므로 주의
		m_vecSendMemoExUser.push_back((*iter).c_str());

		CString strID = (*iter).c_str();
		CString strName, strNickname;
		//GTUserStatusType eUserStatusType = ustOFFLINE;

		// 초대하려는 대화상대를 찾는다.
		// 없으면 1:1중에 대화창을 떠난 상대
		int nIndex = m_chatModel.FindUserMap(strID);
		if (nIndex >= 0)
		{
			strName = m_chatModel.GetChatUserName(strID);
			strNickname = m_chatModel.GetChatUserNickName(strID);
			//eUserStatusType = m_chatModel.GetChatUserStatus(strID);
		}
		else
		{
			ASSERT(FALSE);
		}

		PINVITE_USER pUser = NULL;	
		pUser = new INVITE_USER;

		if (NULL != pUser)
		{
			pUser->pszID = new TCHAR[strID.GetLength() + 1];
			if (NULL != pUser->pszID)
			{
				wcscpy_s(pUser->pszID, strID.GetLength()+1, strID.GetBuffer());
			}

			pUser->pszName = new TCHAR[strName.GetLength() + 1];		
			if (NULL != pUser->pszName)
			{
				wcscpy_s(pUser->pszName,  strName.GetLength()+1, strName.GetBuffer());
			}

			pUser->pszNickName = new TCHAR[strNickname.GetLength() + 1];
			if (NULL != pUser->pszNickName)
			{
				wcscpy_s(pUser->pszNickName, strNickname.GetLength()+1, strNickname.GetBuffer());
			}

			vecInvites.push_back(pUser);
		}
	}//lint !e429

	BOOL result = RequestRegisterChatUsers(vecInvites);
    NTALK_LOG->Debug(L"[CHAT] INVITE REGISTER %d", result);

	if (result == TRUE)
	{
		if (SendNotification() == FALSE)
		{
			vector<LPCTSTR> vecNotJoinUser = m_chatModel.GetNotJoinUserList();
			if (vecUser.size() == vecNotJoinUser.size())
			{
				result = FALSE;
			}
		}
		else
		{
			int retryCount = 0;
            int nSuccessUserCnt = 0;
            int nChatUserCnt = 0;
			while (1)
			{
				if (m_chatModel.IsGroupRoom())
				{
					result = FALSE;
                    nSuccessUserCnt = 0;
					nChatUserCnt = m_chatModel.GetChatUserMapCount();
					
					for (int i = 0; i < nChatUserCnt; i++)
					{
						CString strID = m_chatModel.GetChatUserID(i);
						
                        if (strID.IsEmpty() || m_chatModel.GetMyID().CompareNoCase(strID) == 0){
							continue;
                        }
                        GTUserStatusType userStatus = m_chatModel.GetChatUserStatus(strID);
                        BOOL isInvitedUser = m_chatModel.IsInvitedUser(strID);
						if (userStatus != ustMOBILE && isInvitedUser != TRUE)
						{
                            NTALK_LOG->Error(L"[CHAT] INVITE - 1:N FAIL(%s), %d:0x%x:%d", strID, 
                                retryCount, (int)userStatus, isInvitedUser);
							//break;
						}
                        else{
                            nSuccessUserCnt++;
                        }
					}
                    if (nSuccessUserCnt == nChatUserCnt)
                    {
						//all user success invited
                        result = TRUE;
                    }
				}
				else
				{
					result = FALSE;
					CString strID = m_chatModel.GetChatUserID(0);
					nChatUserCnt = 1;

					if (strID.IsEmpty())
						break;

					if (m_chatModel.GetMyID().CompareNoCase(strID) == 0)
						break;

					if (m_chatModel.GetChatUserStatus(strID) == ustMOBILE || m_chatModel.IsInvitedUser(strID) == TRUE)
					{
                        nSuccessUserCnt = 1;
						NTALK_LOG->Debug(_T("[CHAT] INVITE - 1:1 OK, %s"), strID);
						result = TRUE;
					}
				}

				if( result == TRUE )
                {
                    NTALK_LOG->Debug(_T("[CHAT] INVITE - 1:%s SUCCESS"), 
                        m_chatModel.IsGroupRoom() ? L"N" : L"1");
					break;
                }

				++retryCount;

				if (retryCount > RETRY_COUNT) 
				{
                    if (nSuccessUserCnt > 0)
                    {
						//invite some user success, so will return true to send them
                        result = TRUE;
                    }
                    else{
                        result = FALSE;
                    }

                    NTALK_LOG->Debug(_T("[CHAT] INVITE - 1:%s RETRY QUIT, %d/%d : %d"), 
                        m_chatModel.IsGroupRoom() ? L"N" : L"1", nSuccessUserCnt, nChatUserCnt, result);
					break;
				}

				Sleep(RETRY_SLEEP);
			}
		}
	}

	INVITE_USER* pItem = NULL;
	
	for (size_t j = 0; j < vecInvites.size(); j++)
	{
		pItem = vecInvites.at(j);

		if (!pItem)
			continue;

		if (pItem->pszID)
		{
			delete [] pItem->pszID; 
			pItem->pszID = NULL;
		}

		if (pItem->pszName)
		{
			delete [] pItem->pszName;
			pItem->pszName = NULL;
		}

		if (pItem->pszNickName) 
		{
			delete [] pItem->pszNickName; 
			pItem->pszNickName = NULL;
		}

		delete pItem; 
		pItem = NULL;
	}

	return result;
}

BOOL CChatDlg::RequestRegisterChatUsers(vector<PINVITE_USER> vecInvites)
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);	

	BOOL result = TRUE;

	m_chatModel.SetInviteListStatus(REGISTER_ONGOING);

	if (m_pNtalk)
		m_pNtalk->RegisterChatUsers(vecInvites);

	int nRetryCount = 0;

	while (true)
	{
		EInviteList register_status = m_chatModel.GetInviteListStatus();
		switch (register_status)
		{
		case REGISTER_SUCCESS:
			return TRUE;

		case REGISTER_ERROR:
			return FALSE;

		case REGISTER_ONGOING:
            {
                ++nRetryCount;

                if (nRetryCount > RETRY_COUNT) 
                {
                    m_chatModel.SetInviteListStatus(REGISTER_ERROR);
                    return FALSE;
                }
                Sleep(RETRY_SLEEP);
                break;
            }
        default:
            ASSERT(FALSE);
            return FALSE;
		}
	}

	return TRUE;    //lint !e527
}

BOOL CChatDlg::SendNotification()
{
	BOOL result = TRUE;
	CString strContents = _T("");

	// Contents format : creator id | creator name | creator nickname | roomid | srv address | srv port
	strContents.Format(_T("%s|%s|%s|%d|%s|%d|%d"), m_chatModel.GetMyID(), m_chatModel.GetMyName(), 
		m_chatModel.GetMyTalkName(), m_chatModel.GetRoomID(), 
		m_chatModel.GetSrvAddress(), m_chatModel.GetSrvPort(), m_chatModel.IsGroupRoom() ? CHATROOM_MULTITYPE : CHATROOM_SINGLETYPE);	

    NTALK_LOG->Debug(L"[CHAT] REQUEST SENDMEMOEX2(INVITE) [%s]", strContents);

	result = g_pMessengerActor->RequestSendMemoEx2(m_vecSendMemoExUser, strContents);

	return result;
}

bool CChatDlg::NegotiateChatSession()
{
    FUNCTION_BLOCK_TRACE(DEFAULT_BLOCK_TRACE_THRESHOLD);

	TRACE("%s %d\n", __FUNCTION__, __LINE__);

    bool bResult = true;
    bool bCreateNewRoom = false;
    do 
    {
        // 네트워크 에러로 로그아웃된 상태로 대화창만 활성화 되는 경우를 막기 위해
        // 로그인 상태인 경우만 대화 세션을 복구한다.
        if (GET_MESSENGER_DLG()->IsLogin())
        {
            if (!m_chatModel.IsValidServerInfo())
            {
                // 서버 정보가 없을 경우 CreateChatSessioin을 할 수 없다.
                // 우선 방 정보부터 가져오도록 하자.
                bCreateNewRoom = true;
                RequestNewRoom();
                //return false;
				bResult = false;
                break;
            }

            SetTimer(m_hWnd, TIMER_CHAT_CHECK_SESSIONSTATUS, INTERVAL_CHECK_SESSIONSTATUS, NULL);

            if (CreateChatSession() == -1)
            {		
                //return false;
				bResult = false;
                break;
            }
        }
	    bResult = true;
    } while (false);

    NTALK_LOG->Debug(L"[CHAT] NegotiateChatSession %d: %d:%d", m_chatModel.GetRoomID(), bResult, bCreateNewRoom);
	return bResult;
}

void CChatDlg::ReceiveChatMsg()
{
    //CRect z(0, 0, 0, 0);
	CHAT_MSG* pItem = NULL;

	while (m_chatModel.IsExistChatMessage())
	{
		pItem = m_chatModel.GetFrontChatMessage();

		if (!pItem)
		{
			m_chatModel.RemoveFrontChatMessage();
			continue;
		}

		/* 초대받은 대화방의 경우 초대시 바로 보여줄 경우 대화내용이 없는 빈 창이 뜬다.
		 * 그래서 대화창을 띄우고 참여대화 목록에 추가하는 동작은 대화 수신시 처리한다.
		 */
		AddChatToMainView(pItem);	// 대화창에 표시

		if (IsNeedMinimize(pItem->strID) == TRUE || IsWindowVisible(m_hWnd) != TRUE)
		{
			if (!IsWindowVisible(m_hWnd))
			{
				if (GET_MESSENGER_DLG()->GetMainFrame()->GetMyStatus() != ustBUSY)
				{
                    //if user status is busy, will not show the message dialog
					//when the chat dialog is created,it has been cascaded,needn't to cascaded again.
					//CalcCascade(); 
					::ShowWindow(m_hWnd, SW_SHOWMINNOACTIVE);
				}
			}

			if (GET_MESSENGER_DLG()->GetMainFrame() && NULL != GET_MESSENGER_DLG()->GetMainFrame()->GetSafeHwnd())
			{
				GET_MESSENGER_DLG()->GetMainFrame()->AddChatRoomList(this);
			}
		}
		
		EnableWindow(TRUE);
		
		
	     DisplayPopupAndFlashEffect(pItem, m_chatModel.GetMyID());

		

		if (pItem->msgType == DEF_CHAT_MSG_TYPE_STICKER)
		{
			m_strFileOrStickerMsg = LoadStringFromResource(IDS_STRING_RECEIVE_STICKER);
		}
		else if (pItem->msgType == DEF_FTP_MSG_TYPE)
		{
			m_strFileOrStickerMsg = LoadStringFromResource(IDS_STRING_RECEIVE_FILE);
		}
		m_creationTime = CTime::GetCurrentTime();
		GetLocaleTime(&m_creationTime);
		if(GET_MESSENGER_DLG()->GetMainFrame() != NULL)
		{
			GET_MESSENGER_DLG()->GetMainFrame()->UpdateChatRoomList(this, TRUE);
		}
		
		m_chatModel.RemoveFrontChatMessage();
	}
}

void CChatDlg::ReceiveChatFile(TranslateFileInfoPtr pTranslateFileInfo)
{
	if (IsNeedMinimize(pTranslateFileInfo->m_strSenderID) == TRUE || IsWindowVisible(m_hWnd) != TRUE)
	{
		if (!IsWindowVisible(m_hWnd))
		{
			if (GET_MESSENGER_DLG()->GetMainFrame()->GetMyStatus() != ustBUSY)
			{
				//CalcCascade();
				::ShowWindow(m_hWnd, SW_SHOWMINNOACTIVE);
			}
		}
		if (GET_MESSENGER_DLG()->GetMainFrame() && NULL != GET_MESSENGER_DLG()->GetMainFrame()->GetSafeHwnd())
		{
			GET_MESSENGER_DLG()->GetMainFrame()->AddChatRoomList(this);
		}
	}

	EnableWindow(TRUE);

	//AddChatToMainView(pItem);	// 대화창에 표시
  
	
	DisplayPopupAndFlashEffect(pTranslateFileInfo, m_chatModel.GetMyID());
	
}

void CChatDlg::OnBnClickedButtonFont()
{
	CHARFORMAT2 userCharacterFormat;
	ZeroMemory(&userCharacterFormat, sizeof(CHARFORMAT2));  //lint !e1775
	userCharacterFormat = m_chatModel.GetSendChatViewUserFont();

	if (m_pFontDlg != NULL){
		if(::IsWindow(m_pFontDlg->GetHWND()))
		     m_pFontDlg->OnClose();
		SAFE_DELETE(m_pFontDlg);
	}
	m_pFontDlg = new CNFontWnd(userCharacterFormat, this->wnd);

	if( m_pFontDlg == NULL ) {return; }
	CRect rcPos(0, 0, 0, 0);
	GetWindowRect(m_hWnd, &rcPos);    



	//m_pAddChatWnd->Create(pParent->GetSafeHwnd(), _T("AddChatWindow"), WS_POPUP, WS_EX_TOOLWINDOW, NULL);
	if (!m_pFontDlg->Create(GetSafeHwnd(), _T("CNFontWnd"), UI_WNDSTYLE_DIALOG, 0, 0, 0, 0, 0, NULL))
	{
		SAFE_DELETE(m_pFontDlg);
		return;
	}

  //  m_pFontDlg->SetClientRect(rcPos);
	SetWindowPosition(m_pFontDlg,wnd,  rcPos,340,222);
	
}

void CChatDlg::OnBnClickedButtonSticker()
{
	if (m_pStickerDlg)
	{
		m_pStickerDlg->Reset();

	}
	else
	{
		m_pStickerDlg = new CStickersWindow( m_hWnd);
		if (NULL != m_pStickerDlg)
		{
			if (!m_pStickerDlg->Create(GetSafeHwnd(), _T("CStickersWindow"), UI_WNDSTYLE_DIALOG, 0, 0, 0, 0, 0, NULL))
			{
				SAFE_DELETE(m_pStickerDlg);
				return;
			}
		}
	}

	CRect rcPos(0, 0, 0, 0);
	GetWindowRect(m_hWnd, &rcPos);
	SetWindowPosition(m_pStickerDlg,wnd,  rcPos,350,305);
	::ShowWindow(m_pStickerDlg->GetHWND(),SW_SHOW);


}

LRESULT CChatDlg::OnSysCommand(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	// 有时会在收到WM_NCDESTROY后收到wParam为SC_CLOSE的WM_SYSCOMMAND
	if(wParam == SC_CLOSE)
	{
		bHandled = TRUE;
		CheckCloseChatDialog();
		return 0;
	}


	LRESULT lResult = 0;
	bHandled = FALSE;
	int nCode = wParam & 0xFFF0;
	if (nCode == SC_MAXIMIZE || nCode == SC_RESTORE)
	{
		CControlUI* pBtnMax = static_cast<CControlUI*>(m_PaintManager.FindControl(_T("maxbtn")));
		CControlUI *pBtnRestore = static_cast<CControlUI*>(m_PaintManager.FindControl(_T("restorebtn")));
		CVerticalLayoutUI* pLeftWnd = static_cast<CChatLeftList*>(m_PaintManager.FindControl(_T("chat_list_bg")));
		CButtonUI* pSplitLine = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("split_line")));
		if (pBtnMax != NULL &&  pBtnRestore != NULL && pLeftWnd != NULL)
		{
			//int nCode = wParam & 0xFFF0;
			if(nCode == SC_MAXIMIZE) 
			{
				pBtnMax->SetVisible(false);
				pBtnRestore->SetVisible(true);
			}
			else if (nCode == SC_RESTORE)
			{
				if (::IsZoomed(m_hWnd))
				{
					pBtnMax->SetVisible(true);
					pBtnRestore->SetVisible(false);
				}
				else if (::IsIconic(m_hWnd))
				{
					WINDOWPLACEMENT wp = {0};
					wp.length= sizeof(wp);
					GetWindowPlacement(m_hWnd,&wp);
					if (wp.flags == WPF_RESTORETOMAXIMIZED)
					{
						pBtnMax->SetVisible(false);
						pBtnRestore->SetVisible(true);
						wp.showCmd = SW_SHOWMAXIMIZED;
						SetWindowPlacement(m_hWnd,&wp);

						bHandled = TRUE;
					}
					else
					{
						pBtnMax->SetVisible(true);
						pBtnRestore->SetVisible(false);
					}
				}
				else
				{
					pBtnMax->SetVisible(false);
					pBtnRestore->SetVisible(true);
				}

				if (pLeftWnd->IsVisible() != m_bRestoreLeftWindow)
				{
					bHandled = TRUE;
					ExpandWindow(!m_bRestoreLeftWindow);
					ShowChatList(!m_bRestoreLeftWindow);
				}
			}
		}
	}


	return lResult;
}

void CChatDlg::OnBnClickedButtonFile()
{
	DoChatSendFiles();
}


int CChatDlg::GetAllUserCount()
{
	return m_listChatUser.GetItemCount();
}

LRESULT CChatDlg::OnNcHitTest(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    POINT pt = {0}; 
    pt.x = GET_X_LPARAM(lParam);
	pt.y = GET_Y_LPARAM(lParam);
	::ScreenToClient(*this, &pt);

    RECT rcClient = { 0 };
	::GetClientRect(*this, &rcClient);

	if( !::IsZoomed(*this) )
	{
		RECT rcSizeBox = m_PaintManager.GetSizeBox();
		int width = rcSizeBox.right - rcSizeBox.left;
		rcSizeBox.right = rcSizeBox.left + width/2;
		if( pt.y < rcClient.top + rcSizeBox.top )
		{
			if( pt.x < rcClient.left + rcSizeBox.left ) 
				return HTTOPLEFT;
			if( pt.x > rcClient.right - rcSizeBox.right ) 
				return HTTOPRIGHT;
			return HTTOP;
		}
		else if( pt.y > rcClient.bottom - rcSizeBox.bottom )
		{
			if( pt.x < rcClient.left + rcSizeBox.left ) return HTBOTTOMLEFT;
			if( pt.x > rcClient.right - rcSizeBox.right ) return HTBOTTOMRIGHT;
			return HTBOTTOM;
		}

		if( pt.x < rcClient.left + rcSizeBox.left ) 
			return HTLEFT;
		if( pt.x > rcClient.right - rcSizeBox.right ) 
			return HTRIGHT;
	}

	RECT rcCaption = m_PaintManager.GetCaptionRect();	
	if( pt.x >= rcClient.left + rcCaption.left && pt.x < rcClient.right - rcCaption.right \
		&& pt.y >= rcCaption.top && pt.y < rcCaption.bottom ) {
			CControlUI* pControl = static_cast<CControlUI*>(m_PaintManager.FindControl(pt));
			if( pControl && _tcsicmp(pControl->GetClass(), _T("ButtonUI")) != 0 && 
				_tcsicmp(pControl->GetClass(), _T("OptionUI")) != 0 &&
				_tcsicmp(pControl->GetClass(), _T("EditUI")) != 0 &&
				_tcsicmp(pControl->GetClass(), _T("TextUI")) != 0 &&
				_tcsicmp(pControl->GetClass(), _T("SliderUI")) != 0 )
				return HTCAPTION;
	}

	return HTCLIENT;
}

BOOL m_bDragMoving = FALSE;

void CChatDlg::OnNotifyAlphaChange(TNotifyUI& msg)
{
    int sliderValue =(static_cast<CSliderUI*>(msg.pSender))->GetValue() ;
    int alphaValue = max(MIN_ALPHA_VALUE, sliderValue * 255 / 100);
    SetAlpha(alphaValue);
}

void CChatDlg::OnNotifySetCursor(TNotifyUI& msg)
{
    if (_tcsicmp(msg.pSender->GetName(), _T("split_line")) == 0)
    {
// 		if (IsZoomed())
// 		{
// 			::SetCursor(AfxGetApp()->LoadStandardCursor((LPCTSTR)IDC_ARROW));
// 		}
// 		else
// 		{
// 			::SetCursor(AfxGetApp()->LoadCursor(AFX_IDC_HSPLITBAR));
// 		}

		::SetCursor(AfxGetApp()->LoadStandardCursor((LPCTSTR)IDC_ARROW));
    }
}

//void CChatDlg::OnNotifyDragMoving(TNotifyUI& msg)
//{
//     if (_tcsicmp(msg.pSender->GetName(), _T("split_line")) == 0)
//     {
// 		//disable drag when window is zoomed.
// 		if (IsZoomed())
// 		{
// 			return;
// 		}
//         CButtonUI* pSplitLine = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("split_line")));
// 
//         if(NULL != pSplitLine)
//         {
//             m_bDragMoving = TRUE;
//             RECT rc = pSplitLine->GetPos();
//             rc.left = msg.ptMouse.x + 1;
// 
//             CRect rcClient(0, 0, 0, 0);
//             GetClientRect(m_hWnd, rcClient);
// 
//             if(rc.left > (EDGE_WIDTH + CHAT_LIST_MIN_WIDTH + SPLIT_LINE_WIDTH) && rc.left < rcClient.right - CHAT_CONTENT_MIN_WIDTH - EDGE_WIDTH)
//             {
//                 m_rtSplitter.left = rc.left;
//                 m_rtSplitter.right = m_rtSplitter.left;
//                 m_rtSplitter.top = rc.top;
//                 m_rtSplitter.bottom = rc.bottom;
// 
// 
//                 CVerticalLayoutUI* pLeftWnd = static_cast<CChatLeftList*>(m_PaintManager.FindControl(_T("chat_list_bg")));
// 
//                 if(NULL != pLeftWnd)
//                 {
//                     pLeftWnd->SetFixedWidth(rc.left - EDGE_WIDTH);
//                     m_PaintManager.SetMinInfo(CHAT_WINDOW_LEFTSHOW__MIN_WIDTH, CHAT_WIDOW_MIN_HEIGHT);
//                     m_bDragMoving = TRUE;
//                     ReSizeCtrl();
//                 }
//             }
//         }
//     }
//}

void CChatDlg::OnNotifyReturn(TNotifyUI& msg)
{
    if (_tcsicmp(msg.pSender->GetName(), kChatSearchEdit) == 0)
    {
        if (msg.wParam == WM_KEYDOWN)
        {
            OnSearchUser();
        }
    }
    else if (_tcsicmp(msg.pSender->GetName(), _T("edit_chat")) == 0)
    {
        CRichEditUI* pEditChat =  static_cast<CRichEditUI*>(msg.pSender);
        if (msg.wParam == WM_KEYDOWN)
        {
            if (GetKeyState(VK_SHIFT) < 0 || GetKeyState(VK_CONTROL) < 0)		//NTALKCL-713
            {
                pEditChat->ReplaceSel(_T("\r\n"), true);
            }
            else
            {
                SendChatMsg(DEF_CHAT_MSG_TYPE_CHAT);
            }
        }
        if(msg.wParam == WM_SYSKEYDOWN)
        {
            if (GetKeyState(VK_MENU) < 0 )		
            {
                pEditChat->ReplaceSel(_T("\r\n"), true);
            }
            else
            {
                SendChatMsg(DEF_CHAT_MSG_TYPE_CHAT);
            }
        }
    }
}

void CChatDlg::OnNotifySetFocus(TNotifyUI& msg)
{
    if (_tcsicmp(msg.pSender->GetName(), kChatSearchEdit) == 0)
    {
        m_strSearchWord = _T("");//msg.pSender->GetText();
        msg.pSender->SetText(m_strSearchWord);
    }
}
void CChatDlg::OnNotifyKillFocus(TNotifyUI& msg)
{
    if (_tcsicmp(msg.pSender->GetName(), kChatSearchEdit) == 0)
    {
        msg.pSender->SetVisible(false);
        CButtonUI* searchLabel = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSearchLabel));
        if (searchLabel != NULL)
        {
            searchLabel->SetVisible(true);
            if (msg.pSender->GetText().GetLength() == 0)
            {
                searchLabel->SetText(LoadStringFromResource(IDS_STRING_CHAT_DEFAULT_SEARCH));
                searchLabel->SetToolTip(LoadStringFromResource(IDS_STRING_CHAT_DEFAULT_SEARCH));
            }
            else
            {
                m_strSearchWord = msg.pSender->GetText();
                searchLabel->SetText(m_strSearchWord);
                searchLabel->SetToolTip(m_strSearchWord);
            }
        }
    }
    else if (_tcsicmp(msg.pSender->GetName(), _T("edit_chat")) == 0)
    {
        //CRichEditUI* pEditChat =  static_cast<CRichEditUI*>(m_PaintManager.FindControl(_T("edit_chat")));

        if (m_pEditChat != NULL)
        {
            m_pEditChat->ShowCaret(FALSE);
        }
    }
}

CRichEditUI * CChatDlg::GetChatEdit()
{
	return m_pEditChat;
}

void CChatDlg::OnNotifyClick(TNotifyUI& msg)
{
	if (_tcsicmp(msg.pSender->GetName(), _T("btn_pin")) == 0)
	{
		OnMenuTopMost();
	}
	else if (_tcsicmp(msg.pSender->GetName(), kCloseButtonControlName) == 0)
	{
		CheckCloseChatDialog();
	}
	else if (_tcsicmp(msg.pSender->GetName(), kMinButtonControlName) == 0)
	{
		if ((g_pProfileWnd != NULL) && (g_pProfileWnd->GetParentHwnd() == m_hWnd || (m_pChatSearchWnd != NULL && m_pChatSearchWnd->GetHWND() == g_pProfileWnd->GetParentHwnd())))
		{
			g_pProfileWnd->CloseProfileWnd();
		}
		SendMessage(WM_SYSCOMMAND, SC_MINIMIZE, 0);
	}
	else if (_tcsicmp(msg.pSender->GetName(), kMaxButtonControlName) == 0)
	{
		SendMessage(WM_SYSCOMMAND, SC_MAXIMIZE, 0);
	}
	else if (_tcsicmp(msg.pSender->GetName(), kRestoreButtonControlName) == 0)
	{
		SendMessage(WM_SYSCOMMAND, SC_RESTORE, 0);
	}
	else if (_tcsicmp(msg.pSender->GetName(), kAddGroupUserButtonControlName) == 0)
	{
		DoChatInvite();
	}
	else if (_tcsicmp(msg.pSender->GetName(), _T("btn_extend")) == 0)
	{
		CVerticalLayoutUI* pLeftWnd = static_cast<CChatLeftList*>(m_PaintManager.FindControl(_T("chat_list_bg")));
		if (pLeftWnd)
		{
			if (::IsZoomed(m_hWnd))
			{
				ShowChatList(!pLeftWnd->IsVisible());
			}
			else
			{
				ExpandWindow(!pLeftWnd->IsVisible());
				ShowChatList(!pLeftWnd->IsVisible());
			}
		}
	}
	else if (_tcsicmp(msg.pSender->GetName(), _T("btn_file")) == 0)
	{
		m_OnGoingAction = SENDACTION_FILE;
		OnBnClickedButtonFile();
		m_OnGoingAction = SENDACTION_NONE;

	}
	else if (_tcsicmp(msg.pSender->GetName(), _T("btn_sticker")) == 0)
	{
		OnBnClickedButtonSticker();
	}
	else if (_tcsicmp(msg.pSender->GetName(), _T("btn_text")) == 0)
	{
		OnBnClickedButtonFont();
	}
	else if (_tcsicmp(msg.pSender->GetName(), _T("menubtn")) == 0)
	{
		CRect rectbtnMenu(0, 0, 0, 0);
        POINT pt = {0};

		CButtonUI* pBtnMenu =  static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("menubtn")));
        if (pBtnMenu)
        {
			rectbtnMenu = pBtnMenu->GetPos();	
        } 
        else
        {
			rectbtnMenu.SetRectEmpty();
        }

		CRect rtDlg(0, 0, 0, 0);
		GetWindowRect(m_hWnd, &rtDlg);

		pt.x = rtDlg.left + rectbtnMenu.left;
		pt.y = rtDlg.top + rectbtnMenu.bottom;

		CMenu menu;
		CMenu* pPopup = NULL;
		menu.LoadMenu(IDR_MENU_CHAT);
		pPopup = menu.GetSubMenu(0);
		int nCmdID = 0;
        if (pPopup)
        {
			pPopup->CheckMenuItem(ID_CHAT_TOPMOST, m_bTopMost ? MF_CHECKED : MF_UNCHECKED);
			pPopup->EnableMenuItem(ID_CHAT_SEND_MEMO, /*IsReadOnlyStatus() ? MF_GRAYED :*/ MF_ENABLED);
			pPopup->EnableMenuItem(ID_CHAT_SEND_FILES, _IsReadOnlyStatus() ? MF_GRAYED : MF_ENABLED);
			pPopup->EnableMenuItem(ID_CHAT_INVITE, /*!m_btnChatInvite.IsWindowEnabled() ? MF_GRAYED :*/ MF_ENABLED);
			pPopup->EnableMenuItem(ID_CHAT_HISTORY, IsGroupRoom() ? MF_GRAYED : MF_ENABLED);

			nCmdID = pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, pt.x, pt.y, wnd);  //lint !e550
        }
		
	}
	else if (_tcsicmp(msg.pSender->GetName(), kSearchLabel) == 0)
	{
		msg.pSender->SetVisible(false);
		CEditUI* searchEdit = static_cast<CEditUI*>(m_PaintManager.FindControl(kChatSearchEdit));
		if (searchEdit != NULL)
		{
			m_strSearchWord = _T("");//msg.pSender->GetText();
			searchEdit->SetText(m_strSearchWord);
			searchEdit->SetVisible(true);
			searchEdit->SetFocus();
		}
	}
	else if (_tcsicmp(msg.pSender->GetName(), kSearchBtn) == 0)
	{
		OnSearchUser();
	}
	else if (_tcsicmp(msg.pSender->GetName(), kSearchCancel) == 0)
	{
		CloseChatSearchWnd(TRUE);
	}
}

//void CChatDlg::OnNotifyClickMenuTopMost(TNotifyUI& msg)
//{
//    OnMenuTopMost();
//}

void CChatDlg::OnNotifyItemClick(TNotifyUI& msg)
{
    CChatLeftList* pFriendsList = static_cast<CChatLeftList*>(m_PaintManager.FindControl(kChatList));
    if ((pFriendsList != NULL) &&  pFriendsList->GetItemIndex(msg.pSender) != -1)
    {
        if (_tcsicmp(msg.pSender->GetClass(), _T("ListContainerElementUI")) == 0)
        {
            Node* node = (Node*)msg.pSender->GetTag();
            if (msg.wParam == UIEVENT_RBUTTONUP)
            {
                if (!node->folder())
                {
                    CPoint point = msg.ptMouse;
                    ClientToScreen(m_hWnd, &point);
                    m_vecSelectItems.clear();
                    CRect rcItem = msg.pSender->GetPos();
                    rcItem.left = point.x;
                    rcItem.top = point.y;
                    rcItem.right = rcItem.left + rcItem.Width();
                    rcItem.bottom = rcItem.top + rcItem.Height();
                    list<Node*> listSelItem = pFriendsList->GetSelectedItems();
                    m_vecSelectItems.assign(listSelItem.begin(), listSelItem.end());
                    PopupMenuView(point, IDR_MEMU_COMMON_MENU, CHAT_POPUP_MENU);
                }

            }
        }
    }
}

void CChatDlg::PopupMenuView(CPoint pt, int nMain, int nSub)
{
	CMenu menuList;
	menuList.LoadMenu(nMain);

	MakeFavoriteMenu(&menuList, nSub);
	menuList.GetSubMenu(nSub)->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, pt.x, pt.y, CWnd::FromHandle(m_hWnd));

}

void CChatDlg::MakeFavoriteMenu(CMenu* menu, int nSub)
{
	const UINT favoriteMenuIndex = 7;
	// 榴败茫扁 弊缝 府胶飘(悼利栏肺 积己)
	CMenu menuFavoriteList;

	if (!menuFavoriteList.CreatePopupMenu())
		return;

	// 扁夯 皋春(榴败茫扁 府胶飘甫 嘿老 何葛 皋春)
	CMenu* pPopup = menu->GetSubMenu(nSub);

	if (!pPopup)
		return;

	int nSelectedCount = m_vecSelectItems.size();

	int i;
	int itemCnt =  pPopup->GetMenuItemCount();
	int deleteIndex = itemCnt - 1;
	for (i =0;i<itemCnt;i ++)
	{
		if (deleteIndex < 0)
		{
			break;
		}
		int id = pPopup->GetMenuItemID(deleteIndex);
		
		if( id != ID_MENU_KICK_USER){
		    pPopup->DeleteMenu(deleteIndex,MF_BYPOSITION);
           	deleteIndex = pPopup->GetMenuItemCount()-1;
		}
		else
			deleteIndex --;

	}

	if (m_listChatUser.GetItemCount() <= 1 || m_listChatUser.GetItemCount() == m_vecSelectItems.size())
	{
		pPopup->EnableMenuItem(ID_MENU_KICK_USER, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);		// 대화취소
	}

	m_GroupList.clear();

	size_t nGroupCount = g_pMessengerActor->GetBuddyGroupCount();
	int nAddableBuddyGroupCount = 0;

	int nMenuIndex = 0;

}

LRESULT CChatDlg::OnKeyDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	if(VK_ESCAPE == wParam)
	{
		if (m_pChatSearchWnd != NULL && IsWindowVisible(m_pChatSearchWnd->GetHWND()))
		{
			CloseChatSearchWnd(TRUE);
		}
		else
		{
			bHandled = TRUE;
			CheckCloseChatDialog();
		}

		return 0;
	}

	 if((wParam == 'F' || wParam == 'f') && GetKeyState(VK_CONTROL) < 0)
	 {
		CChatLeftList* pFriendsList = static_cast<CChatLeftList*>(m_PaintManager.FindControl(kChatList));
		ASSERT(pFriendsList);
		if(pFriendsList != NULL && pFriendsList->IsVisible())
		{
			CEditUI* searchEdit = static_cast<CEditUI*>(m_PaintManager.FindControl(kChatSearchEdit));
			CButtonUI* searchLabel = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSearchLabel));
			ASSERT(searchLabel);
			ASSERT(searchEdit);
			if(searchLabel != NULL && searchEdit != NULL)
			{
				searchLabel->SetVisible(false);
				searchEdit->SetVisible(true);
				searchEdit->SetFocus();
				bHandled = TRUE;
				return S_OK;
			}
		}
		
	 }
    TCHAR nChar = (TCHAR)wParam;
    //CRichEditUI* pEditChat =  static_cast<CRichEditUI*>(m_PaintManager.FindControl(_T("edit_chat")));
    if(m_pEditChat)
    {
        if (m_pEditChat->IsFocused())
        {
            if (GetKeyState(VK_CONTROL) < 0)
            {
                if (_T('r') == nChar || _T('R') == nChar ||	// Right alignment
                    _T('e') == nChar || _T('E') == nChar ||	// Center alignment
                    _T('j') == nChar || _T('J') == nChar)	// Justify alignment
                {
                    return 0;
                }
                // 					else if (_T('v') == nChar || _T('V') == nChar)
                // 					{
                // 						Paste();
                // 						return;
                // 					}

                if (GetKeyState(VK_SHIFT) < 0)
                {
                    if (_T('0') <= nChar && nChar <= _T('9'))
                    {
                        DWORD dwIndex = nChar - _T('0') + 10;
                        if (dwIndex < 0 || 20 <= dwIndex)
                            return 1;

                        std::vector<CString> &v = GET_CONFIG()->m_vecAutoText;
                        m_pEditChat->ReplaceSel(GET_CONFIG()->m_vecAutoText[dwIndex],true);
                        return 1;
                    }
                }
                else if (_T('0') <= nChar && nChar <= _T('9'))
                {
                    DWORD dwIndex = nChar - _T('0');
                    if (dwIndex < 0 || 20 <= dwIndex)
                        return 1;

                    m_pEditChat->ReplaceSel(GET_CONFIG()->m_vecAutoText[dwIndex],true);
                    return 1;
                }
            }
            // 				else if (nChar == VK_INSERT)
            // 				{
            // 					if (GetAsyncKeyState(VK_SHIFT) & 0x8000)
            // 					{
            // 						Paste();
            // 						return;
            // 					}
            // 				}
        }
    }
    if ((TCHAR)wParam == _T('M'))
    {
        if (GetKeyState(VK_CONTROL) < 0)
        {

        }
    }
    else if ((TCHAR)wParam == _T('B'))
    {
        if (GetKeyState(VK_CONTROL) < 0)
        {
            CHARFORMAT2 userCharacterFormat;
            ZeroMemory(&userCharacterFormat, sizeof(CHARFORMAT2));  //lint !e1415
            userCharacterFormat = m_chatModel.GetSendChatViewUserFont();
            userCharacterFormat.dwMask |= CFM_BOLD;
            userCharacterFormat.dwEffects ^= CFE_BOLD;
            m_chatModel.SetSendChatViewUserFont(&userCharacterFormat);
            GET_CONFIG()->SaveChatFont(&userCharacterFormat);

            //CRichEditUI* pEditChat =  static_cast<CRichEditUI*>(m_PaintManager.FindControl(_T("edit_chat")));
            userCharacterFormat.yHeight = 9* 20;
            if (m_pEditChat)
            {
                m_pEditChat->SetDefaultCharFormat(userCharacterFormat);
            }

            bHandled = TRUE;
            return TRUE;
        }
    }
    else if ((TCHAR)wParam == _T('U'))
    {
        if (GetKeyState(VK_CONTROL) < 0)
        {
            CHARFORMAT2 userCharacterFormat;
            ZeroMemory(&userCharacterFormat, sizeof(CHARFORMAT2));
            userCharacterFormat = m_chatModel.GetSendChatViewUserFont();
            userCharacterFormat.dwMask |= CFM_UNDERLINE;
            userCharacterFormat.dwEffects ^= CFE_UNDERLINE;
            m_chatModel.SetSendChatViewUserFont(&userCharacterFormat);
            GET_CONFIG()->SaveChatFont(&userCharacterFormat);

            //CRichEditUI* pEditChat =  static_cast<CRichEditUI*>(m_PaintManager.FindControl(_T("edit_chat")));
            userCharacterFormat.yHeight = 20*9;
            if (m_pEditChat)
            {
                m_pEditChat->SetDefaultCharFormat(userCharacterFormat);
            }

            bHandled = TRUE;
            return TRUE;
        }
    }
    else if ((TCHAR)wParam == _T('I'))
    {
        if (GetKeyState(VK_CONTROL) < 0)
        {
            CHARFORMAT2 userCharacterFormat;
            ZeroMemory(&userCharacterFormat, sizeof(CHARFORMAT2));  //lint !e1415
            userCharacterFormat = m_chatModel.GetSendChatViewUserFont();
            userCharacterFormat.dwMask |= CFM_ITALIC;
            userCharacterFormat.dwEffects ^= CFE_ITALIC;
            m_chatModel.SetSendChatViewUserFont(&userCharacterFormat);
            GET_CONFIG()->SaveChatFont(&userCharacterFormat);

            //CRichEditUI* pEditChat =  static_cast<CRichEditUI*>(m_PaintManager.FindControl(_T("edit_chat")));
            userCharacterFormat.yHeight = 20*9;

            if (m_pEditChat){
                m_pEditChat->SetDefaultCharFormat(userCharacterFormat);
            }
            bHandled = TRUE;
            return TRUE; 
        }
    }
    else if ((TCHAR)wParam == _T('D'))
    {
        if (GetKeyState(VK_CONTROL) < 0)
        {
            CHARFORMAT2 userCharacterFormat;
            ZeroMemory(&userCharacterFormat, sizeof(CHARFORMAT2));  //lint !e1415
            userCharacterFormat = m_chatModel.GetSendChatViewUserFont();
            userCharacterFormat.dwMask |= CFM_STRIKEOUT;
            userCharacterFormat.dwEffects ^= CFE_STRIKEOUT;
            m_chatModel.SetSendChatViewUserFont(&userCharacterFormat);
            GET_CONFIG()->SaveChatFont(&userCharacterFormat);

            //CRichEditUI* pEditChat =  static_cast<CRichEditUI*>(m_PaintManager.FindControl(_T("edit_chat")));
            userCharacterFormat.yHeight = 20*9;

            if (m_pEditChat){
                m_pEditChat->SetDefaultCharFormat(userCharacterFormat);
            }
            bHandled = TRUE;
            return TRUE;
        }
    }


	return WindowImplBase::OnKeyDown(uMsg, wParam, lParam, bHandled);
}
int CChatDlg::ShowChatList(bool bShow)
{
	CVerticalLayoutUI* pLeftWnd = static_cast<CChatLeftList*>(m_PaintManager.FindControl(_T("chat_list_bg")));
	CButtonUI* pSplitLine = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("split_line")));
	CButtonUI* pBtnExtend = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("btn_extend")));
	if (!pLeftWnd || !pSplitLine || !pBtnExtend)
	{
		return -1;
	}
	
	if (bShow)
	{
		int nWidth = pLeftWnd->GetFixedWidth() + pSplitLine->GetFixedWidth();
		m_rtSplitter.left = nWidth;
		m_rtSplitter.right = m_rtSplitter.left;
	}
	else
	{
		m_rtSplitter.left = EDGE_WIDTH;
		m_rtSplitter.right = m_rtSplitter.left;
	}

	pLeftWnd->SetVisible(bShow);
	pSplitLine->SetVisible(bShow);
	pBtnExtend->SetNormalImage(bShow?_T("btn_chat_extend_mini.png"):_T("btn_chat_extend_extend.png"));
	pBtnExtend->SetToolTip(bShow?LoadStringFromResource(IDS_STRING_CHAT_TOOLTIP_12):LoadStringFromResource(IDS_STRING_CHAT_TOOLTIP_1));

	ReSizeCtrl();

	if (!::IsZoomed(m_hWnd))
	{
		m_bRestoreLeftWindow = bShow;
	}	

	return 0;
}

int CChatDlg::ExpandWindow(bool bExpand,int nCmdShow)
{
	CVerticalLayoutUI* pLeftWnd = static_cast<CChatLeftList*>(m_PaintManager.FindControl(_T("chat_list_bg")));
	CButtonUI* pSplitLine = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("split_line")));
	CButtonUI* pBtnExtend = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("btn_extend")));
	if (!pLeftWnd || !pSplitLine || !pBtnExtend)
	{
		return -1;
	}

	int nMinWidth = 0;

	WINDOWPLACEMENT wp = {0};
	wp.length= sizeof(wp);
	GetWindowPlacement(m_hWnd,&wp);

	int nWidth = pLeftWnd->GetFixedWidth() + pSplitLine->GetFixedWidth();
	if (bExpand)
	{
		wp.rcNormalPosition.left -= nWidth;
		nMinWidth = CHAT_WINDOW_LEFTSHOW__MIN_WIDTH;
	}
	else
	{
		wp.rcNormalPosition.left += nWidth;
		nMinWidth = CHAT_WINDOW_LEFT_NOT_SHOW__MIN_WIDTH;
	}

	m_PaintManager.SetMinInfo(nMinWidth, CHAT_WIDOW_MIN_HEIGHT);

	wp.showCmd = nCmdShow;
	::SetWindowPlacement(m_hWnd,&wp);


	return 0;
}

LRESULT CChatDlg::OnMsgChatDlgSendFile(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    bHandled = TRUE;
    if ( SENDACTION_FILE ==m_OnGoingAction)
    {
        OnBnClickedButtonFile();
        m_OnGoingAction = SENDACTION_NONE;
    }
    return 0;   //old code is return 0;
}

//LRESULT CChatDlg::OnMsgChatEditKillFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
//{
//    //CRichEditUI* pEditChat =  static_cast<CRichEditUI*>(m_PaintManager.FindControl(_T("edit_chat")));
//    if (m_pEditChat != NULL && m_pEditChat->IsFocused())
//    {
//        //m_PaintManager.SetFocus(NULL, false);
//    }
//    return 0;
//}

//LRESULT CChatDlg::OnMsgChatEditFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
//{
//    //CRichEditUI* pEditChat =  static_cast<CRichEditUI*>(m_PaintManager.FindControl(_T("edit_chat")));
//    if (m_pEditChat != NULL)
//    {
//        //m_PaintManager.SetFocus(pEditChat);
//    }
//    return 0;
//}

LRESULT CChatDlg::OnMsgSysKeyDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    ASSERT(WM_SYSKEYDOWN == uMsg);
    if (VK_F4 == wParam)
    {
        bHandled = TRUE;
        CheckCloseChatDialog();
        return TRUE;
    }

    if(GetKeyState(VK_MENU) < 0)
    {
        if(wParam == 'I' || wParam == 'i')
        {
            DoChatInvite();
        }
    }

    return 0;
}

// LRESULT CChatDlg::OnMsgShowChatList(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
// {
// 	CButtonUI* pSplitLine = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("split_line")));
// 
// 	if (wParam == TRUE && !pSplitLine->IsVisible())
// 	{
// 		ExpandWindow(true);
// 		ShowChatList(true);
// 	}
// 	else if(wParam == FALSE && pSplitLine->IsVisible())
// 	{
// 		ExpandWindow(false);
// 		ShowChatList(false);
// 	}
//     return 0;
// }

LRESULT CChatDlg::OnMsgActivate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    // Modify by sevin for NTALKCL-811
//     if (m_pChatMainView && LOWORD(wParam) == WA_ACTIVE)
//     {
//         m_pChatMainView->ShowRecentMessage();
//     }

    UINT nState =(UINT)LOWORD(wParam);
    BOOL bMinimized = (BOOL)HIWORD(wParam);
    HWND hWndOther = (HWND)lParam;

    BOOL bStopFlash = FALSE;
    switch (nState)
    {
    case WA_INACTIVE:
        {
            //do nothing
            break;
        }
    case WA_ACTIVE:
        {
            if(m_pEditChat && m_bPrepared)
            {
                if(!m_pEditChat->IsFocused())
                {
                    m_PaintManager.SetFocus(m_pEditChat);
                }
            }
            bStopFlash = TRUE;
            break;
        }
    case WA_CLICKACTIVE:
        bStopFlash = TRUE;
        break;
    }

    if (bStopFlash)
    {
        StopChatFlash();
    }
    return 0;
}

LRESULT CChatDlg::OnSizing(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	CVerticalLayoutUI* pLeftWnd = static_cast<CChatLeftList*>(m_PaintManager.FindControl(_T("chat_list_bg")));
	if(pLeftWnd && pLeftWnd->IsVisible()) 
	{
		LPRECT lpRect = (LPRECT)lParam;
		int width = (lpRect->right - lpRect->left) - (CHAT_CONTENT_MIN_WIDTH + EDGE_WIDTH);
		if (width < pLeftWnd->GetFixedWidth())
		{	
			pLeftWnd->SetFixedWidth(width);
		}
	}
	return 0;
}

LRESULT CChatDlg::OnMsgKeyUp(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    ASSERT(WM_KEYUP == uMsg);
    if (_IsReadOnlyStatus() != TRUE)
    {
        DWORD dwCurTypingTicket = GetTickCount();
        if (!m_bBeforeStatusOfTyping
            || dwCurTypingTicket > m_dwLastSendTypingTicket + MIN_SEND_TYPEING_TIMEOUT
            || dwCurTypingTicket < m_dwLastSendTypingTicket) //overflow
        {
            //FTLTRACE(TEXT("CChatDlg::OnMsgKeyUp, will call RequestTyping, %d\n"), dwCurTypingTicket);
            RequestTyping(TRUE);
            m_dwLastSendTypingTicket = dwCurTypingTicket;
        }
        m_dwLastTypingTicket = dwCurTypingTicket;
    }
    return 0;
}

//LRESULT CChatDlg::OnMsgCommand(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
//{
 //   if (wParam == ID_CHAT_TOPMOST)
 //   {
 //       OnMenuTopMost();
 //   }
 //   else if (wParam == ID_CHAT_SEND_MEMO)
 //   {
 //       OnMenuSendMemo();
 //   }
 //   else if (wParam == ID_CHAT_SEND_FILES)
 //   {
 //       OnMenuSendFiles();
 //   }
 //   else if (wParam == ID_CHAT_INVITE)
 //   {
 //       OnMenuInvite();
 //   }
 //   else if (wParam == ID_CHAT_HISTORY)
 //   {
 //       OnMenuChatHistoryOnTopMenu();
 //   }
 //   else if (wParam == ID_MENU_USER_INFO)
 //   {
 //       CPoint pt(0, 0);
 //       GetCursorPos(&pt);
 //       //GET_MESSENGER_DLG()->GetProfileDlgController()->CreateProfileDlg(m_vecSelectItems[0]->data().value.GetData(), pt, GetSafeHwnd());
 //   }
 //   else if (wParam == ID_MENU_KICK_USER)
 //   {
 //       for (size_t i=0; i<m_vecSelectItems.size(); ++i)
 //       {
 //           CString strUserID = m_vecSelectItems[i]->data().value;
 //           if (m_chatModel.IsInvitedUser(strUserID) == FALSE && m_chatModel.GetChatUserStatus(strUserID) != ustMOBILE)
 //           {
 //               RemoveUser(strUserID);
 //               HideShowLeftList();
 //               RefreshTitle();
 //           }
 //           else
 //           {
 //               if (!m_pNtalk)
 //                   continue;

 //               m_pNtalk->RequestForceLeave(strUserID, m_chatModel.GetChatUserName(strUserID), m_chatModel.GetChatUserNickName(strUserID));

 //               ProcUregFavoriteFromPOI( strUserID.GetBuffer() );

 //               //모바일 사용자를 초대 하지 않은 상태면 퇴장 패킷을 보내고 리스트에서 직접 삭제도 해야함.
 //               if (m_chatModel.IsInvitedUser(strUserID) == FALSE && m_chatModel.GetChatUserStatus(strUserID) == ustMOBILE)
 //               {
 //                   RemoveUser(strUserID);
 //                   HideShowLeftList();
 //                   RefreshTitle();
 //               }
 //           }
 //       }
 //   }
 //   else if (wParam == ID_MENU_SEND_MEMO)
 //   {
 //       std::vector<ReceiverInfo> receiverVector;
 //       ReceiverInfo receiverInfo;
 //       for (size_t i=0; i<m_vecSelectItems.size(); ++i)
 //       {
 //           receiverInfo.strID = m_vecSelectItems[i]->data().value;
 //           receiverInfo.strName = m_vecSelectItems[i]->data().text_; 
 //           receiverVector.push_back(receiverInfo);
 //       }

 //       GET_APP()->m_pSendNoteManager->CreateReceiverInfoListNote(receiverVector);
 //   }
 //   else if (wParam == ID_MENU_TREE_SEND_MEMO)
 //   {
 //       NE_MEMBER_DATA_LIST DL;
 //       DL.nSize = 1;

 //       NE_MEMBER_DATA dlData;
 //       dlData.strName = m_vecSelectItems[0]->data().text_;
 //       CString strDL;
 //       strDL.Format(_T("or_%s"), m_vecSelectItems[0]->data().value);
 //       dlData.strUserId = strDL;
 //       DL.pList = &dlData;

 //       GET_MESSENGER_DLG()->GetWorkGroupController()->SendMemberListMemo(DL);
 //   }
 //   else if (wParam == ID_MENU_CHAT_HISTORY)
 //   {
 //       CString strID = m_vecSelectItems[0]->data().value;
 //       GET_MESSENGER_DLG()->OpenChatHistoryDlg(strID);
 //   }
 //   else if (wParam >= WM_USER_ID_LIST && wParam <= (WM_USER_ID_LIST + 1000))
 //   {
 //       int nID = (int)wParam;
 //       GROUP_MEMU_LIST::iterator iter = m_GroupList.find(nID);
 //       int nGroupID = iter->second;
 //       std::vector<wstring> vecBuddyId;

 //       for (size_t i=0; i<m_vecSelectItems.size(); ++i)
 //       {
 //           const NE_MEMBER_DATA data = GET_MESSENGER_DLG()->GetWorkGroupController()->m_pModel->GetMember(m_vecSelectItems[i]->data().value);
 //           vecBuddyId.push_back((LPCWSTR)m_vecSelectItems[i]->data().value.GetData()) ;
 //       }

 //       if (!vecBuddyId.empty())
 //       {
 //           GET_MESSENGER_DLG()->GetWorkGroupController()->AddFavoriteList(vecBuddyId, nGroupID);
 //       }
 //   }
 //   else if (wParam == ID_MENU_CHAT)
 //   {
 //       std::vector<NE_MEMBER_DATA> memberVector;
 //       for (size_t i=0; i<m_vecSelectItems.size(); ++i)
 //       {
 //           if (GET_MESSENGER_DLG()->GetWorkGroupController()->IsMyID(m_vecSelectItems[i]->data().value.GetData()) || m_vecSelectItems[i]->data().folder_)
 //           {
 //               continue;
 //           }
 //           GTUserStatusType userStatus = GET_MESSENGER_DLG()->GetWorkGroupController()->m_pModel->GetMemberStatus(m_vecSelectItems[i]->data().value);
 //           if (userStatus != ustOFFLINE)
 //           {
 //               const NE_MEMBER_DATA data = GET_MESSENGER_DLG()->GetWorkGroupController()->m_pModel->GetMember(m_vecSelectItems[i]->data().value);
 //               memberVector.push_back(data); 
 //           }
 //       }
 //       if (!memberVector.empty())
 //       {
 //           GET_APP()->m_pChatDialogManager->CreateMemberChat(memberVector);
 //       }
 //   }
 //   else if (wParam == ID_MENU_CREATE_FAVORITE_GROUP)
 //   {
 //       if(GET_MESSENGER_DLG()->GetMainFrame())
 //       {
 //           GET_MESSENGER_DLG()->GetMainFrame()->SetSelectItems(m_vecSelectItems);
 //           GET_MESSENGER_DLG()->GetMainFrame()->OnMnCreateFavoriteGroup();
 //       }
 //   }
//    else{
//	    bHandled = FALSE;
//    }
//    return 0;
//}

LRESULT CChatDlg::OnMsgChatFontDlgClosed(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    OnFontDlgClosed(wParam, lParam);
    return 0;
}

LRESULT CChatDlg::OnMsgPopupTrayDlg(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    OnPopupTrayDlg(wParam, lParam);
    return 0;
}

LRESULT CChatDlg::OnMsgClickTray(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    OnClickTray(wParam, lParam);
    return 0;
}

LRESULT CChatDlg::OnMsgChatMsgPopupTrayDlg(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    OnChatMsgPopupTrayDlg(wParam, lParam);
    return 0;
}

LRESULT CChatDlg::OnMsgChatStickerSelected(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    OnStickerSelected(wParam, lParam);
    return 0;    
}

LRESULT CChatDlg::OnMsgChatStickerDlgClosed(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	OnStickerDlgClosed(wParam, lParam);
    return 0;
}

LRESULT CChatDlg::OnMsgNotifyStatusPopup(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    OnListNotifyHover(wParam, lParam);
    return 0;
}

LRESULT CChatDlg::OnMsgAddUserChat(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    OnAddUserToChat(wParam, lParam);
    return 0;
}

LRESULT CChatDlg::OnDestroy(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    if (m_pInternetTransfer)
    {
        m_pInternetTransfer->Stop();
        delete m_pInternetTransfer;
        m_pInternetTransfer = NULL;
    }

    m_chatModel.RemoveAllChatMessage();
    m_chatModel.ClearChatItemAll();

    if (m_listChatUser.GetSafeHwnd())
    {
        m_listChatUser.ClearUserListItem();
        m_listChatUser.DestroyWindow();
    }

    if (m_pChatMainView->GetChatSafeHwnd())
    {
        m_pChatMainView->DestroyChatWindow();

        delete m_pChatMainView;
        m_pChatMainView = NULL;
    }

    if (m_wndChatStatus.GetSafeHwnd())	
        m_wndChatStatus.DestroyWindow();

    return WindowImplBase::OnDestroy(uMsg, wParam, lParam, bHandled);
}

LRESULT CChatDlg::OnMsgTimer(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    OnTimer(wParam,bHandled);
    return 0;
}

LRESULT CChatDlg::OnMsgClickMainView(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    CEditUI* searchEdit = static_cast<CEditUI*>(m_PaintManager.FindControl(kChatSearchEdit));
    CButtonUI* searchLabel = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSearchLabel));
    if (searchLabel != NULL && searchEdit != NULL)
    {
        searchEdit->SetVisible(false);
        searchLabel->SetVisible(true);
        if (searchEdit->GetText().GetLength() == 0)
        {
            searchLabel->SetText(LoadStringFromResource(IDS_STRING_CHAT_DEFAULT_SEARCH));
            searchLabel->SetToolTip(LoadStringFromResource(IDS_STRING_CHAT_DEFAULT_SEARCH));
        }
        else
        {
            m_strSearchWord = searchEdit->GetText();
            searchLabel->SetText(m_strSearchWord);
            searchLabel->SetToolTip(m_strSearchWord);
        }
    }
    CChatLeftList* pFriendsList = static_cast<CChatLeftList*>(m_PaintManager.FindControl(kChatList));
    if (pFriendsList)
    {
        pFriendsList->SetEnableScroll(FALSE);
    }

    return 0;
}

LRESULT CChatDlg::OnLButtonDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    CChatLeftList* pFriendsList = static_cast<CChatLeftList*>(m_PaintManager.FindControl(kChatList));
    if (pFriendsList)
    {
        POINT pt = { GET_X_LPARAM(lParam), GET_Y_LPARAM(lParam) };
        //::ScreenToClient(m_hWnd, &pt);
        CRect rcList = pFriendsList->GetPos();
        if (rcList.PtInRect(pt))
        {
            pFriendsList->SetEnableScroll(TRUE);
        }
        else
        {
            pFriendsList->SetEnableScroll(FALSE);
        }
    }
    return WindowImplBase::OnLButtonDown(uMsg, wParam, lParam, bHandled);
}

LRESULT CChatDlg::OnChar(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    if (wParam == VK_TAB && (GetKeyState(VK_CONTROL) < 0))		// for Ctrl+i in chat  NTALKCL-510
    {
        bHandled = TRUE;
        return TRUE;
    }
    return WindowImplBase::OnChar(uMsg, wParam, lParam, bHandled);
}

LRESULT CChatDlg::OnMsgCloseChatSearch(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	m_pChatSearchWnd = NULL;
	MainFrame* pFrame = GET_MESSENGER_DLG()->GetMainFrame();
	if (pFrame != NULL)
	{
		pFrame->SetCurChatSearchWnd(m_pChatSearchWnd);
	}
	if (m_pEditChat != NULL)
	{
		m_PaintManager.SetFocus(m_pEditChat);
	}
	return 0;
}

LRESULT CChatDlg::OnMsgCloseInviteWindow(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    //CRichEditUI* pEditChat =  static_cast<CRichEditUI*>(m_PaintManager.FindControl(_T("edit_chat")));
    if (m_pEditChat != NULL)
    {
        m_PaintManager.SetFocus(m_pEditChat);
    }
    return 0;
}

void CChatDlg::StopChatFlash()
{
	if(m_bFlashFlag)
	{
		GET_MESSENGER_DLG()->GetMainFrame()->UpdateUnReadMessage(FALSE, m_chatModel.GetRoomID());
		GET_MESSENGER_DLG()->GetMainFrame()->UpdateChatRoomList(this);
		wnd->FlashWindowEx(FLASHW_STOP, 0, 0);
		m_bFlashFlag = false;
	}
}

void CChatDlg::OnBnClickedButtonScrollLock()
{
	if (m_bScrollock)
	{
		m_bScrollock = false;
		m_pChatMainView->ScrollToLastchatItem();
		m_pChatMainView->UpdateView();
	}
	else
		m_bScrollock = true;
}

void CChatDlg::SetScrollLock(bool bLock)
{
	m_bScrollock = bLock;
}

int CChatDlg::CreateChatSession()
{
    NTALK_LOG->Debug(L"[CHAT] CREATECHATSESSION (ROOMID)%d:(EChatMakeType)%d", m_chatModel.GetRoomID(), (int)m_chatModel.GetChatRoomMakeType());

    TRACE("%s %d\n", __FUNCTION__, __LINE__);

	if (NULL == m_pNtalk)
	{
		m_pNtalk = CreateNTalkClient(this);
	}
		
	if (m_pNtalk)
	{
		m_chatModel.SetSessionCreateStatus(SESSION_ONGOING);		
	
		if (m_pNtalk->CreateChatSession(m_chatModel.GetSrvAddress(), m_chatModel.GetSrvPort(), 
										m_chatModel.GetRoomID(), m_chatModel.GetMyID(), 
										m_chatModel.GetMyName(), m_chatModel.GetMyTalkName(), 
										(m_chatModel.GetChatRoomMakeType() == MAKETYPE_CREATE ? TRUE : FALSE)) == FALSE)
		{
			NTALK_LOG->Debug(L"[CHAT] CREATECHATSESSION FAILED (ROOMID)%d:(EChatMakeType)%d", m_chatModel.GetRoomID(), (int)m_chatModel.GetChatRoomMakeType());

			return -1;		
		}
	}
	else
	{
		return -1;
	}	
	
	return 0;
}

BOOL CChatDlg::GetChatMsg(CString &strChatMsg)
{
	// Message Data
	strChatMsg.Empty();

	//CRichEditUI* pChatEdit = static_cast<CRichEditUI*>(m_PaintManager.FindControl(_T("edit_chat")));
    if (m_pEditChat) // m_pChatEdit)
    {
		strChatMsg = m_pEditChat->GetText();
    
		strChatMsg.Replace(_T("\r"), _T("\r\n"));
		// Message Length
		char* szSend = StringToChar(strChatMsg);
		if (szSend == NULL)
			return FALSE;

		int nLen = strlen(szSend);
		delete [] szSend; 
		szSend = NULL;

		if (nLen <= 0)
			return FALSE;

		if (nLen > 2000)
		{
			NMessageBox(this->wnd, LoadStringFromResource(IDS_STRING152));
			return FALSE;
		}

		m_pEditChat->SetText(_T(""));
    }
	return TRUE;
}

void CChatDlg::ResendChatMsg(UINT nMsgSeq, UINT nTid, CString strChatMsg, CHARFORMAT2 cf, BYTE msgType)
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);
	
	//m_pChatMainView->SetFailMsg(nTid, false);	// 전송 실패 상태를 초기화
	m_pChatMainView->ResetChatItem(nTid);

	// Draw My Message
	CTime time(CTime::GetCurrentTime());
	GetLocaleTime(&time);

	// Send Message Transaction ID
	m_chatModel.AddMyMessageTid(nTid, strChatMsg, time);

	// Push chat message to queue
	SEND_CHAT_MESSAGE *pChatMessage = new SEND_CHAT_MESSAGE;
	pChatMessage->strMsg = strChatMsg;
	pChatMessage->cfFontStyle = cf;
	pChatMessage->nTid = nTid;
	pChatMessage->nMsgSeq = nMsgSeq;
	pChatMessage->msgType = msgType;
	

    m_qChatMsg.Append(pChatMessage, INFINITE);
}//lint !e429


void   CChatDlg::SetLastFileOrStickerMsg(CChatItem* lastItem)
{
	CString strMyID = GetMyUserID();
	if (lastItem != NULL)
	{
		if (lastItem->GetChatItemInfo()->eMsgGB == CHAT_MSG_FTP )
		{
			if (!strMyID.Compare(lastItem->GetChatItemInfo()->strUserID))
			{
				m_strFileOrStickerMsg = LoadStringFromResource(IDS_STRING_SEND_FILE);
			}
			else{
				m_strFileOrStickerMsg = LoadStringFromResource(IDS_STRING_RECEIVE_FILE);
			}
		}
		else if (lastItem->GetChatItemInfo()->eMsgGB == CHAT_MSG_STICKER)
		{
			if (!strMyID.Compare(lastItem->GetChatItemInfo()->strUserID))
			{
				m_strFileOrStickerMsg = LoadStringFromResource(IDS_STRING_SEND_STICKER);
			}
			else{
				m_strFileOrStickerMsg = LoadStringFromResource(IDS_STRING_RECEIVE_STICKER);
			}

		}
	}


}


BOOL CChatDlg::SendChatMsg(BYTE msgType, CString strMsg)
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);

	// Get chat Message
	CString strChatMsg;
	CHARFORMAT2 cf = m_chatModel.GetSendChatViewUserFont();
	
	if (msgType == DEF_CHAT_MSG_TYPE_CHAT)
	{
		if (GetChatMsg(strChatMsg) == FALSE)
        {
			return FALSE;
        }
	}
	else
	{
		strChatMsg = strMsg;
	}

	// 내가 대화를 하면 스크롤 잠금을 풀어준다.
	if (IsScrollLocked())
		SetScrollLock(false);

	// Nick Name
	CString strUserNickName = g_pMessengerActor->GetTalkName();	
	if(m_pNtalk)
		m_pNtalk->SetNickname(strUserNickName);

	// Draw My Message
	CTime time(CTime::GetCurrentTime());
	GetLocaleTime(&time);

	// Send Message Transaction ID
	UINT nTid = m_chatModel.GetChatMsgTid();

    //NTALKCL-1119, add 30 second for ack check to avoid time out quickly, will reset by SetMyMessageTidSendTime when REAL send
    CTime tmForCheck = time + CTimeSpan(0, 0, 0, 30); 
	m_chatModel.AddMyMessageTid(nTid, strChatMsg, tmForCheck);

	ChatItemInfo stChatItemInfo;
	stChatItemInfo.strUserID = m_chatModel.GetMyID();
	stChatItemInfo.strUserName = m_chatModel.GetMyName();
	stChatItemInfo.strNameTalkName = strUserNickName;
	stChatItemInfo.cf = cf;
	stChatItemInfo.time = time;
	stChatItemInfo.nTid = nTid;
	stChatItemInfo.nMsgSeq = 0;
	stChatItemInfo.nUserCount = m_chatModel.GetUserCount();
	stChatItemInfo.eMsgGB = CHAT_MSG_CHAT;

	if (msgType == DEF_CHAT_MSG_TYPE_CHAT)
	{
		stChatItemInfo.strMsg = strChatMsg;
		m_strFileOrStickerMsg = _T("");
	}
	else 
	{
		stChatItemInfo.strMsg = strMsg;
		if (msgType == DEF_CHAT_MSG_TYPE_STICKER)
		{
			stChatItemInfo.eMsgGB = CHAT_MSG_STICKER;
			m_strFileOrStickerMsg = LoadStringFromResource(IDS_STRING_SEND_STICKER);
		}
		else if (msgType == DEF_FTP_MSG_TYPE)
		{
			m_strFileOrStickerMsg = LoadStringFromResource(IDS_STRING_SEND_FILE);
		}
	}

	m_pChatMainView->AddChatItem(&stChatItemInfo, true);
	AddRecentContact();
	//m_pChatMainView->AddChatItem(m_chatModel.GetMyID(), m_chatModel.GetMyName(), strUserNickName, time, strChatMsg, cf, nTid, 0, msgType);

	// Push chat message to queue
	SEND_CHAT_MESSAGE *pChatMessage = new SEND_CHAT_MESSAGE;
	pChatMessage->strMsg = strChatMsg;
	pChatMessage->cfFontStyle = cf;
	pChatMessage->nTid = nTid;
	pChatMessage->nMsgSeq = 0;	// 신규 메시지의 Msg_seq는 0이다. (NtalkClient_OnAckSendMsg()에서 서버에서 발급해준 값으로 업데이트된다)
	pChatMessage->msgType = msgType;

    NTALK_LOG->Debug(L"[CHAT] SendChatMsg %d:%d:%d:%d:%s", 
        m_chatModel.GetRoomID(), pChatMessage->msgType, pChatMessage->nMsgSeq, pChatMessage->nTid, pChatMessage->strMsg);
    m_qChatMsg.Append(pChatMessage, INFINITE);

	m_creationTime = CTime::GetCurrentTime();
	GetLocaleTime(&m_creationTime);

	return TRUE;
 //pChatMessage already in m_qChatMsg
}//lint !e429

P_SEND_CHAT_MESSAGE CChatDlg::GetChatMsgFromQueue(BOOL* pbCheckStop)
{
	P_SEND_CHAT_MESSAGE pChatMsg = NULL;
    FTLThreadWaitType waitType = m_qChatMsg.Remove(pChatMsg, INFINITE);
    if (pbCheckStop && waitType != ftwtContinue)
    {
        *pbCheckStop = TRUE; //user stop
    }

    if (pChatMsg)
    {
        m_chatModel.SetMyMessageTidSendTime(pChatMsg->nTid);
    }
	return pChatMsg;
}

CChatItem* CChatDlg::GetLastMsgItem(BOOL bGetSearchlastMsg)
{
	CChatItem* pItem = NULL;
	CSingleLock l(m_chatModel.GetChatItemCS(), TRUE);
	int nCount = m_chatModel.GetChatItemCount();

	if (0 == nCount)
	{
		return pItem;
	}

	if (GET_MESSENGER_DLG()->GetMainFrame()->IsRecentChatSearchMode() && m_pSearchChatItem != NULL && bGetSearchlastMsg)
	{
		return m_pSearchChatItem;
	}

	for (int i = nCount - 1; i >= 0; i--)
	{
		CChatItem *pChItem = (CChatItem*)m_chatModel.GetChatItemArray()->GetAt(i);

		if (pChItem == NULL)
			continue;

		LPChatItemInfo pInfo = pChItem->GetChatItemInfo();
		if (pInfo->eMsgGB == CHAT_MSG_CHAT || pInfo->eMsgGB == CHAT_MSG_STICKER)
		{
			if (pChItem->GetMsgStatus() != CMS_FAIL)
			{
				pItem = pChItem;
				break;
			}
		}
		if (pInfo->eMsgGB == CHAT_MSG_FTP)
		{
			if (pChItem->GetMsgStatus() == sUploadSuccess || pChItem->GetMsgStatus() == sRecvWaiting
				|| pChItem->GetMsgStatus() == sReceiving || pChItem->GetMsgStatus() == sRecvSuccess
				|| pChItem->GetMsgStatus() == sRecvCancle)
			{
				pItem = pChItem;
				break;
			}
		}
	}

	return pItem;
}

CString CChatDlg::GetLastMsg(BOOL bGetSearchlastMsg)
{
	CString strLastMsg = _T("");
	CChatItem* pChatItem = GetLastMsgItem(bGetSearchlastMsg);
	SetLastFileOrStickerMsg(pChatItem);
	if (pChatItem != NULL)
	{
		if (pChatItem->GetChatItemInfo()->eMsgGB == CHAT_MSG_CHAT || pChatItem->GetChatItemInfo()->eMsgGB == CHAT_MSG_SYS)
		{
			strLastMsg = pChatItem->GetChatItemInfo()->strMsg;
		}
		else if ( pChatItem->GetChatItemInfo()->eMsgGB == CHAT_MSG_STICKER || pChatItem->GetChatItemInfo()->eMsgGB == CHAT_MSG_FTP)
		{
			strLastMsg = GetLastFileOrStickerMsg();
		}
	}
	else
	{
		strLastMsg = _T("");
	}
	return strLastMsg;
}

//void CChatDlg::RemoveChatMsgFromQueue()
//{
//	CSingleLock lock(&m_csSendMsg);
//	lock.Lock();
//	if( lock.IsLocked() )
//	{
//		if( m_qChatMsg.empty() != true )
//		{
//			P_SEND_CHAT_MESSAGE pChatMsg = m_qChatMsg.front();
//			delete pChatMsg;
//
//			m_qChatMsg.pop();
//		}
//		lock.Unlock();
//	}
//}

void CChatDlg::InitControls()
{
    ASSERT(FALSE); // check this is rubbish code, will delete it later

	wnd = CWnd::FromHandle(m_hWnd);

	m_pChatMainView = new CChatMainViewElementList(this);

	GET_APP()->SetWindowRegion(this->wnd);

	// 스티커 데이터 로드
// 	GET_CONFIG()->LoadStickerInfo(&m_vecAllSticker);
// 	GET_CONFIG()->LoadRecentUsedStickerInfo(&m_vecRecentSticker);
// 	for (DWORD i = 0; i < m_vecAllSticker.size(); i++)
// 	{
// 		CStickerItem* pItem = (CStickerItem*)m_vecAllSticker[i];
// 
// 		if (!pItem)
// 			continue;
// 
// 		pItem->m_img = new Image(pItem->m_strImgPath);
// 	}


	AssignDefaultFont();
	AssignMenuandIcon();
	__ResourceLoad(TRUE);	

	CreateChatMainView();
	RegisterWindowandCreateButtons();
	InitChatUserListCtrl();
	AssignChatEditCharformat();

	RegisterObserver();
	RequestNewRoom();

	m_pSendMsgThread = (CChatSendMsgThread*)AfxBeginThread(RUNTIME_CLASS(CChatSendMsgThread), THREAD_PRIORITY_NORMAL, 0, CREATE_SUSPENDED);
	m_pSendMsgThread->SetChatDlg(this);
	m_pSendMsgThread->ResumeThread();

    //423(lint)
    if (m_pInternetTransfer)
    {
        m_pInternetTransfer->Stop();
        delete m_pInternetTransfer;
        m_pInternetTransfer = NULL;
    }
	m_pInternetTransfer = new FTL::CFInternetTransfer();
	m_pInternetTransfer->Start( this, 0, 1, NTALK_CLIENT_AGENT);

	SetTimer(m_hWnd, TIMER_CHAT_SENDMSG_ACK, 3000, NULL);
	SetTimer(m_hWnd, TIMER_CHAT_CHECK_PING, INTERVAL_CHECK_PING, NULL);
	SetTimer(m_hWnd, TIMER_CHAT_CHECK_SENDFILE, 3000, NULL);


	AssignDropTarget();

	TCHAR szOpenDirInitPath[MAX_PATH] = {0};
	SHGetSpecialFolderPath(NULL, szOpenDirInitPath, CSIDL_MYDOCUMENTS , FALSE);
	m_strOpenDirInitPath = szOpenDirInitPath;

	//InitRichEditCtrl();
	SetLastPositionAndSize(this->wnd, _T("ChatDialog"));

	SetAlpha(255);
	m_nSlidePos = 100;

	ReSizeCtrl();


	//return TRUE;  // return TRUE unless you set the focus to a control
}

LRESULT CChatDlg::OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    FUNCTION_BLOCK_TRACE(DEFAULT_BLOCK_TRACE_THRESHOLD);

	WindowImplBase::OnCreate(uMsg, wParam, lParam, bHandled);

	wnd = CWnd::FromHandle(m_hWnd);

	m_pChatMainView = new CChatMainViewElementList(this);
	
	InitDuiControls();

	GET_APP()->SetWindowRegion(this->wnd);

	// 스티커 데이터 로드
//	GET_CONFIG()->LoadStickerInfo(&m_vecAllSticker);
//	GET_CONFIG()->LoadRecentUsedStickerInfo(&m_vecRecentSticker);
// 	for (DWORD i = 0; i < m_vecAllSticker.size(); i++)
// 	{
// 		CStickerItem* pItem = (CStickerItem*)m_vecAllSticker[i];
// 
// 		if (!pItem)
// 			continue;
// 
// 		pItem->m_img = new Image(pItem->m_strImgPath);
// 	}


	AssignDefaultFont();
	AssignMenuandIcon();
	__ResourceLoad(TRUE);	

	CreateChatMainView();
	RegisterWindowandCreateButtons();
	InitChatUserListCtrl();
	AssignChatEditCharformat();

	RegisterObserver();
	RequestNewRoom();

	m_pSendMsgThread = (CChatSendMsgThread*)AfxBeginThread(RUNTIME_CLASS(CChatSendMsgThread), THREAD_PRIORITY_NORMAL, 0, CREATE_SUSPENDED);
	m_pSendMsgThread->SetChatDlg(this);
	m_pSendMsgThread->ResumeThread();

	m_pInternetTransfer = new FTL::CFInternetTransfer();
	m_pInternetTransfer->Start( this, 0, 1, NTALK_CLIENT_AGENT);
	
	SetTimer(m_hWnd, TIMER_CHAT_SENDMSG_ACK, 3000, NULL);
	SetTimer(m_hWnd, TIMER_CHAT_CHECK_PING, INTERVAL_CHECK_PING, NULL);
	SetTimer(m_hWnd, TIMER_CHAT_CHECK_SENDFILE, 3000, NULL);
	
	AssignDropTarget();
	InitRichEditCtrl();

	TCHAR szOpenDirInitPath[MAX_PATH] = {0};
	SHGetSpecialFolderPath(NULL, szOpenDirInitPath, CSIDL_MYDOCUMENTS , FALSE);
	m_strOpenDirInitPath = szOpenDirInitPath;

	//InitRichEditCtrl();
	SetLastPositionAndSize(this->wnd, _T("ChatDialog"));

	CSliderUI* pSilder = static_cast<CSliderUI*>(m_PaintManager.FindControl(_T("opacityBar")));
	if( pSilder ) {
		pSilder->SetValue(100);
	}
	SetAlpha(255);
	m_nSlidePos = 100;


	 m_PaintManager.AddFont(GetDefaultFontFaceName(),DEFAULT_TYPESTATUS_FONTSIZE,false,false,false);
	 m_PaintManager.AddFont(GetDefaultFontFaceName(),DEFAULT_EDITCHAT_FONTSIZE,false,false,false);

	ReSizeCtrl();
	return TRUE;  // return TRUE unless you set the focus to a control
}

void CChatDlg::InitDuiControls()
{
	CButtonUI* pBtnExtend = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("btn_extend")));
	pBtnExtend->SetKeyboardEnabled(FALSE);
    //find control and store as member variable
    m_pEditChat = static_cast<CRichEditUI*>(m_PaintManager.FindControl(_T("edit_chat")));
    ASSERT(m_pEditChat);

    m_pBtnFile =  static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("btn_file")));
    m_pBtnSticker =  static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("btn_sticker")));
    m_pBtnText =  static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("btn_text")));

    m_pBtnSearch =  static_cast<CButtonUI*>(m_PaintManager.FindControl(kSearchBtn));
    ASSERT(m_pBtnFile && m_pBtnSticker && m_pBtnText && m_pBtnSearch);

    m_pBtnAddUser =  static_cast<CButtonUI*>(m_PaintManager.FindControl(kAddGroupUserButtonControlName));
    ASSERT(m_pBtnAddUser);

    m_pBtnMin = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("minbtn")));
    m_pBtnMax = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("maxbtn")));
    m_pBtnClose = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("closebtn")));
    m_pBtnRestore = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("restorebtn")));
    ASSERT(m_pBtnMin && m_pBtnMax && m_pBtnClose && m_pBtnRestore);

    m_pBtnPin = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("btn_pin")));
    m_pSliderOpacity = static_cast<CSliderUI*>(m_PaintManager.FindControl(_T("opacityBar")));
    ASSERT(m_pBtnPin && m_pSliderOpacity);

    m_pSearchEdit = static_cast<CEditUI*>(m_PaintManager.FindControl(kChatSearchEdit));
    m_pSearchLabel = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSearchLabel));
    ASSERT(m_pSearchEdit && m_pSearchLabel);

    m_pChatNumLabel = static_cast<CLabelUI*>(m_PaintManager.FindControl(_T("chat_num")));
    ASSERT(m_pChatNumLabel);
}

BOOL CChatDlg::IsDuplicateUser(LPCTSTR strUserID)
{
	BOOL result = FALSE;

	CSingleLock lock(m_listChatUser.GetLockObject(), TRUE);
	int nCount = m_listChatUser.GetItemCount();

	CChatUserList::_chat_user_info* pChInfo = NULL;
	for (int i = 0 ; i < nCount ; i++)
	{
		pChInfo = (CChatUserList::_chat_user_info*)m_listChatUser.GetItemData(i);
		if (!pChInfo)
			continue;

		if (pChInfo->strUserID.CompareNoCase(strUserID) == 0)
		{
			result = TRUE;
			break;
		}
	}

	return result;
}

void CChatDlg::ProcRegiFavoriteToPOI()
{
	vector<wstring> vecUsers;
	vecUsers.clear();

	int nUsers = m_chatModel.GetChatUserMapCount();
	for(int i = 0; i < nUsers; i++)
	{
		vecUsers.push_back((LPCTSTR)m_chatModel.GetChatUserID(i));
	}

	if(vecUsers.size() > 0)
		ProcRegiFavoriteToPOI(vecUsers);
}

void CChatDlg::ProcRegiFavoriteToPOI(CString strUser)
{
	if( strUser.IsEmpty() )
		return;

	vector<wstring> vecUsers;
	vecUsers.push_back((LPCTSTR)strUser);

	if(vecUsers.size() > 0)
		ProcRegiFavoriteToPOI(vecUsers);
}

void CChatDlg::ProcRegiFavoriteToPOI(vector<wstring> vecUsers)
{
	if(vecUsers.size() > 0)
	{
		int nGroupID = m_chatModel.GetChatTrid().GetID();		
		g_pMessengerActor->RequestRegiFavoriteToPOI(vecUsers, nGroupID + REGPOIGROUP_CHATDLG);
	}
}

void CChatDlg::ProcUregFavoriteFromPOI()
{
	int nGroupID = m_chatModel.GetChatTrid().GetID();
	g_pMessengerActor->RequestUregFavoriteFromPOI(nGroupID + REGPOIGROUP_CHATDLG);
}

void CChatDlg::ProcUregFavoriteFromPOI(wstring strUser)
{
	vector<wstring> vecUsers;
	vecUsers.push_back(strUser);
	ProcUregFavoriteFromPOI(vecUsers);
}

void CChatDlg::ProcUregFavoriteFromPOI(vector<wstring> &vecUsers)
{
	int nGroupID = m_chatModel.GetChatTrid().GetID();
	g_pMessengerActor->RequestUregFavoriteFromPOI(vecUsers, nGroupID + REGPOIGROUP_CHATDLG);
}

void CChatDlg::RequestChatUserInfo()
{
	CString strID, strIDs(_T(""));
	int nUsers = m_chatModel.GetChatUserMapCount();

	for (int i = 0; i < nUsers; i++)
	{
		strID = m_chatModel.GetChatUserID(i);

		// 사용자 정보를 비즈니스로직 서버에 요청하여 가져온다.
		if (!m_chatModel.IsUserInfoLoaded(strID))
		{
			if (strIDs.IsEmpty() == FALSE)
				strIDs.Append(_T("|"));

			strIDs.Append(strID);
		}
	}

	if (strIDs.IsEmpty() == FALSE)
	{
		trid_t trid;
		if (g_pMessengerActor->GetWASActor()->RequestEmplyeeInfo(strIDs, GetLanguageStringUnicode(), reitSingleTrans, &trid) == true)
		{
			m_tridListGetEmployeeInfo.push_back(trid);
		}
		else
		{
			// 이미 RequestEmplyeeInfo가 실행되고 있는 경우 실패할 수 있다.
			// 그럴 경우는 타이머에서 재 실행한다.
			SetTimer(m_hWnd, TIMER_CHAT_REQUEST_EMP_INFO, INTERVAL_WAS_REQUEST, NULL);
		}
	}
}

void CChatDlg::ProcChatUserNickName()
{
	CString strNickName, strID, strIDs(_T(""));

	int nUsers = m_chatModel.GetChatUserMapCount();
	for(int i = 0; i < nUsers; i++)
	{
		strID = m_chatModel.GetChatUserID(i);
		strNickName = m_chatModel.GetChatUserNickName(strID);
		if(strNickName.IsEmpty() == TRUE)
		{
			if(strIDs.IsEmpty() == FALSE)
				strIDs.Append(_T("|"));

			strIDs.Append(strID);
		}
	}

	if(strIDs.IsEmpty() == FALSE)
	{		
		g_pMessengerActor->GetWASActor()->RequestGetTalkName(strIDs);
	}
}

void CChatDlg::ChangeNickNameChatUserList(LPCTSTR strUserID, LPCTSTR strNickName)
{
	if (m_chatModel.ChangeNickName(strUserID, strNickName) == TRUE)
	{
		// 상단의 리스트컨트롤 갱신
		CSingleLock lock(m_listChatUser.GetLockObject(), TRUE);
		int nCount = m_listChatUser.GetItemCount();

		CChatUserList::_chat_user_info* pChInfo = NULL;
		for (int i = 0; i < nCount; i++)
		{
			pChInfo = (CChatUserList::_chat_user_info*)m_listChatUser.GetItemData(i);
			if (!pChInfo)
				continue;

			if (pChInfo->strUserID.CompareNoCase(strUserID) == 0)
			{
				pChInfo->strUserNickName = strNickName;
				//m_listChatUser.Update(i);
			}
		}
	}	
}

void CChatDlg::ChangeNickNameChatUserList(const std::vector<NT_TALKNAME_DATA> listTalknameData)
{
	std::vector<NT_TALKNAME_DATA>::const_iterator user_iter = listTalknameData.begin();
	for(; user_iter != listTalknameData.end(); ++user_iter)
	{
		NT_TALKNAME_DATA sTalkNameData = *user_iter;		
		ChangeNickNameChatUserList(sTalkNameData.strUserID.c_str(), sTalkNameData.strUserNick.c_str());
	}
}

int CChatDlg::GetImageIndexFromStatus(GTUserStatusType eMyStatus)
{
	int nImage = 0;

	switch (eMyStatus)
	{
	case ustOFFLINE:					nImage = 0;		break;
	case ustONLINE:						nImage = 1;		break;
	case ustAWAY:
	case ustAUTOAWAY:					nImage = 2;		break;
	case ustBUSY:						nImage = 3;		break;
	case ustOUTSIDE:					nImage = 4;		break;
	case ustEAT:						nImage = 5;		break;
	case ustMEETING:					nImage = 6;		break;

	case ustOFFLINE  | ustMOBILE:		nImage = 7;		break;
	case ustONLINE	 | ustMOBILE:		nImage = 8;		break;
	case ustAWAY	 | ustMOBILE:
	case ustAUTOAWAY | ustMOBILE:		nImage = 9;		break;
	case ustBUSY	 | ustMOBILE:		nImage = 10;	break;
	case ustOUTSIDE  | ustMOBILE:		nImage = 11;	break;
	case ustEAT		 | ustMOBILE:		nImage = 12;	break;
	case ustMEETING  | ustMOBILE:		nImage = 13;	break;

	default:							nImage = 0;		break;
	}

	return nImage;
}

void CChatDlg::AddChatUserToListCtrl(CChatUser* pChatUser,bool bSync)
{
	if (!pChatUser)
		return;

	AddChatUserToListCtrl(pChatUser->GetID(), pChatUser->GetName(), pChatUser->GetNickName(), pChatUser->GetStatus(),
		pChatUser->GetExtensionTel(), pChatUser->GetCellphone(), pChatUser->GetJobPos(), pChatUser->GetJobDuty(), pChatUser->GetDeptName(),bSync);
}

void CChatDlg::OnFinalMessage(HWND hWnd)
{
	OutputDebugString(_T("void CChatDlg::OnFinalMessage(HWND hWnd)\n"));
	CChatLeftList* pFriendsList = static_cast<CChatLeftList*>(m_PaintManager.FindControl(kChatList));
	if (pFriendsList != NULL)
	{
		pFriendsList->RemoveAll();
	}

	m_DT.Revoke();
	if (m_pInternetTransfer)
	{
		m_pInternetTransfer->Stop();
		delete m_pInternetTransfer;
		m_pInternetTransfer = NULL;
	}

	m_ilStatus.DeleteImageList();
	m_ilIPTStatus.DeleteImageList();

	// 대화 전송 쓰레드 종료 시까지 대기
	if( m_pSendMsgThread != NULL )
	{
        m_qChatMsg.Stop();
		m_pSendMsgThread->CloseThread(FALSE);
        m_pSendMsgThread->PostThreadMessage(WM_QUIT, 0, 0);

		if(WaitForSingleObject(m_pSendMsgThread->m_hThread, 3000) == WAIT_TIMEOUT)
		{
			// 타임아웃까지 종료되지 않으면 강제종료
			m_pSendMsgThread->SuspendThread();
			m_pSendMsgThread->ExitInstance();
		}
		else  
		{
			// 자동종료되어 객체가 자동 삭제된다. 
			// 자동삭제를 방지하려면 m_pSendMsgThread->m_bAutoDelete = FALSE 로 설정하면
			// 객체를 삭제되지 않고 남아있다.
			// 현재 쓰레드의 상태를 알기 위해서는 ::GetExitCodeThread( m_pSendMsgThread, &dwExitCode ); 를 사용하면 된다.
		}
		m_pSendMsgThread = NULL;

        //delete unsend message
        P_SEND_CHAT_MESSAGE pSendChatMessage = NULL;
        while (m_qChatMsg.RemoveAfterStop(pSendChatMessage))
        {
            delete pSendChatMessage;
        }
	}

	// 초대 쓰레드 종료 시까지 대기
	for (std::list<HANDLE>::iterator iter = m_hInviteThreadList.begin(); iter != m_hInviteThreadList.end(); iter++)
	{
		HANDLE hInviteThread = (HANDLE)*iter;
		if (hInviteThread != NULL)
		{
			WaitForSingleObject(hInviteThread, INFINITE); 
			CloseHandle(hInviteThread);
		}
	}
	m_hInviteThreadList.clear();

//	CloseStickerDlg();
	if (m_pFontDlg != NULL){
		if(::IsWindow(m_pFontDlg->GetHWND()))
			m_pFontDlg->OnClose();
		SAFE_DELETE(m_pFontDlg);
		m_pFontDlg = NULL;
	}

	if (m_pStickerDlg != NULL)
	{
		if(::IsWindow(m_pStickerDlg->GetHWND()))
			m_pStickerDlg->Close();
		delete m_pStickerDlg;
		m_pStickerDlg = NULL;
	}
	if (m_pChatSearchWnd != NULL && ::IsWindow(m_pChatSearchWnd->GetHWND()))
	{
		::DestroyWindow(m_pChatSearchWnd->GetHWND());
	}

	delete this;
}

void	CChatDlg::SetRestoreLeftWindow(bool bRestore)
{
	m_bRestoreLeftWindow = bRestore;
}



void CChatDlg::AddChatUserToListCtrl(CString strID, CString strName, CString strNickName, GTUserStatusType onlineStatus, CString strExtensionTel, CString strCellphone, CString strJobPos, CString strJobDuty, CString strDeptName, bool bSync)
{
	if (m_chatModel.GetMyID().CompareNoCase(strID) == 0)
		return;

	if (IsDuplicateUser(strID))
		return;

	CChatUserList::_chat_user_info* pUserData = new CChatUserList::_chat_user_info;	

	if (!pUserData)
		return;

	pUserData->strUserID = strID;
	pUserData->strUserName = strName;
	pUserData->strUserNickName = strNickName;
	pUserData->strExtensionTel = strExtensionTel;
	pUserData->strCellphone = strCellphone;
	pUserData->strJobPos = strJobPos;
	pUserData->strJobDuty = strJobDuty;
	pUserData->strUserDepart = strDeptName;
	pUserData->eUserStatus = onlineStatus;

	CSingleLock lock(m_listChatUser.GetLockObject(), TRUE);
	int nCount = m_listChatUser.GetItemCount();

	LVITEM lvItem;
	lvItem.mask = LVIF_IMAGE;
	lvItem.iItem = nCount;
	lvItem.iSubItem = UL_COLUMN_STATUS;
	lvItem.iImage = GetImageIndexFromStatus(onlineStatus);

	m_listChatUser.InsertItem(&lvItem);
	
	m_listChatUser.SetItemText(nCount, UL_COLUMN_NAME, strName);	// Custom draw를 할 것이기때문에 일단 이름을 넣어준다.
	m_listChatUser.SetItemText(nCount, UL_COLUMN_IPT, _T("")); 		// IPT 컬럼은 pUserData->eIPTStatus 값으로 그려줄 것이다.
	m_listChatUser.SetItemData(nCount, (DWORD_PTR)pUserData);

	CChatLeftList* pFriendsList = static_cast<CChatLeftList*>(m_PaintManager.FindControl(kChatList));
	if (pFriendsList != NULL)
	{
		//const IGTBuddyUser* pUser = g_pMessengerActor->GetBuddyInfo(strID);
		ChatListItemInfo item;
	
		item.id = strID;
		item.nick_name = strName;
        item.status = onlineStatus;
		CString strImg=_T("");
	
		if(GET_MESSENGER_DLG()->GetMainFrame())
		{
			strImg = GET_MESSENGER_DLG()->GetMainFrame()->GetImageFromStatus(onlineStatus);
		}
       
		item.logo = strImg;	
		Node* pUserNode = pFriendsList->AddNode(item, NULL);
		pFriendsList->Invalidate();
	}

	if(bSync)
	{
        HideShowLeftList();
	}
    RefreshTitle();
	RequestChatUserInfo();
}

bool CChatDlg::OnGTWASActor_ResponseGetEmployeeInfo(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, 
													const NE_MEMBER_DATA_LIST &list, NTRequestEmpInfoType reqEmpInfoType, int nGroupID)
{
	// 내가 보낸 trid 가 아니면 true를 리턴하여 보낸 곳에서 처리하도록 해준다.
	std::list<trid_t>::iterator findTrid = std::find(m_tridListGetEmployeeInfo.begin(), m_tridListGetEmployeeInfo.end(), trid);
	if (findTrid == m_tridListGetEmployeeInfo.end())
		return true;

	m_tridListGetEmployeeInfo.remove(*findTrid);

	if (eErrorCode != wasError_None)
	{
		// WAS 에러가 발생한 경우 타이머에서 재시도한다.
		// 직원정보를 가져오지 못할 경우 대화창의 직원정보칸이 비어서 나오는 문제가 있다.
		SetTimer(m_hWnd, TIMER_CHAT_REQUEST_EMP_INFO, INTERVAL_WAS_REQUEST, NULL);
		return false;
	}

	// ActiveX 에서 채팅창을 생성한 경우 사용자 ID만 가지고 채팅창을 생성하기 때문에 대화상대의 이름조차 나오지 않는다.
	// 그래서 신규로 이름을 가져온 경우 타이틀바를 업데이트 해주어야 한다.
	bool bRefreshTitle = false;

	for (size_t i = 0; i < list.nSize; i++) 
	{
		const NE_MEMBER_DATA &sMemberInfo  = list.pList[i];

		if (m_chatModel.GetMyID().CompareNoCase(sMemberInfo.strUserId.c_str()) == 0)
			continue;

		if (m_chatModel.IsUserInfoLoaded(sMemberInfo.strUserId.c_str()))
			continue;

		if (m_chatModel.SetChatUserInfo(&sMemberInfo) == FALSE)
			continue;
		CChatLeftList* pChatList = static_cast<CChatLeftList*>(m_PaintManager.FindControl(kChatList));
		if (pChatList != NULL)
		{
			pChatList->UpdateName(GetChatModel()->GetChatUsrPtr(sMemberInfo.strUserId.c_str()));
			pChatList->UpdateTooltip(GetChatModel()->GetChatUsrPtr(sMemberInfo.strUserId.c_str()));
		}

		// 상단의 리스트컨트롤 갱신
		CSingleLock lock(m_listChatUser.GetLockObject(), TRUE);

		int nCount = m_listChatUser.GetItemCount();
		CString strID = _T("");

		CChatUserList::_chat_user_info* pChInfo = NULL;
		for (int j = 0; j < nCount; j++)
		{
			pChInfo = (CChatUserList::_chat_user_info*)m_listChatUser.GetItemData(j);

			if (!pChInfo)
				continue;

			strID = pChInfo->strUserID;

			if (strID.CompareNoCase(sMemberInfo.strUserId.c_str()) == 0)
			{
				// 기 등록된 사용자의 이름과 지금 가져온 이름이 다르다면 타이틀을 갱신해준다.
				if (pChInfo->strUserName.CompareNoCase(sMemberInfo.strName.c_str()) != 0)
					bRefreshTitle = true;

				pChInfo->strUserName = sMemberInfo.strName.c_str();
				pChInfo->strUserNickName = sMemberInfo.strNickName.c_str();
				pChInfo->strUserDepart = sMemberInfo.strDept.c_str();
				pChInfo->strIncoTel = sMemberInfo.strIncoTel.c_str();		// 회사 전화
				pChInfo->strExtensionTel = sMemberInfo.strExtesion.c_str();	// 내선 번호
				pChInfo->strCellphone = sMemberInfo.strCellPhone.c_str();	// 휴대폰
				pChInfo->strJobPos = sMemberInfo.strJobPos.c_str();
				pChInfo->strJobDuty = sMemberInfo.strJobDuty.c_str();

				m_listChatUser.Update(j);

				break;
			}
		}
	}

	if (bRefreshTitle)
		RefreshTitle();

	return false;
}


void CChatDlg::SetUserJoinMsg( UINT nID, LPCTSTR strName, BOOL bJoin )
{
	CString strStatusMsg(_T(""));
	CString strUserName = _T(""), strUserNickName = _T("");
	
	AfxExtractSubString(strUserName, strName, 0, _T('|'));
	AfxExtractSubString(strUserNickName, strName, 1, _T('|'));

	ECHAT_MSG_TYPE eMsgType = bJoin? CHAT_MSG_JOIN : CHAT_MSG_LEAVE;
	if (m_pChatMainView->GetChatSafeHwnd())
	{
		CTime time(CTime::GetCurrentTime());
		GetLocaleTime(&time);
		ChatItemInfo stChatItemInfo(LoadStringFromResource(nID), time, m_cf, eMsgType);
		stChatItemInfo.strUserName = strUserName;
		m_pChatMainView->AddChatItem(&stChatItemInfo, true);
	}
}

void CChatDlg::SetChatSysMsg(UINT nID, LPCTSTR strName, LPCTSTR userid)
{
	CString strStatusMsg(_T(""));
	CString strUserName = _T(""), strUserNickName = _T("");
	
	/*if(userid != NULL)
	{
		if( m_chatModel.GetChatUserStatus(userid) == ustAWAY )
		AlertOfflineUser();
	}*/

	AfxExtractSubString(strUserName, strName, 0, _T('|'));
	AfxExtractSubString(strUserNickName, strName, 1, _T('|'));

	strStatusMsg.Format(_T("%s%s"), strUserName, LoadStringFromResource(nID));



	if (m_pChatMainView->GetChatSafeHwnd())
	{
		CTime time(CTime::GetCurrentTime());
		GetLocaleTime(&time);
		ChatItemInfo stChatItemInfo(strStatusMsg, time, m_cf);
		m_pChatMainView->AddChatItem(&stChatItemInfo, true);
		//m_pChatMainView->AddChatItem(_T(""), _T(""), _T(""), time, strStatusMsg, m_cf);
	}
}

BOOL CChatDlg::AddChatUserList(vector<CChatUser*> vecUser)
{	
	BOOL result = FALSE;

	const int nTotUserCount = m_chatModel.GetChatUserMapCount() + vecUser.size();
	

	if (vecUser.size() < 1)
	{
		NTALK_LOG->Debug(L"BOOL CChatDlg::AddChatUserList:(vector<CChatUser*> vecUser.size() == 0\n");
       return TRUE;
	}
	if (nTotUserCount > MAX_CHAT_USER)
	{
		NMessageBox(this->wnd, LoadStringFromResource(IDS_STRING144));
		return TRUE;
	}


	vector<wstring> vecInviteUser;

	// 한명이라도 리얼 조인이라면 추가되는 대상도 바로 초대한다. (대화창 초기에 계속 추가하는 경우가 있으므로 이를 체크함)
	BOOL bInviteNow = FALSE;

	for (int i = 0; i < m_chatModel.GetChatUserMapCount(); i++)
	{
		if (m_chatModel.IsInvitedUser(m_chatModel.GetChatUserID(i)))
		{
			bInviteNow = TRUE;
			break;
		}
	}

	// 초대 대상자를 목록에 넣는다.
	CChatUser* pUser = NULL;
	vector<CChatUser*>::iterator itr = vecUser.begin();

	for (; itr != vecUser.end(); itr++)
	{	
		pUser = *itr;

		if (!pUser)
		{
			continue;
		}

		if (m_chatModel.GetMyID().CompareNoCase(pUser->GetID()) == 0)
		{
			NMessageBox(this->wnd, LoadStringFromResource(IDS_STRING_NOT_ADD_SELF));
			if (m_pChatSearchWnd != NULL && ::IsWindow(m_pChatSearchWnd->GetHWND()))
			{
				SetFocus(m_pChatSearchWnd->GetHWND());
			}
			delete pUser;
			continue;
		}

		if (m_chatModel.FindUserMap(pUser->GetID()) < 0)
		{
			m_chatModel.AddChatUser(pUser);
			AddChatUserToListCtrl(pUser);
			vecInviteUser.push_back((LPCTSTR)pUser->GetID());
			if (m_chatModel.GetMyID().CompareNoCase(pUser->GetID()) == 0)
			{
				delete pUser;
			}
		}
		else
		{
			delete pUser;
		}
	}

	if(vecInviteUser.size() == 0)
	{
		NTALK_LOG->Debug(L"BOOL CChatDlg::AddChatUserList:(vecInviteUser.size() == 0\n");
		return TRUE;
	}
	ProcRegiFavoriteToPOI(vecInviteUser);
	ProcChatUserNickName();

	// 바로 초대할 대상이 있다면 초대
	if (bInviteNow && vecInviteUser.size() > 0)
	{
		HANDLE hInviteThread = (HANDLE)_beginthreadex(NULL, 0, InviteChatUserThd, (LPVOID)this, 0, NULL);
		m_hInviteThreadList.push_back(hInviteThread);
	}
	m_chatModel.SortChatUserVector();
	ResortChatListByName();
	result = TRUE;

	JudgeReadOnly();

	return result;
}

void CChatDlg::AlertOfflineUser( )
{
	CString strAlertMsg;
	strAlertMsg.LoadString(IDS_STRING650);
	//NMessageBox(this, strAlertMsg);
	CChatDlg *pChatDlg = this;
	CTime time(CTime::GetCurrentTime());
	GetLocaleTime(&time);
	pChatDlg->AddChatItem( TEXT(""), 
		TEXT(""), 
		TEXT(""),
		time, 
		strAlertMsg, 
		pChatDlg->GetDefaultChatFont(), 
		0, 
		0,
		0);


}




LRESULT CChatDlg::OnSize(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	WindowImplBase::OnSize(uMsg, wParam, lParam, bHandled);
	ReSizeCtrl();
    //RefreshTitle(false);
	CString strTitle = _GetChatDlgTitleStr(); 
	//[CN]  Onsize()关于title显示，其实只关心设定title width的问题。
	_DisplayChatNumInfo(strTitle);

	return 0;
}

//void CChatDlg::MoveSplitter()
//{
// 	ReSizeCtrl();
// 	RedrawWindow(m_hWnd, NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
//}

void CChatDlg::ReSizeCtrl(BOOL bReverse)
{
	if(IsIconic())
		return;

	CRect rcClient(0, 0, 0, 0);
	GetClientRect(m_hWnd, rcClient);


	CButtonUI* pSplitLine = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("split_line")));
	CVerticalLayoutUI* pLeftWnd = static_cast<CChatLeftList*>(m_PaintManager.FindControl(_T("chat_list_bg")));
	if(pSplitLine && pSplitLine->IsVisible()) // reduce left window width if neccessary
	{
		//if(rcClient.right - rcClient.left - EDGE_WIDTH * 2 - pLeftWnd->GetFixedWidth() - SPLIT_LINE_WIDTH < CHAT_CONTENT_MIN_WIDTH)
		{
			//pLeftWnd->SetFixedWidth(rcClient.right - rcClient.left - EDGE_WIDTH * 2 - CHAT_CONTENT_MIN_WIDTH - SPLIT_LINE_WIDTH);
			m_rtSplitter.left = EDGE_WIDTH + pLeftWnd->GetFixedWidth() + 1;
			m_rtSplitter.right = m_rtSplitter.left;
		}
	}
	
	m_rtSplitter.bottom = rcClient.bottom - CHAT_WINDOW_BOTTOM_HEIGHT;

	CButtonUI* pBtnFont =  static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("btn_text")));
	RECT rcFont={0};
	if (pBtnFont)
	{
		rcFont = pBtnFont->GetPos();
	} 


	CRect rtStatus(0, 0, 0, 0);

	if (m_wndChatStatus.GetSafeHwnd())
	{
		rtStatus.left = m_rtSplitter.right + SPLIT_STATUSWND_DIS_LEFT;
		rtStatus.right = rcClient.right - EDGE_WIDTH;
		rtStatus.bottom = rcFont.bottom;
		rtStatus.top = rcFont.top - FONTBTN_TO_STATUSWND_DIS_TOP;

		m_wndChatStatus.MoveWindow(rtStatus);
	}

	if(m_pChatSearchWnd != NULL && ::IsWindow(m_pChatSearchWnd->GetHWND()))
	{
		CRect rcSearch(0, 0, 0, 0);
		GetClientRect(m_pChatSearchWnd->GetHWND(), &rcSearch);
		m_pChatSearchWnd->SetChatSearchHeight(rcSearch.Height());
		CRect rcSearchClient(0, 0, 0, 0);
		GetClientRect(m_hWnd, &rcSearchClient);
		rcSearchClient.bottom -= 37;
        int nTmpTop = rcSearchClient.bottom - rcSearch.Height();
		rcSearchClient.top = max(nTmpTop, 221);
		rcSearchClient.left += 1;
		rcSearchClient.right = m_rtSplitter.left - 1;
		m_pChatSearchWnd->SetClientRect(rcSearchClient);
	}

	CRect rtChat(0, 0, 0, 0);
	if (m_pChatMainView && m_pChatMainView->GetChatSafeHwnd())
	{
		rtChat.left = m_rtSplitter.right;
		rtChat.right = rcClient.right - EDGE_WIDTH;
		rtChat.top = rcClient.top + CHAT_TITLE_HEIGHT;
		rtChat.bottom = rcClient.bottom - (CHAT_WINDOW_BOTTOM_HEIGHT + 68/*edit height*/ + 28/*tool bar height*/);
		if (m_bDragMoving)
		{
			rtChat.left += 1;
		}
		m_pChatMainView->MoveChatWindow(&rtChat);
	}

	RecalcTitleRect();
}


void CChatDlg::RecalcTitleRect()
{
	if (m_strTitle.IsEmpty())
		return;

	CRect rtClient(0, 0, 0, 0);
	GetClientRect(m_hWnd, &rtClient);

	// 사용자 이름 리스트의 영역 계산
	int nSX = rtClient.left + DEF_CHAT_TITLE_LEFT;
	int nSY = rtClient.top + DEF_CHAT_TITLE_TOP;

	CSize szUser(0, 0);
	REAL nUserFontHeight = m_nChatUserFontHeight;
	CRect rtUser(0, 0, 5000, DEF_CHAT_TITLE_BAR_HEIGHT);	// Width 를 충분히 큰 값으로 주어야 실제의 Width를 구할 수 있다.
	RecalcTextRect(this->wnd, m_strTitle, g_defaultFontFaceName, nUserFontHeight, FontStyleBold, rtUser, szUser);

	m_rtTitle.SetRect(nSX, nSY, nSX + rtClient.Width() - DEF_CHAT_TITLE_RIGHT, nSY + szUser.cy);
}

CRect CChatDlg::GetSlideBtnRect(const CRect& rtSlideBar, int nSlidePos)
{
	int nPosWidth = nSlidePos * SLIDEBAR_WIDTH / 100;
	Image* slide_btn = CFTImageMapInt::Instance()->GetImageByID(slide_bar_btn);
	
	CPoint pt = rtSlideBar.CenterPoint();
	pt.x = rtSlideBar.left + nPosWidth;
	CRect rtBtn(pt.x - slide_btn->GetWidth() / 2, pt.y - slide_btn->GetHeight() / 2, 
		pt.x + slide_btn->GetWidth() / 2, pt.y + slide_btn->GetHeight() / 2);
	return rtBtn;
}

//DT_END_ELLIPSIS  | DT_LEFT

SIZE CChatDlg::EstimateSize(SIZE szAvailable,CString m_sText,DWORD m_dwTextColor,DWORD m_uTextStyle)
{
	HDC hdc = GetDC(m_hWnd);
	RECT rcText = { 0, 0, szAvailable.cx, 9999 };
	bool m_bShowHtml = false;
	if( m_bShowHtml ) {   
		int nLinks = 0;
		CRenderEngine::DrawHtmlText(hdc,GetPaintManager() , rcText, m_sText, m_dwTextColor, NULL, NULL, nLinks, DT_CALCRECT | m_uTextStyle);
	}
	else {
		CRenderEngine::DrawText(hdc, GetPaintManager(), rcText, m_sText, m_dwTextColor, -1, DT_CALCRECT | m_uTextStyle);
	}
	ReleaseDC(m_hWnd,hdc);
	SIZE cXY = {rcText.right - rcText.left ,
		rcText.bottom - rcText.top};	
	return cXY;
}

int CChatDlg::GetChatContactCntExceptMe(){

	return m_listChatUser.GetItemCount();
}

void CChatDlg::HideShowLeftList()
{
	int nUserCount = m_listChatUser.GetItemCount(); 
	if(nUserCount == 0)
	{
		return;
	}

	CVerticalLayoutUI* pLeftWnd = static_cast<CChatLeftList*>(m_PaintManager.FindControl(_T("chat_list_bg")));
	if (!pLeftWnd)
	{
		return;
	}

	int nCmdShow = ::IsWindowVisible(m_hWnd)?SW_SHOWNOACTIVATE:SW_HIDE;

	if (nUserCount > 1)
	{
		if (!pLeftWnd->IsVisible())
		{
			if (!::IsZoomed(m_hWnd))
			{
				ExpandWindow(true,nCmdShow);
			}
			
			ShowChatList(true);
		}
	}
	else if(nUserCount == 1)
	{
		if (pLeftWnd->IsVisible())
		{
			if (!::IsZoomed(m_hWnd))
			{
				ExpandWindow(false,nCmdShow);
			}
			ShowChatList(false);
		}
	}
}

//set title string width.
void CChatDlg::_DisplayChatNumInfo(const CString& strTitle)
{
    BOOL bRet = FALSE;
    if (GetSafeHwnd())
    {
        CRect rc(0, 0, 0, 0);
        API_VERIFY(SetWindowText(m_hWnd, strTitle));
        API_VERIFY(GetWindowRect(m_hWnd,&rc));

        ASSERT(m_pChatNumLabel);
        if (m_pChatNumLabel)
        {
            //CLabelUI* pEditNum =  static_cast<CLabelUI*>(m_PaintManager.FindControl(_T("chat_num")));
            int LabelWidth = rc.Width() - 195;  //TODO:what's mean?, -5-5-16-4-6-144-5-10;
            m_pChatNumLabel->SetShowHtml(true);
            m_pChatNumLabel->SetText(strTitle);
            CSize szAvail(LabelWidth,20);

            CSize sz = EstimateSize(szAvail,strTitle,0xFFC8D1D8,DT_END_ELLIPSIS  | DT_LEFT);
            m_pChatNumLabel->SetTextColor(0xFFC8D1D8);
            m_pChatNumLabel->SetFixedWidth(sz.cx> LabelWidth ? LabelWidth:sz.cx);
        }
    }
}//lint !e550

CString CChatDlg::_GetChatDlgTitleStr() //Get current title string
{
	CString strTitle;
	CString strFirstName = _T("");

	int nUserCountExceptMe = 0;

	nUserCountExceptMe = m_listChatUser.GetItemCount() ; // count self
	CString 	strNameList = GetAllUserNameFromList();


	if(nUserCountExceptMe < 1)
	{
		strTitle =LoadStringFromResource(IDS_STRING_NO_CONTACT);
		return strTitle;
	}

	CChatUserList::_chat_user_info* pChInfo = NULL;
	pChInfo = (CChatUserList::_chat_user_info*)m_listChatUser.GetItemData(0);

	if (!pChInfo)
		return _T("");

	strFirstName = pChInfo->strUserName;

	ASSERT(m_pChatNumLabel);

	if (nUserCountExceptMe > 1) 
	{
		if (m_pChatNumLabel)
		{
			m_pChatNumLabel->SetFont(GetDefaultFontIndex());
		}

		CString userCntDisplay;
		if (!m_bForceLeave)
	    	userCntDisplay.Format(_T("%d"),nUserCountExceptMe + 1);
		else
			userCntDisplay.Format(_T("%d"),nUserCountExceptMe);
		strTitle = LoadStringFromResource(IDS_STRINGCHATTITLE1) + userCntDisplay 
			+ LoadStringFromResource(IDS_STRINGCHATTITLE2) ;


		strTitle += _T(" - ");
		strTitle += strNameList;
		if (!m_bForceLeave)
		{
			strTitle += _T(",");
			strTitle += m_chatModel.GetMyName();
		}
		
	} 
	else if (nUserCountExceptMe == 1)
	{	
		strTitle = strFirstName;	  
	}
	else{
		strTitle = _T("No contact");
	}
	
    return strTitle;
}
//RefreshTitle():Get current title. When chat users increase/decrease/resorted.聊天联系人增加/减少/顺序改变，都需要刷新title并更新chat room list.
void CChatDlg::RefreshTitle(bool bSync)
{
	
    //if(bSync)PostMessage(UM_SHOW_CHAT_LIST, TRUE);
	CString strTitle = _GetChatDlgTitleStr();

    _DisplayChatNumInfo(strTitle);

    if (NULL != GET_MESSENGER_DLG() && GET_MESSENGER_DLG()->GetMainFrame())
	{
		GET_MESSENGER_DLG()->GetMainFrame()->UpdateChatRoomList(this);
	}
}


void CChatDlg::SetInputStatusText(CString strStatus)
{
	CString strStatusText = strStatus;
	/*CSize szBound( 0, 0);
	CRect rcDraw(0, 0, 255, 28);*/
	REAL fontHeight = DEFAULT_TYPESTATUS_FONTSIZE;
	/*int trimLen = RecalcTextRect3(CWnd::FromHandle(m_hWnd), 
		strStatusText,
		g_defaultFontFaceName, fontHeight, 
		FontStyleRegular, rcDraw, szBound);

	CString trimStatusText = strStatusText.Left(strStatusText.GetLength() - trimLen);*/

	int index =  m_PaintManager.GetFontIndex(GetDefaultFontFaceName(),fontHeight,false,false,false);

	CLabelUI* pChatStatus =  static_cast<CLabelUI*>(m_PaintManager.FindControl(_T("label_chatstatus")));
	if (pChatStatus)
	{
		pChatStatus->SetTextColor(0x6b707e);

		pChatStatus->SetFont(index);
		pChatStatus->SetText(strStatusText);
	}
}

void CChatDlg::SetUserActionStatusText(NTalkTyping eState, LPCTSTR strName, LPCTSTR strUserID, int nOSType)
{
	CString strStatusMsg = _T("");
	CString strUserNames = _T("");

	CString strMyLangName = ConvertUserNameToMyLanguage(strUserID);

	if (strMyLangName.IsEmpty())
		strMyLangName = strName;

	if (nOSType == OS_PC)
	{
		strMyLangName += _T("(PC)");
	}
	else
	{
		strMyLangName += _T("(Mobile)");
	}

	if (eState == typeNonTyping)
	{
		m_chatModel.DelInputActionUser(strMyLangName);
	}
	else
	{
		m_chatModel.AddInputActionUser(strMyLangName);		
	}

	strUserNames = m_chatModel.GetInputActionUserString();
	 
	
	if (strUserNames.IsEmpty() == TRUE)
		strStatusMsg = _T("");
	else
	{
		strStatusMsg.Format(_T("%s %s"), strUserNames, LoadStringFromResource(IDS_STRING140));
	}
	
	
	SetInputStatusText(strStatusMsg);
}

/////////////////////////////////// NTalk Event ///////////////////////////////////
void CALLBACK CChatDlg::NtalkClient_OnCreateChatSession(INTalkClient* pNTClient, NTalkCreateChatType chatType, NTalkCreateSesionErrorCode eErrorCode)
{
	NTALK_LOG->Debug(L"[CHAT] OnCreateChatSession (RoomID)%d:(chatType)%d:(eErrorCode)%d", m_chatModel.GetRoomID(), chatType, eErrorCode);

	//CRichEditUI *pEditChat =  static_cast<CRichEditUI*>(m_PaintManager.FindControl(_T("edit_chat")));
	

	if (eErrorCode == createSessionError_None)
	{
		//JudgeReadOnly();
		SetInputStatusText(_T(""));

		m_chatModel.SetSessionCreateStatus(SESSION_SUCCESS);

		if(chatType == typeChatCreate)
		{
			int nCount = m_chatModel.GetChatUserMapCount();
			for(int i = 0; i < nCount; i++)
			{
				CString strID = m_chatModel.GetChatUserID(i);
				AddChatUserToListCtrl(strID, m_chatModel.GetChatUserName(strID), m_chatModel.GetChatUserNickName(strID), 
					m_chatModel.GetChatUserStatus(strID), m_chatModel.GetChatUserExtensionTel(strID), m_chatModel.GetChatUserCellphone(strID), 
					m_chatModel.GetChatUserJobPos(strID), m_chatModel.GetChatUserJobDuty(strID), m_chatModel.GetChatUserDeptName(strID));
				ProcRegiFavoriteToPOI( strID );
			}

			if( m_chatModel.IsGroupRoom() != TRUE )
			{
				HANDLE hInviteThread = (HANDLE)_beginthreadex(NULL, 0, InviteChatUserThd, (LPVOID)this, 0, NULL);
				m_hInviteThreadList.push_back(hInviteThread);
			}

			EnableWindow(TRUE);
			RequestChatUserInfo();
			::ShowWindow(m_hWnd, SW_SHOW); //TODO: want (SW_SHOW);  but will be SW_SHOWNORMAL
		}
		else if (chatType == typeChatJoin)
		{
			if (m_chatModel.GetChatRoomMakeType() != MAKETYPE_CREATE)
			{
				if (m_chatModel.IsOldRoomType() == FALSE)
				{
					if(m_pNtalk)
						m_pNtalk->RequestChatJoin();
/*
					if( m_chatModel.GetChatRoomMakeType() == MAKETYPE_JOIN )						 
						ShowWindow(SW_SHOW);
*/
				}
				else
				{		
					if(m_pNtalk)
						m_pNtalk->RequestForceChatReJoin();

					if(m_chatModel.GetChatRoomMakeType() != MAKETYPE_FORCEJOINED)
						::ShowWindow(m_hWnd, SW_SHOW);
				}
				
			}
			else
			{
				ASSERT(FALSE);
			}
			EnableWindow(TRUE);
		}

		//ProcRegiFavoriteToPOI();
	}
	else
	{
		//JudgeReadOnly();
		m_chatModel.SetSessionCreateStatus(SESSION_ERROR);

		if( eErrorCode == createSessionError_Connect )
		{
			DisplayErrorSessionMessage(::LoadStringFromResource(IDS_STRING162));
		}
		else if( eErrorCode == createSessionError_InitRoom )
			DisplayChatErrorMessage(::LoadStringFromResource(IDS_STRING161));
	}
	
}


void CALLBACK CChatDlg::NtalkClient_OnReceiveChatMsg(INTalkClient* pNTClient,
													 int roomid, 
													 LPCTSTR userid,
													 LPCTSTR nickname,	// '이름|대화명' 형식
													 int os_type, 
													 int time,
													 LPCTSTR pszMsg,
													 UINT msg_seq, 
													 CHARFORMAT2* pFont, 
													 UINT nTid, 
													 BYTE msgType) /* 대화내용 수신됨 */
{
	if (m_chatModel.GetRoomID() != roomid)
		return;
	
	if (m_chatModel.GetChatRoomMakeType() == MAKETYPE_FORCEJOINED)
		m_chatModel.SetInviteUserStatus(userid, TRUE);

	vector<CString> vecNames;
	CString strName(_T(""));
	CString strNickName(_T(""));

	SplitString_NotEmpty(nickname, _T('|'), vecNames);
	int size = vecNames.size();		
	strName = vecNames[0];
	strNickName = vecNames[1];

	if (m_chatModel.GetMyID().CompareNoCase(userid) != 0)	// 내 대화가 아닌 경우
	{
		// 대화상대 목록에는 없으나 대화가 수신된 경우 목록에 추가
		if (m_chatModel.FindUserMap(userid) < 0)
		{
			m_chatModel.AddChatUser(userid, strName, strNickName, ustONLINE, TRUE);
			AddChatUserToListCtrl(userid, strName, strNickName, ustONLINE);
			ProcRegiFavoriteToPOI(userid);
			RequestChatUserInfo();
		}

		ChangeNickNameChatUserList(userid, strNickName);

		m_chatModel.AddChatMessage(userid, strName, strNickName, time, pszMsg, pFont, msg_seq, nTid, msgType);

		if (m_pNtalk){
            INT nReason = 0;
			if(!m_pNtalk->RequestAckRecvMsg(msg_seq, nTid, nReason))
            {
                NTALK_LOG->Debug(L"[CHAT] RequestAckRecvMsg FAIL %d:%d:%d:%d", roomid, msg_seq, nTid, nReason);
            }
			//CTime CurTime(CTime::GetCurrentTime());
			//CString szTime = CurTime.Format("'%Y-%m-%d %H:%M:%S'");

#ifdef _DEBUG
            NTALK_LOG->Debug(L"[CHAT] ONRECEIVECHATMSG :roomid=%d:msg_seq=%d:nTid=%d:%s:%s", roomid, msg_seq, nTid, userid, pszMsg);
#else 
            NTALK_LOG->Debug(L"[CHAT] ONRECEIVECHATMSG :roomid=%d:msg_seq=%d:nTid=%d:%s", roomid, msg_seq, nTid, userid);
#endif
		}
	}
	else	// 내 대화인 경우
	{
		if (os_type == OS_MOBILE)
		{
			m_chatModel.AddChatMessage(userid, strName, strNickName, time, pszMsg, pFont, msg_seq, nTid, msgType);
			
			if (m_pNtalk)
            {
                INT nReason = 0;
				if(!m_pNtalk->RequestAckRecvMsg(msg_seq, nTid, nReason))
                {
                    NTALK_LOG->Debug(L"[CHAT] REQUESTACKRECVMSG Mobile FAIL %d:%d:%d:%d", roomid, msg_seq, nTid, nReason);
                }
            }
		}
	}		



	ReceiveChatMsg();
	SQLITE3.UpdateMsgStatus(roomid,userid,nTid,CMS_SUCCEED);
}

void CALLBACK CChatDlg::NtalkClient_OnReceiveFile(INTalkClient* pNTClient, 
												int roomid, 
												LPCTSTR userid, 
												LPCTSTR nickname, 
												int os_type,
												int time, 
												LPCTSTR pszFileName, 
												int nFileSize, 
												LPCTSTR pszURL, 
												UINT msg_seq, 
												UINT tid, 
												BYTE msgType)
{
	if (m_chatModel.GetRoomID() != roomid)
		return;

	FTLTRACE(TEXT("NtalkClient_OnReceiveFile, rootid=%d, userid=%s, pszFileName=%s, pszURL=%s\n"),
		roomid, userid, pszFileName, pszURL);

	if (m_chatModel.GetChatRoomMakeType() == MAKETYPE_FORCEJOINED)
	{
		m_chatModel.SetInviteUserStatus(userid, TRUE);
	}

	vector<CString> vecNames;
	CString strName(_T(""));
	CString strNickName(_T(""));

	SplitString_NotEmpty(nickname, _T('|'), vecNames);
	int size = vecNames.size();	
	if (vecNames.size() >= 2)
	{
		strName = vecNames[0];
		strNickName = vecNames[1];
	}

	if (-1 != m_chatModel.GetChatItemIndex(CString(userid),tid))
	{
		return;
	}

	TCHAR szSavePath[MAX_PATH] = {0};
	StringCchCopy(szSavePath, _countof(szSavePath), GET_CONFIG()->GetRecvFolder());
	// TEXT("C:\\HanaTour\\NTalk\\Download\\"));
	//GetTempPath(_countof(szLocalPath), szLocalPath);
	CreateDirectoryTree(szSavePath);
	::PathAppend(szSavePath, pszFileName);

	AttachFileInfo fileInfo;
	fileInfo.downloadUrl = pszURL;
	fileInfo.fileName = pszFileName;
	fileInfo.fileSize = nFileSize;
	fileInfo.flepath = szSavePath;
	TranslateFileInfoPtr pTranslateFileInfo(new TranslateFileInfo(fileInfo, FALSE));
	if(pTranslateFileInfo)
	{
		pTranslateFileInfo->m_strSenderID = userid;
		pTranslateFileInfo->m_nOsType = os_type;
		//pTranslateFileInfo->m_tmTime = time;
		pTranslateFileInfo->m_strName = strName;
		pTranslateFileInfo->m_strNickName = strNickName;
		pTranslateFileInfo->m_TidRequestFileTranslate = tid;
		CTime timeLocal(CTime::GetCurrentTime());
		GetLocaleTime(&timeLocal);
		pTranslateFileInfo->m_tmTime = timeLocal;
        pTranslateFileInfo->m_nFileSeq = msg_seq;

		//TODO: UINT msg_seq, UINT tid, BYTE msgType

		if(m_chatModel.GetMyID() == CString(userid))
		{
			SyncFileTranslateInfo(pTranslateFileInfo);
			ReceiveChatFile(pTranslateFileInfo);
			return;
		}

		if (m_chatModel.GetMyID().CompareNoCase(userid) != 0)
		{
			if (m_chatModel.FindUserMap(userid) < 0)
			{
				m_chatModel.AddChatUser(userid, strName, strNickName, ustONLINE, TRUE);
				AddChatUserToListCtrl(userid, strName, strNickName, ustONLINE);
				ProcRegiFavoriteToPOI(userid);

				RequestChatUserInfo();
			}
			ChangeNickNameChatUserList(userid, strNickName);
			
			MakeDownloadFileJob(pTranslateFileInfo,true);
			
			//m_chatModel.AddChatMessage(userid, strName, strNickName, time, pszMsg, pFont, msg_seq, nTid, msgType);

			if (m_pNtalk)
				m_pNtalk->RequestAckRecvFile(msg_seq, tid);
		}
		else
		{
			if (os_type == OS_MOBILE)
			{
				//m_chatModel.AddChatMessage(userid, strName, strNickName, time, pszMsg, pFont, msg_seq, nTid, msgType);
				MakeDownloadFileJob(pTranslateFileInfo,false);

				if (m_pNtalk)
					m_pNtalk->RequestAckRecvFile(msg_seq, tid);
			}
		}
	}


	//if (IsNeedMinimize(userid) == TRUE || IsWindowVisible() != TRUE)
	//{
	//	m_listenContainer->OnChatDlgChanged(this);

	//	if (m_pChatRoomListEvent)
	//	{
	//		m_pChatRoomListEvent->AddChatRoomList(m_chatModel.IsGroupRoom(), m_chatModel.GetRoomID(), m_chatModel.GetAllUserName(), GetCreationTime());
	//	}
	//}

	ReceiveChatFile(pTranslateFileInfo);
}

void CALLBACK CChatDlg::NtalkClient_OnReceiveTypingMsg(INTalkClient* pNTClient, int roomid, LPCTSTR userid, LPCTSTR nickname, int nOSType, NTalkTyping state) /* 상대방 내용 입력중 알림 */
{
	if (IsWindow(m_hWnd) == FALSE){
		 return;
	}
	if (m_chatModel.GetRoomID() != roomid){
		return;
	}


	vector<CString> vecNames;
	SplitString(nickname, _T('|'), vecNames);  
	SetUserActionStatusText(state, vecNames[0], userid, nOSType);
  //  if (state == typeTyping)
  //  {
		//SetTimer(m_hWnd, TIMER_CHAT_CLEAR_INPUTTING,3000,NULL);	
  //  }
}

void CALLBACK CChatDlg::NtalkClient_OnChatLeaveJoiner(INTalkClient* pNTClient, int roomid, 
													  LPCTSTR userid, LPCTSTR nickname, 
													  int os_type, int time,  UINT membercount) /* 대화방 나가기 알림 */
{
    if (m_chatModel.GetRoomID() != roomid)
		return;	

    FTLTRACEEX(tlTrace, TEXT("OnChatLeaveJoiner roomid=%d, userid=%s, os_type=%d, time=%d, membercount=%d\n"),
        roomid, userid, os_type, time, membercount);

    NTALK_LOG->Debug(L"[CHAT] ONCHATLEAVEJOINER %d:%s:membercount", roomid, userid, membercount);

    vector<CString> vecNames;
	SplitString(nickname, _T('|'), vecNames);
	
	if (m_chatModel.GetMyID().CompareNoCase(userid) == 0 && os_type == OS_MOBILE)
	{
		CloseChatDialog();
		return;
	}

	if (m_chatModel.IsGroupRoom())
	{
		CString strName = m_chatModel.GetChatUserName(userid);

		if (strName.IsEmpty() && vecNames.size() == 2)
			strName = vecNames[0];
		else if (strName.IsEmpty())
			strName = userid;

		//SetChatSysMsg(IDS_STRING145, strName, userid);
		SetUserJoinMsg(IDS_STRING145, strName, FALSE);

		RemoveUser(userid);
		ProcUregFavoriteFromPOI(userid);

		//if (m_chatModel.GetChatUserMapCount() == 0)
		//{
			JudgeReadOnly();
	//	}
        HideShowLeftList();
		RefreshTitle();
	}
	else
	{
		// 1:1 대화 중 대화방을 닫고 다시 그 대화상대를 더블클릭하여 열어둔 상태에서 상대가 방을 닫으면
		// 아래의 코드에 따라 내 방도 자동으로 닫히는 현상을 막기 위해 주석처리함. 2012.8.18.
// 		if (m_chatModel.GetChatItemCount() <= 0 && m_chatModel.GetChatRoomMakeType() != MAKETYPE_CREATE)
// 			PostMessage(WM_CLOSECHATDLG, 0, 0);
// 		else
			m_chatModel.SetInviteUserStatus(userid, FALSE);
			if(userid != NULL)
			{
				if( m_chatModel.GetChatUserStatus(userid) == ustAWAY )
					AlertOfflineUser();
			}

		return;
	}
}

/* 대화방 강제 퇴장 알림 */
void CALLBACK CChatDlg::NtalkClient_OnPushForceLeave(INTalkClient* pNTClient, int roomid, LPCTSTR userid)
{	
	TRACE("%s %d\n", __FUNCTION__, __LINE__);

	if (m_chatModel.GetRoomID() != roomid)
		return;

    NTALK_LOG->Debug(L"[CHAT] ONPUSHFORCELEAVE %d:%s", roomid, userid);

    int nCount = 0;
	{
		CSingleLock l(m_chatModel.GetChatItemCS(), TRUE);
		nCount = m_chatModel.GetChatItemCount();
	}

	if (nCount == 0)
	{
		CloseChatDialog();
		return;
	}

	if (m_chatModel.GetMyID().CompareNoCase(userid) == 0)
	{
        m_bForceLeave = TRUE;
		m_bTryRecoverySession = FALSE;
		RefreshTitle();
		KillTimer(m_hWnd, TIMER_CHAT_CHECK_SESSIONSTATUS);

		if (m_pNtalk)
		{
			m_pNtalk->RequestChatLeave();
			m_pNtalk->DestroyChatSession();
		}

		m_chatModel.SetSessionCreateStatus(SESSION_SUCCESS);
		DisplayChatErrorMessage(LoadStringFromResource(IDS_STRING325));

		ProcUregFavoriteFromPOI();
	}

    JudgeReadOnly();
}

void CALLBACK CChatDlg::NtalkClient_OnPushSessionClose(INTalkClient* pNTClient, int roomid)
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);
	if (m_chatModel.GetRoomID() != roomid)
		return;
    NTALK_LOG->Debug(L"[CHAT] ONPUSHSESSIONCLOSE %d", roomid);

	//CloseChatDialog();
	m_bTryRecoverySession = FALSE;
}

void CALLBACK CChatDlg::NtalkClient_OnChatJoin(INTalkClient* pNTClient, NTalkChatJoinErrorCode eErrorCode, int roomid, std::vector<PINVITE_USER>& vecUserList, int roomtype, UINT nJoinNum, UINT nLastMsgNum)
{
	if (roomid != m_chatModel.GetRoomID())
	{
		NTALK_LOG->Debug(L"[CHAT] ONCHATJOIN [%d] IS NOT THIS ROOMID", roomid);
		return;
	}

    FTLTRACEEX(tlTrace, TEXT("OnChatJoin eErrorCode=%d, roomid=%d, vecUserList=(%d),roomtype=%d, nJoinNum=%d, nLastMsgNum=%d\n"),
        eErrorCode, roomid, vecUserList.size(), roomtype, nJoinNum, nLastMsgNum);

    NTALK_LOG->Debug(L"[CHAT] ONCHATJOIN (NTalkChatJoinErrorCode)%d:(roomtype)%d:(roomid)%d:(nJoinNum)%d:(nLastMsgNum)%d", 
        eErrorCode, roomtype, roomid, nJoinNum, nLastMsgNum);

	//Modify by sevin for bts:NTALKCL-1137
	if (eErrorCode == chatJoinError_NoExist)
	{
		NTALK_LOG->Error(L"[CHAT] ONCHATJOIN ERROR CODE IS [%d]", eErrorCode);
        m_bTryRecoverySession = FALSE;
        NMessageBox(this->wnd, LoadStringFromResource(IDS_STR_CLOSE_NOTEXIST_CHAT));
		CloseChatDialog();
		return;
	}
	else if (eErrorCode == chatJoinError_NoInviteUser)
	{
		NTALK_LOG->Error(L"[CHAT] ONCHATJOIN ERROR CODE IS [%d], m_bForceLeave=%d, m_bTryRecoverySession=%d", eErrorCode, m_bForceLeave, m_bTryRecoverySession);
		if (m_bForceLeave)
		{
			m_bTryRecoverySession = FALSE;
			return;
		}
		m_bForceLeave = TRUE;
		m_bTryRecoverySession = FALSE;
		DisplayChatErrorMessage(LoadStringFromResource(IDS_STRING325), false, false);
		return;
	}

	CString strUserIDs = _T("");
	vector<PINVITE_USER>::iterator Iter;
	//int nCount = 0;
	PINVITE_USER pUser = NULL;

	m_chatModel.SetInitRoomStatus(INITROOM_SUCCESS);
	m_chatModel.SetInviteListStatus(REGISTER_SUCCESS);	

	if( m_chatModel.GetChatRoomMakeType() == MAKETYPE_JOIN )
	{
		if(roomtype == ROOMTYPE_SINGLE)
		{
			m_bRestoreLeftWindow = false;
			m_chatModel.InitInviteUserStatus();			
		}
		else
		{
			int nUserMapCount = m_chatModel.GetChatUserMapCount();
			for(int i = (nUserMapCount-1); i >= 0; i--)
			{
				BOOL isFind = FALSE;
				CString strID = m_chatModel.GetChatUserID(i);
				vector<PINVITE_USER>::iterator user_iter = vecUserList.begin();

				for(; user_iter != vecUserList.end(); ++user_iter)
				{
					pUser = *user_iter;
					if(strID.CompareNoCase(pUser->pszID) == 0)
					{
						isFind = TRUE;
						break;
					}
				}

				if(isFind == FALSE)
				{
					//SetChatSysMsg(IDS_STRING145, m_chatModel.GetChatUserName(strID), NULL);
					SetUserJoinMsg(IDS_STRING145, m_chatModel.GetChatUserName(strID), FALSE);
					RemoveUser(strID);
                    HideShowLeftList();
					RefreshTitle();
				}
			}
		}

		for ( Iter = vecUserList.begin( ) ; Iter != vecUserList.end( ) ; Iter++ )
		{
			pUser = *Iter;
			if (pUser->pszID != m_chatModel.GetMyID())
			{
                GTUserStatusType status = ustOFFLINE;
                const IGTBuddyUser *pBuddyUser = g_pMessengerActor->GetAvailbeBuddyInfo(pUser->pszID);
                ASSERT(pBuddyUser);
                if (pBuddyUser)
                {
                    status = pBuddyUser->GetStatus();
                }

				if(m_chatModel.FindUserMap(pUser->pszID) < 0)
				{
					m_chatModel.AddChatUser(pUser->pszID, pUser->pszName, pUser->pszNickName, status, TRUE);
					//AddChatUserToListCtrl(pUser->pszID, pUser->pszName, pUser->pszNickName, status);	
					AddChatUserToListCtrl(pUser->pszID, pUser->pszName, pUser->pszNickName, status, _T(""),_T(""),_T(""),_T(""),_T(""),false);	
					//ProcRegiFavoriteToPOI( pUser->pszID );
				}
                
				m_chatModel.SetInviteUserStatus(pUser->pszID, (status != ustOFFLINE));
			}
		}
		
		HideShowLeftList();
		RequestChatUserInfo();
		ProcRegiFavoriteToPOI();
	}
	else
	{
		// Invited but alone... remove user data added when receive invitation packet.
		if( m_chatModel.GetChatRoomMakeType() == MAKETYPE_INVITE && vecUserList.size() == 1 && (*vecUserList.begin())->pszID == m_chatModel.GetMyID() )
		{
			m_chatModel.RemoveChatUserMap(TRUE);
			m_chatModel.ClearChatItemAll();
		}

		if(roomtype == ROOMTYPE_SINGLE)
		{
			m_bRestoreLeftWindow = false;
		}

		for ( Iter = vecUserList.begin( ) ; Iter != vecUserList.end( ) ; Iter++ )
		{	
			pUser = *Iter;		
			if (pUser->pszID != m_chatModel.GetMyID())
			{
                GTUserStatusType status = ustOFFLINE;
                const IGTBuddyUser *pBuddyUser = g_pMessengerActor->GetAvailbeBuddyInfo(pUser->pszID);
                ASSERT(pBuddyUser);
                if (pBuddyUser)
                {
                    status = pBuddyUser->GetStatus();
                }

				if(m_chatModel.FindUserMap(pUser->pszID) < 0)
				{
					m_chatModel.AddChatUser(pUser->pszID, pUser->pszName, pUser->pszNickName, status, TRUE);
				}

				//AddChatUserToListCtrl(CString strID, CString strName, CString strNickName, GTUserStatusType onlineStatus, CString strExtensionTel = _T(""), CString strCellphone = _T(""), CString strJobPos = _T(""), CString strJobDuty = _T(""), CString strDeptName = _T(""), bool bSync = true);
				AddChatUserToListCtrl(pUser->pszID, pUser->pszName, pUser->pszNickName, status,_T(""),_T(""),_T(""),_T(""),_T(""),false);	
				//nCount ++;

				//ProcRegiFavoriteToPOI( pUser->pszID );
			}
		}
		
		HideShowLeftList();

		RequestChatUserInfo();
		ProcRegiFavoriteToPOI();

		// 혹시 초대 전에 못 받은 메시지가 없는지 DB에서 메시지를 읽어본다
		if (m_chatModel.GetChatRoomMakeType() == MAKETYPE_INVITE)
		{
			m_getMessageTrid = 0;
			/*	
				ⓐ A가 B에게 대화를 보낼때 '대화 내용'을 DB에 저장하고,
				ⓑ B에게서 응답을 받으면 해당 대화의 전송상태를 '성공'으로 업데이트 합니다.
				ⓐ와 ⓑ 사이에 초대를 받을 경우, 해당 시점에는 성공한 대화가 없기 때문에 지난 대화 리스트를 가져오지 못하는 이슈가 있다.
				(ⓐ 이전에 초대가 된 경우는 대화창에 정상적으로 대화가 나올 것이고, 
				ⓑ 이후에 초대가 된 경우는 서버에서 대화를 가져와서 보여주므로 문제가 없다)
				위 이슈를 해결하기 위해 아래와 같이 처리한다.
				1. 멀티 로그인 상태인 경우
				-> 전송 성공 상태와 상관없이, 지난 대화를 가져와서 보여주도록 수정
				(멀티 로그인 상태인 경우 모바일로의 전송은 무조건 성공한다고 가정. 즉 ⓑ단계는 무조건 성공이라고 가정)
				2. PC만 로그인 상태인 경우
				-> 현 상태 유지('전송 성공한' 대화만 가져와서 보여주도록) 
			*/
			int nSendSuccess = 1;
			if (GET_MESSENGER_DLG()->GetMainFrame() && GET_MESSENGER_DLG()->GetMainFrame()->IsMobileOnline())
				nSendSuccess = 0;  

            int nFromMsgSeq = nLastMsgNum;
            NE_MYROOM_DATA* pRoomData = GET_APP()->m_pChatDialogManager->GetRoomData(roomid);

            //pRoomData will be NULL when user be invited in group chat, comment out and check it later
            //ASSERT(pRoomData);
            if (pRoomData)
            {
                nFromMsgSeq = pRoomData->nLastMsgSeq + 1;
            }

            NTALK_LOG->Debug(L"[CHAT] RequestGetMessages %d:%d:%d->%d:%d", roomid, nJoinNum, nFromMsgSeq, nLastMsgNum, nSendSuccess);
//			g_pMessengerActor->GetWASActor()->RequestGetMessages(roomid, nJoinNum,nFromMsgSeq, nLastMsgNum, nSendSuccess, &m_getMessageTrid);
			g_pMessengerActor->GetWASActor()->RequestGetMessages(roomid, nJoinNum,nFromMsgSeq, nLastMsgNum, nSendSuccess, &m_getMessageTrid);
		}
	}
}

void CALLBACK CChatDlg::NtalkClient_OnForceChatReJoin(INTalkClient* pNTClient, NTalkChatJoinErrorCode eErrorCode, int roomid, std::vector<PINVITE_USER>& vecUserList)
{
    if (roomid != m_chatModel.GetRoomID() || vecUserList.empty())
		return;		

    FTLTRACEEX(tlTrace, TEXT("OnForceChatReJoin eErrorCode=%d, roomid=%d, vecUserList=%d\n"),
        eErrorCode, roomid, vecUserList.size());

	std::wostringstream os;
#if 1
	//debug for NTALKCL-913
	{
		GT_MY_USER_DATA myUserData;
		g_pMessengerActor->GetMyUserInfo(myUserData);
		for (std::vector<PINVITE_USER>::const_iterator it = vecUserList.begin();
			it != vecUserList.end();
			++it)
		{
			if (it != vecUserList.begin())
			{
				os << L",";
			}
			os << L"[" << (*it)->pszID << L":" << (*it)->pszName << L"," << L"]";
		}
	}
#endif 
	std::wstring strRoomList = os.str();
    NTALK_LOG->Debug(L"[CHAT] ONFORCECHATREJOIN %d:%d:%d(%s)", roomid, eErrorCode, vecUserList.size(), strRoomList.c_str());

	if (eErrorCode == chatJoinError_NoExist || eErrorCode == chatJoinError_NoInviteUser)
	{
		KillTimer(m_hWnd, TIMER_CHAT_CHECK_SESSIONSTATUS);
		if (m_pNtalk)
		{
			m_pNtalk->RequestChatLeave();
			m_pNtalk->DestroyChatSession();
		}
		m_chatModel.SetSessionCreateStatus(SESSION_SUCCESS);
		DisplayChatErrorMessage(::LoadStringFromResource(IDS_STRING255));
		JudgeReadOnly();
		return;
	}

	CString strUserIDs = _T("");
	vector<PINVITE_USER>::iterator Iter;	
	PINVITE_USER pUser = NULL;

	if (IsNeedInviteOthers(vecUserList))
	{
		HANDLE hInviteThread = (HANDLE)_beginthreadex(NULL, 0, InviteChatUserThd, (LPVOID)this, 0, NULL);
		m_hInviteThreadList.push_back(hInviteThread);
	}
	else
	{
		for ( Iter = vecUserList.begin( ) ; Iter != vecUserList.end( ) ; Iter++ )
		{
			pUser = *Iter;
			if (m_chatModel.GetMyID().CompareNoCase(pUser->pszID) != 0)
			{
				m_chatModel.SetInviteUserStatus(pUser->pszID, TRUE);

                GTUserStatusType status = ustOFFLINE;
                const IGTBuddyUser *pBuddyUser = g_pMessengerActor->GetAvailbeBuddyInfo(pUser->pszID);
                ASSERT(pBuddyUser);
                if (pBuddyUser)
                {
                    status = pBuddyUser->GetStatus();
                }

				AddChatUserToListCtrl(pUser->pszID, pUser->pszName, pUser->pszNickName, status);
				ProcRegiFavoriteToPOI( pUser->pszID );
			}
		}
		RequestChatUserInfo();
		//ProcRegiFavoriteToPOI();
	}	
}

BOOL CChatDlg::IsNeedInviteOthers(vector<PINVITE_USER> vecInvites)
{
	if (vecInvites.empty() == true)
		return TRUE;
	
	CString strMyID = m_chatModel.GetMyID();

	vector<PINVITE_USER>::iterator iter = vecInvites.begin();
	PINVITE_USER pUser = *iter;

	if(vecInvites.size() == 1 && strMyID.CompareNoCase(pUser->pszID) == 0 )
		return TRUE;
	
	return FALSE;
}

void CALLBACK CChatDlg::NtalkClient_OnNewJoiner(INTalkClient* pNTClient, int roomid, LPCTSTR userid, LPCTSTR nickname, int time, UINT membercount, int jointype, int ostype)
{
	if (roomid != m_chatModel.GetRoomID())
		return;	

    FTLTRACEEX(tlTrace, TEXT("OnNewJoiner roomid=%d, userid=%d, nickname=%s, time=%d, membercount=%d, jointype=%d, ostype=%d\n"),
        roomid, userid, nickname, time, membercount, jointype, ostype);

    NTALK_LOG->Debug(L"[CHAT] ONNEWJOINER %d:%s:%s:%d:%d:%d:%d", 
        roomid, userid, nickname, time, membercount, jointype, ostype);

	if(m_chatModel.IsGroupRoom() == FALSE && m_chatModel.FindUserMap(userid) >= 0)
	{
		if( jointype == JOIN_TYPE_REAL )
		{
			m_chatModel.SetInviteUserStatus(userid, TRUE);
		}
	}
	else
	{
		if(m_chatModel.FindUserMap(userid) < 0)
		{
			CString nameNnickname(nickname);
			vector<CString> vecNames;
			SplitString(nameNnickname, _T('|'), vecNames);

			CString strName(_T(""));
			CString strNickName(_T(""));
			int size = vecNames.size();
			if (size == 2)
			{
				strName = vecNames[0];
				strNickName = vecNames[1];
			}
			else if (size == 1)
			{
				strName = vecNames[0];
			}

			m_chatModel.AddChatUser(userid, strName, strNickName, ustONLINE, FALSE);					
			AddChatUserToListCtrl(userid, strName, strNickName, ustONLINE);			
			ProcRegiFavoriteToPOI( userid );
			RequestChatUserInfo();
			//ProcRegiFavoriteToPOI();	
		}

        if( jointype == JOIN_TYPE_REAL )
        {
            m_chatModel.SetInviteUserStatus(userid, TRUE);
        }
	}	

	if (m_chatModel.IsGroupRoom() == TRUE && jointype == JOIN_TYPE_DUMMY)
	{
		if( m_chatModel.GetChatUserStatus(userid) == ustMOBILE )
		{
			m_chatModel.SetInviteUserStatus(userid, TRUE);
		}

		//SetChatSysMsg(IDS_STRING150, m_chatModel.GetChatUserName(userid), userid);	// 입장 알림 메세지(JOIN_TYPE_DUMMY인 경우에만)
		SetUserJoinMsg(IDS_STRING150, m_chatModel.GetChatUserName(userid), TRUE);
	}
}

void CALLBACK CChatDlg::NtalkClient_OnForceReJoiner(INTalkClient* pNTClient, int roomid, LPCTSTR userid, LPCTSTR nickname, int time, UINT membercount)
{
	if (roomid != m_chatModel.GetRoomID())
		return;	

    FTLTRACEEX(tlTrace, _T("%s roomid=%d, userid=%s, nickname=%s, time=%d, membercount=%d\n"), 
        roomid, userid, nickname, time, membercount);

    NTALK_LOG->Debug(L"[CHAT] NtalkClient_OnForceReJoiner,roomid=%d,userid=%s,membercount=%d", 
        roomid, userid, membercount);

	m_chatModel.SetInviteUserStatus(userid, TRUE);
}

void CALLBACK CChatDlg::NtalkClient_OnAckSendMsg(INTalkClient *pNtClient, 
												  int roomid, 
												  UINT msg_seq, 
												  LPCTSTR userid,
												  UINT tid, 
												  int time)
{
	if (roomid != m_chatModel.GetRoomID())
		return;	

	TRACE("%s %d\n", __FUNCTION__, __LINE__);
    NTALK_LOG->Debug(L"[CHAT] NtalkClient_OnAckSendMsg, roomid=%d, msg_seq=%d,userid=%s,tid=%d", 
        roomid, msg_seq, userid, tid);

	m_chatModel.AckMyMessageTid(tid);	// 전송 실패 여부는 CheckSendMsgAck() 에서 한다.
	m_chatModel.SetMsgSequence(userid, tid, msg_seq);

	SQLITE3.UpdateSequence(roomid,userid,tid,msg_seq);
}

void CALLBACK CChatDlg::NtalkClient_OnAckSendFile(INTalkClient* pNtClient,
												  int roomid, 
												  UINT msg_seq, 
												  LPCTSTR userid,
												  UINT tid,
												  int time)
{
	if (roomid != m_chatModel.GetRoomID())
		return;	
	
	NTALK_LOG->Debug(TEXT("[CHAT] ONACKSENDFILE, int roomid=%d, msg_seq=%d, tid=%d"),
		roomid, msg_seq, tid);

	//do not ack, because file is diff with msg, handle in OnMsgResult
	//m_chatModel.AckMyTranslateTid(tid);

	m_chatModel.SetMsgSequence(userid, tid, msg_seq);
	SQLITE3.UpdateSequence(roomid,userid,tid,msg_seq);
}

void CALLBACK CChatDlg::NtalkClient_OnInitRoom(INTalkClient* pNTClient, int roomid, NTalkCreateSesionErrorCode eErrorCode)
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);

    NTALK_LOG->Debug(L"[CHAT] ONINITROOM %d=>%d:%d", m_chatModel.GetRoomID(), roomid, eErrorCode);

	if (roomid != m_chatModel.GetRoomID())
		return;	

	if(eErrorCode != createSessionError_None)
	{
		m_chatModel.SetInitRoomStatus(INITROOM_ERROR);

		// TODO: 채팅방 생성 실패에 대한 예외 처리 필요
		// 현재 메세지 전송 시 InitRoom을 수행하므로 초기화 실패 시 메세지 전달 실패 가능성 있음

	}
	else
	{
		m_chatModel.SetInitRoomStatus(INITROOM_SUCCESS);
        m_bRoomEnd = FALSE;
	}
}

void CALLBACK CChatDlg::NtalkClient_OnInviteList(INTalkClient* pNtClient, int roomid, NTalkInviteListErrorCode eErrorCode, 
												UINT nTotalMemberCount, UINT nTryCount, UINT nFailCount, std::vector<TCHAR*>& vecUserList)
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);

	NTALK_LOG->Debug(L"[CHAT] ONINVITELIST %d:%d:%d:%d:%d", roomid, eErrorCode, nTotalMemberCount, nTryCount, nFailCount);

	if (roomid != m_chatModel.GetRoomID())
		return;	

	if(eErrorCode == InviteListError_None)
	{		
		m_chatModel.SetInviteListStatus(REGISTER_SUCCESS);
		if(nFailCount != 0)
		{
			std::vector<TCHAR*>::iterator user_iter = vecUserList.begin();

			for(; user_iter != vecUserList.end(); ++user_iter)
			{
				vector<LPCTSTR>::iterator find_iter = std::find(m_vecSendMemoExUser.begin(), m_vecSendMemoExUser.end(), (*user_iter));
				if(find_iter != m_vecSendMemoExUser.end())
				{
					delete [] *find_iter;
					m_vecSendMemoExUser.erase(find_iter);
				}
			}
		}
	}
	else
	{
		m_chatModel.SetInviteListStatus(REGISTER_ERROR);
	}
}

void CALLBACK CChatDlg::NtalkClient_OnRoomEnd(INTalkClient* pNtClient, int roomid, int type)
{
	NTALK_LOG->Debug(L"[CHAT] ONROOMEND %d:%d", roomid, type);

	if (roomid != m_chatModel.GetRoomID())
		return;	

	CString strMsg;
	strMsg.LoadString(IDS_STRING255);
	DisplayChatErrorMessage(strMsg);
    m_bRoomEnd = TRUE;  //TODO: when set it to FALSE( can room reuse after end?)

    JudgeReadOnly();
}

void CALLBACK CChatDlg::NtalkClient_OnSessionEnd(INTalkClient* pNTClient, int roomid, LPCTSTR userid, 
                                        LPCTSTR nickname, int nOSType)
{
    if (roomid != m_chatModel.GetRoomID())
        return;	

    FTLTRACEEX(tlTrace, TEXT("OnSessionEnd, roomid=%d, nickname=%s, nOSType=%d\n"),
        roomid, userid, nOSType);

    NTALK_LOG->Debug(L"[CHAT] ONSESSIONEND %d:%s:%d", roomid, userid, nOSType);

    m_chatModel.SetInviteUserStatus(userid, FALSE);
    //JudgeReadOnly();
}

void CALLBACK CChatDlg::NtalkClient_OnServerNotReady(INTalkClient* pNtClient)
{
	NTALK_LOG->Error(L"[CHAT] Server Not Ready");
}

void CALLBACK CChatDlg::NtalkClient_OnSendMsgFail(INTalkClient* pNtClient, int roomid, UINT msg_seq, UINT tid, int time, 
																	int os_type, std::vector<COMM_USERINFO *>& vecFailUser)
{
	CTime CurTime(CTime::GetCurrentTime());
	CString szTime = CurTime.Format("'%Y-%m-%d %H:%M:%S'");
	NTALK_LOG->Debug(L"[CHAT] ONSENDMSGFAIL %s: %d:%d:%d:%d:%d",szTime, roomid, msg_seq, tid, time, os_type);
	//NTALK_LOG->Debug(L"[%s][NtalkClient_OnSendMsgFail]:%d:%d:%d:%d:%d",szTime, roomid, msg_seq, tid, time, os_type);

	if (roomid != m_chatModel.GetRoomID())
		return;

	std::vector<CString> vecUserNameAndNickName;
	std::vector<COMM_USERINFO *>::iterator failuser_iter = vecFailUser.begin();
	CString strFailUser, strMsgFormat, strFailMsg;
	strMsgFormat.LoadString(IDS_STRING290);
	
	CTime t(time);
	GetLocaleTime(&t);

	for(; failuser_iter != vecFailUser.end(); ++failuser_iter)
	{
		COMM_USERINFO* pUser = (*failuser_iter);
		int nCount = SplitString(pUser->pszUserName, _T('|'), vecUserNameAndNickName);
		if(nCount > 0)
		{
			if(strFailUser.IsEmpty() == FALSE)
			{
				strFailUser.Append(_T(", "));
			}
			strFailUser.Append(vecUserNameAndNickName[0]);
		}
		else
		{
			ASSERT(FALSE);
		}
	}

	SQLITE3.UpdateMsgStatus(m_chatModel.GetRoomID(),m_chatModel.GetMyID(),tid,CMS_FAIL);
	m_chatModel.UpdateMsgStatus(m_chatModel.GetMyID(),tid,CMS_FAIL);

	strFailMsg.Format(strMsgFormat, strFailUser);
	ChatItemInfo stChatItemInfo(strFailMsg, t, m_cf);
	m_pChatMainView->AddChatItem(&stChatItemInfo, true);

}
 
void CALLBACK CChatDlg::NtalkClient_OnMsgResult(INTalkClient* pNtClient, int room_id, UINT msg_seq, UINT tid, int time, 
											  int os_type, int result_seq, std::vector<SEND_MSGRESULT *>& vecUserMsgResult)
{
	if (room_id != m_chatModel.GetRoomID())
	{
		NTALK_LOG->Debug(L"[CHAT] ONMSGRESULT: room_id(%d) != m_chatModel.GetRoomID(%d)",
			 room_id,m_chatModel.GetRoomID());
		return;	
	}

	bool bFail = false;
	CChatItem *pChatItem = NULL;
	CChatModel *pChatModel = m_pChatMainView->GetChatModel();
	int nIndex = -1;
	for (int i = pChatModel->GetChatItemCount() - 1; i >= 0 ; i--)
	{
		CChatItem *p = pChatModel->GetChatItem(i);
		if (p->GetTid() == tid && p->GetChatItemInfo()->strUserID.CompareNoCase(m_chatModel.GetMyID()) == 0)
		{ 
			pChatItem  = p;
			nIndex = i;
			break; 
		}
	}

	if (!pChatItem)
	{
        NTALK_LOG->Debug(L"[CHAT] ONMSGRESULT can not found ChatItem,tid=%d", tid);
        //ASSERT(FALSE);  //TODO: Why Send File will retrun NtalkClient_OnMsgResult
		return;
	}
 
	std::vector<SEND_MSGRESULT *>::iterator msguser_iter = vecUserMsgResult.begin();
	CString strUserName = _T("");
	for (; msguser_iter != vecUserMsgResult.end(); ++msguser_iter)
	{
		SEND_MSGRESULT* pUser = (*msguser_iter);
		CTime CurTime(CTime::GetCurrentTime());
        CString szTime = CurTime.Format("'%Y-%m-%d %H:%M:%S'");
        NTALK_LOG->Debug(L"[CHAT] ONMSGRESULT, %d:%d:%d:%d:%s:%s",
            pUser->nResult, room_id, msg_seq, tid, pUser->pszUserID, pUser->pszUserName);

        /* nResult 값
		 * 1:  성공
		 * 10: 실패(클라이언트로부터 수신 ACK을 받지 못함)
		 * 11: 실패(대화패킷전달실패) 
		 * 12: 사용자 세션이 존재하지 않음.(Mobile)
		 * 20: nPush 연동 실패(이 경우는 모바일인 경우도 실패처리를 해주어야 함)
		 */
		if (pUser->nResult == 1)
		{
			// 성공! ^______^	
			int newVal = pChatItem->GetSucceedCount() + 1;
			pChatItem->SetSucceedCount(newVal);
		}
		else
		{
			bFail = true;
			/******* 채팅서버요청사항(2012.6.11) *****
			 * 서버에서는 모바일등에 대한 상태를 알 수가 없으므로, 			
			 * msgresult에서 전송실패가 오더라도 PC클라이언트에서 상대의 presence를 확인해서 모바일상태이면
			 * 성공으로 간주하도록 한다. 
			 * (* 단, presence가 정확하지 않은 상황에 대해서는 보장을 할 수 없음)
			 * 추가: result code 20의 경우는 npush 까지 실패한 것이므로 모바일의 경우도 실패처리를 해주어야 함
			 */
			if (m_chatModel.GetChatUserStatus(pUser->pszUserID) != ustMOBILE ||
				(m_chatModel.GetChatUserStatus(pUser->pszUserID) == ustMOBILE && pUser->nResult == 20))
			{
				if (!strUserName.IsEmpty())
				{
					strUserName.Append(_T(", "));
				}
				
				CString strTmp =m_chatModel.GetChatUserName(pUser->pszUserID);
				if (strTmp.IsEmpty() && pUser->nUserNameLength > 0)
				{
					strTmp = pUser->pszUserName;
					int index = strTmp.Find('|');
					if (index != -1)
					{
						strTmp = strTmp.Left(index);
					}
				}

				// PC와 모바일 동시 접속한 사용자에게 메시지를 보내지 못했을 경우 같은 이름이 두번 표시되므로, 모바일은 구분자를 붙여준다.
				if (m_chatModel.GetChatUserStatus(pUser->pszUserID) == ustMOBILE)
					strTmp.Append(_T("(Mobile)"));
				strUserName.Append(strTmp);
				//m_chatModel.IncreaseFailCount(tid);
				pChatItem->IncreaseFailCount();
            }
			else
			{
				/* 여기로 오는 경우 성공 카운트도 올라가지 않고, 에러도 발생하지 않으므로 대화창의 전송 상태가 틀려지게 된다.
				 * 발생할 수 있는 경우는 '모바일' 상태의 사용자에게서 10, 11, 12 에러가 발생할 경우인데
				 * 12번 에러가 발생한 경우는 서버에서 nPush 로 전송 후 1 또는 20 번을 전달해 주므로 문제가 되지 않는다.
				 * 즉, 문제가 되는 것은 10, 11번 에러의 경우인데 성공/실패 중 하나로 처리해 주어야 할 것이다.
				 */
			}
		}
	}

	NTALK_LOG->Debug(L"[CHAT] ONMSGRESULT fail = %s	UserCount = %d	SucceedCount=%d	item isFailedMsg=%s",
		bFail?_T("TRUE"):_T("FALSE"),
		pChatItem->GetChatItemInfo()->nUserCount,
		pChatItem->GetSucceedCount(),
		pChatItem->IsFailedMsg()?_T("TRUE"):_T("FALSE"));

    _UpdateChatItemMsgResultInfo(pChatItem, bFail, tid, time, strUserName);

	m_pChatMainView->UpdateElementStateByIndex(nIndex);
	m_pChatMainView->UpdateView(); 
}

void CChatDlg::_UpdateChatItemMsgResultInfo(CChatItem *pChatItem, bool bFail, UINT tid, 
                                            int time, const CString& strUserName )
{
    ASSERT(pChatItem);
    CTime localTime(time);
    GetLocaleTime(&localTime);

    if (pChatItem->GetChatItemInfo()->eMsgGB !=  CHAT_MSG_FTP)
    {
        ChatMsgStatus msgStatus = bFail ? CMS_FAIL : CMS_SUCCEED;
        if (bFail)
        {
            pChatItem->SetMsgStatus(CMS_FAIL);
            SQLITE3.UpdateMsgStatus(m_chatModel.GetRoomID(),m_chatModel.GetMyID(),tid,CMS_FAIL);
				if (m_chatModel.IsGroupRoom())
				{
					CTime t(time);
					GetLocaleTime(&t);

					CString strFailMsg;
					strFailMsg.Format(LoadStringFromResource(IDS_STRING290), strUserName);	// %s 님에게 메시지를 보내지 못했습니다.
					//m_pChatMainView->AddChatItem(_T(""), _T(""), _T(""), t, strFailMsg, m_cf);
					ChatItemInfo stChatItemInfo(strFailMsg, t, m_cf);
					m_pChatMainView->AddChatItem(&stChatItemInfo, true); 
				}
			}
        else
        {
            if (pChatItem->GetChatItemInfo()->nUserCount == pChatItem->GetSucceedCount())
            {
                pChatItem->SetMsgStatus(CMS_SUCCEED);	//all users have received message.
                SQLITE3.UpdateMsgStatus(m_chatModel.GetRoomID(),m_chatModel.GetMyID(),tid,CMS_SUCCEED);
                // Modify by sevin, send successfuly then update recent chat room list
                if(GET_MESSENGER_DLG()->GetMainFrame() != NULL)
                {
                    GET_MESSENGER_DLG()->GetMainFrame()->UpdateChatRoomList(this, TRUE);
                }
            }
        }
    }
    else
    {
        int msgStatus = sUploadError;
        //File
        if (!bFail)
        {
            //check send to all user
            bFail = (pChatItem->GetChatItemInfo()->nUserCount != pChatItem->GetSucceedCount());
        }

        if (!bFail)
        {
            m_chatModel.AckMyTranslateTid(tid);
            msgStatus = sUploadSuccess;
        }

        CChatFileItem* pFileItem = dynamic_cast<CChatFileItem*>(pChatItem);
        ASSERT(pFileItem);
        if (pFileItem)
        {
            TranslateFileInfoPtr pTranslateFileInfo = pFileItem->GetTranslateFileInfo();
            ASSERT(pTranslateFileInfo);

            if (pTranslateFileInfo)
            {
                if (bFail)
                {
                    pTranslateFileInfo->SetResultByLastError(ERROR_LOST_WRITEBEHIND_DATA_NETWORK_SERVER_ERROR);
                }
                else
                {
                    pTranslateFileInfo->SetResultByLastError(ERROR_SUCCESS);
                }
            }

            //if (pTranslateFileInfo->GetResult() == eSuccess)
            //{
            //	pTranslateFileInfo->SetStatus( sUploadSuccess );
            //	//CFileTranslateAbnormalHandler::Store(m_chatModel.GetRoomID(), pTranslateFileInfo);
            //	SQLITE3.UpdateMsgStatus(m_chatModel.GetRoomID(),m_chatModel.GetMyID(),pTranslateFileInfo->m_TidRequestFileTranslate,sUploadSuccess);
            //	m_chatModel.UpdateMsgStatus(m_chatModel.GetMyID(),pTranslateFileInfo->m_TidRequestFileTranslate,sUploadSuccess);
            //}

            pChatItem->SetMsgStatus(msgStatus);
            SQLITE3.UpdateMsgStatus(m_chatModel.GetRoomID(),m_chatModel.GetMyID(),tid, msgStatus);
            m_chatModel.UpdateMsgStatus(m_chatModel.GetMyID(),tid, msgStatus);

            if (!bFail)
            {
                if(GET_MESSENGER_DLG()->GetMainFrame() != NULL)
                {
                    GET_MESSENGER_DLG()->GetMainFrame()->UpdateChatRoomList(this, TRUE);
                }
            }
        }
    }
}

void CALLBACK CChatDlg::NtalkClient_OnRecvPong()
{
	m_nPingPongCount--;
}

bool CChatDlg::OnGTWASActor_ResponseGetNewRoom(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const GT_ROOM_DATA &sRoomInfo)
{
	//if( m_chatModel.GetChatTrid() != trid )
	if (m_trid != trid)
		return true;

    Trace(_T("%s %d RoomID:%d, Trid:%d\n"), _T(__FUNCTION__), __LINE__, sRoomInfo.nRoomID, trid.GetID());
    CFConversion conv;
    NTALK_LOG->Debug(L"[CHAT] RESPONSEGETNEWROOM, RoomID:%d(%s), Trid:%d, errCode:%d", 
        sRoomInfo.nRoomID, conv.UTF8_TO_UTF16(sRoomInfo.strRoomType), trid.GetID(), eErrorCode);

    if (m_chatModel.GetRoomID() != sRoomInfo.nRoomID)
    {
        ASSERT(m_chatModel.GetRoomID() == 0); //same trid, then check roomid
    }

	if (eErrorCode == wasError_None)
	{
		CString strSrvAddress(sRoomInfo.strServerAddress);
		CString strRoomType(sRoomInfo.strRoomType);		
		SetServerInfo(strSrvAddress, sRoomInfo.nServerPort, sRoomInfo.nRoomID, strRoomType);

		//m_pChatMainView->InitRecentMsg();
		if (m_chatModel.IsOldRoomType() == TRUE)
		{
			/* 1:1 대화 도중 나갔다가 다시 해당 사용자와 대화를 시도하려는 경우
			   새로운 채팅방을 생성하지 않고, 기존의 채팅방에 재진입을 함.*/
			m_chatModel.SetChatRoomMakeType(MAKETYPE_FORCEJOIN);
		}

		m_chatModel.SetSessionReason(REASON_CREATE);
		m_chatModel.ResetCreateSessionCheckTimes();

		// NegotiateChatSession() 이 실패하였을 경우 창을 닫는다.
		if (NegotiateChatSession() != true)
		{
			this->CloseChatDialog();
			return false;
		}
		
		if (GET_MESSENGER_DLG()->GetMainFrame() && NULL != GET_MESSENGER_DLG()->GetMainFrame()->GetSafeHwnd())
		{
			GET_MESSENGER_DLG()->GetMainFrame()->AddChatRoomList(this);
		}
	}	
	
	return false;
}

bool CChatDlg::OnGTWASActor_ResponseGetTalkName(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const std::vector<NT_TALKNAME_DATA> &listTalknameData)
{	
	if(eErrorCode == wasError_None)
	{		
		ChangeNickNameChatUserList(listTalknameData);			
	}

	return true;
}

std::wostream& operator << (std::wostream& os, const NE_MESSAGE_DATA& msg)
{
    os  << L"{ userId:" << msg.strFromUserId 
        << L",nMsgSeq:" << msg.nMsgSeq
        << L",nMsgType:" << msg.nMsgType
        << L",nTrid:" << msg.nTrid
        << "}";

    return os;
}

bool CChatDlg::OnGTWASActor_ResponseGetMessages(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const std::vector<NE_MESSAGE_DATA> &listMessage)
{
	if (m_getMessageTrid != trid)
		return true;

    std::wostringstream os;
#if 1
    std::copy(listMessage.begin(), listMessage.end(), std::ostream_iterator<const NE_MESSAGE_DATA, wchar_t>(os, L";"));
#endif 
    const std::wstring& strMsgList = os.str();
    NTALK_LOG->Debug(L"RESPONSEGETMESSAGES, %d:%d:[%s]", eErrorCode, listMessage.size(), strMsgList.c_str());

	if (eErrorCode == wasError_None)
	{
		if (listMessage.empty() == true)
			return false;

		std::vector<NE_MESSAGE_DATA>::const_iterator iter = listMessage.begin();

		for (; iter != listMessage.end(); iter++)
		{
			NE_MESSAGE_DATA messageData = *iter;

			if (messageData.nMsgType != DEF_CHAT_MSG_TYPE_CHAT 
                && messageData.nMsgType != DEF_CHAT_MSG_TYPE_STICKER
                //&& messageData.nMsgType != DEF_FTP_MSG_TYPE
                )
            {
				continue;
            }
			vector<CString> vecNames;
			CString strName(_T(""));
			CString strNickName(_T(""));

			SplitString_NotEmpty(messageData.strFromUserName.c_str(), _T('|'), vecNames);
			int size = vecNames.size();		
			strName = vecNames[0];
			strNickName = vecNames[1];

			m_chatModel.AddChatMessage(messageData.strFromUserId.c_str(), strName, strNickName, messageData.nRecvTime, messageData.strMessage.c_str(),
				NULL, messageData.nMsgSeq, messageData.nTrid, messageData.nMsgType);
		}

		ReceiveChatMsg();
	}	

	return false;
}

bool CChatDlg::UpdateBuddyStatus(/*IGTMessengerActor *pActor,*/ LPCWSTR strBuddyID, int nTypeBits)
{	
	TRACE(TEXT("%s %d, strBuddyID=%s, nTypeBits=%d\n"), TEXT(__FUNCTION__), __LINE__, strBuddyID, nTypeBits);
	bool res = true;
	
	/*if (!pActor || !g_pMessengerActor->GetBuddyInfo(strBuddyID))
	{
		res = false;
	}
	else*/ if (GET_MESSENGER_DLG()->IsAvailableUpdateStatus())
	{
		GTUserStatusType stStatus = g_pMessengerActor->GetBuddyInfo(strBuddyID)->GetStatus();
		NTIPTStatusType iptStatus = g_pMessengerActor->GetBuddyInfo(strBuddyID)->GetIPTStatus();

		CString strUserID = _T("");

		CSingleLock lock(m_listChatUser.GetLockObject(), TRUE);
		int nCount = m_listChatUser.GetItemCount();
		CChatUserList::_chat_user_info* pChInfo = NULL;
		
		for (int i = 0; i < nCount; i++)
		{
			pChInfo = (CChatUserList::_chat_user_info*)m_listChatUser.GetItemData(i);
		
			if (!pChInfo)
				continue;

			strUserID = pChInfo->strUserID;

			if (strUserID.CompareNoCase(strBuddyID) == 0)
			{
				UpdateStatus(stStatus, i, strUserID);
				UpdateIPTStatus((NTIPTStatusType)iptStatus, i, strUserID);
				
				break;
			}
		}
	}

	return res;
}

bool CChatDlg::UpdateNotBuddyStatus(/*IGTMessengerActor *pActor,*/ LPCWSTR strBuddyID, int nUserStatus, LPCWSTR strNick, int nIPTStatus, int nFlag)
{
	CTime CurTime(CTime::GetCurrentTime());
	CString szTime = CurTime.Format("'%Y-%m-%d %H:%M:%S'");
	//NTALK_LOG->Debug(_T("[%s][CChatDlg::UpdateNotBuddyStatus]:stStatus(%d), CString strUserID(%s)"),szTime,nUserStatus,strBuddyID);

	CChatUserList::_chat_user_info* pChInfo = NULL;
	CSingleLock lock(m_listChatUser.GetLockObject(), TRUE);
	int nItemCount = m_listChatUser.GetItemCount();
	for(int i = 0; i < nItemCount; i++)
	{
		pChInfo = (CChatUserList::_chat_user_info*)m_listChatUser.GetItemData(i);
		if (!pChInfo)
			continue;

		CString strID = pChInfo->strUserID;
		if (strID.CompareNoCase(strBuddyID) == 0)
		{			
			if(nFlag & NOTIFY_FLAG_PRESENCE)
			{					
				UpdateStatus((GTUserStatusType)nUserStatus, i, strID);
			}
			
			if(nFlag & NOTIFY_FLAG_NICK)
			{					
				ChangeNickNameChatUserList(strID, strNick);
			}

			if( nFlag & NOTIFY_FLAG_IPT )
			{
				UpdateIPTStatus((NTIPTStatusType)nIPTStatus, i, strID);
			}
		}
	}
	
	return true;
}

bool CChatDlg::IsCloseRequest( MSG* pMsg )
{
	bool result = false;
	if( pMsg->message == WM_CLOSE ||
		(pMsg->message == WM_KEYDOWN && pMsg->wParam == VK_ESCAPE
		&& !IsAnyFTProcessRunning()) || 
		(pMsg->message == WM_SYSKEYDOWN && pMsg->wParam == VK_F4) ||
		(pMsg->message == WM_SYSCOMMAND && pMsg->wParam == SC_CLOSE) )

		result = true;

	return result;
	
}
void CChatDlg::CheckCloseChatDialog()
{
	if ((g_pProfileWnd != NULL) && (g_pProfileWnd->GetParentHwnd() == m_hWnd || (m_pChatSearchWnd != NULL && m_pChatSearchWnd->GetHWND() == g_pProfileWnd->GetParentHwnd()))
		|| ((g_pProfileWnd != NULL) && m_pChatMainView->GetChatSafeHwnd() == g_pProfileWnd->GetParentHwnd()))
	{
		g_pProfileWnd->CloseProfileWnd();
	}
	GET_MESSENGER_DLG()->GetWorkGroupController()->CloseAddUserDlg();
	
	if (m_chatModel.IsHaveMessageRecord())
	{
		CloseChatDialog(true);
	}
	else
	{
		CloseChatDialog();
	}
}

BOOL CChatDlg::SaveRoomData(NE_MYROOM_DATA &roomData)
{
	roomData.nRoomID = m_chatModel.GetRoomID();
	roomData.strServerIP = m_chatModel.GetSrvAddress();
	roomData.nServerPort = m_chatModel.GetSrvPort();
	if (m_chatModel.IsGroupRoom())
	{
		roomData.nRoomType = CHATROOM_MULTITYPE;
	}
	else
	{
		roomData.nRoomType = CHATROOM_SINGLETYPE;
	}

	CChatItem* pChatItem = GetLastMsgItem(FALSE);
	if (pChatItem == NULL)
	{
		return FALSE;
	}
	else
	{
		roomData.strLastMsgUserId = pChatItem->GetChatItemInfo()->strUserID;
		roomData.msgType = pChatItem->GetItemType();
		if (pChatItem->GetItemType() == CHAT_MSG_FTP)
		{
			roomData.msgType = DEF_FTP_MSG_TYPE;
		}
		else if (pChatItem->GetItemType() == CHAT_MSG_STICKER)
		{
			roomData.msgType = DEF_CHAT_MSG_TYPE_STICKER;
		}
		else
		{
			roomData.msgType = DEF_CHAT_MSG_TYPE_CHAT;
		}
		roomData.nLastMsgSeq = pChatItem->GetMsgSeq();
		CTime tm = pChatItem->GetChatItemInfo()->time;
		GetGMTTime(&tm);
		roomData.nLastMsgTime = (int)tm.GetTime();
		roomData.nLastMsgTrid = pChatItem->GetTid();
		roomData.strLastMsg = pChatItem->GetChatItemInfo()->strMsg;
	}
	vector<CChatUser*> vecChatUser;;
	
	m_chatModel.GetChatUserArray(vecChatUser);
	vector<CChatUser*>::iterator it = vecChatUser.begin();
	for (; it!=vecChatUser.end(); ++it)
	{
		NE_CHATMEMBER_DATA chatMemberData;
		chatMemberData.strID = (*it)->GetID();
		chatMemberData.strDepartmentName = (*it)->GetDeptName();
		chatMemberData.strJobPositionName = (*it)->GetJobPos();
		chatMemberData.strName = (*it)->GetName();
		chatMemberData.strNickName = (*it)->GetNickName();
		roomData.listChatMemberData.push_back(chatMemberData);
	}
	NE_CHATMEMBER_DATA chatMemberData;
	chatMemberData.strID = m_chatModel.GetMyID();
	chatMemberData.strDepartmentName = m_chatModel.GetMyPage().strDeptName;
	chatMemberData.strJobPositionName = m_chatModel.GetMyPage().strJbpsName;
	chatMemberData.strName = m_chatModel.GetMyName();
	chatMemberData.strNickName = m_chatModel.GetMyPage().strTalkName;
	roomData.listChatMemberData.push_back(chatMemberData);

	return TRUE;
}

void CChatDlg::CloseChatDialog(bool willRestoreRoomID, bool bCloseChat)
{
    FUNCTION_BLOCK_TRACE(DEFAULT_BLOCK_TRACE_THRESHOLD);

	if(!IsWindow(m_hWnd))
	{
		return;
	}

    if (m_pInternetTransfer)
    {
        m_pInternetTransfer->Stop();
        delete m_pInternetTransfer;
        m_pInternetTransfer = NULL;
    }

	

	GET_MESSENGER_DLG()->GetMainFrame()->UpdateUnReadMessage(FALSE, m_chatModel.GetRoomID());
	RequestTyping(FALSE);

	BOOL bRemoveChatItem = TRUE;
	BOOL bSaveRoomData = FALSE;
	if (willRestoreRoomID)
	{
		NE_MYROOM_DATA roomData;
		bSaveRoomData = SaveRoomData(roomData);
		if(bSaveRoomData)
		{
			GET_APP()->m_pChatDialogManager->AddRecentChatRoomData(roomData);
			GET_APP()->m_pChatDialogManager->RequestAllRecentUserStatus();
			bRemoveChatItem = FALSE;
		}
	}

	if (m_pNtalk)
	{
		if (!willRestoreRoomID || !bSaveRoomData)
		{
			m_pNtalk->RequestChatLeave();
		}
		m_chatModel.RemoveChatUserMap();
		m_pNtalk->DestroyChatSession();				
		delete m_pNtalk;
		m_pNtalk = NULL;
	}

	ProcUregFavoriteFromPOI();

	KillTimer(m_hWnd, TIMER_CHAT_CHECK_SENDFILE);
	KillTimer(m_hWnd, TIMER_CHAT_RECOVERY_NETWORK);
	KillTimer(m_hWnd, TIMER_CHAT_SENDMSG_ACK);
	KillTimer(m_hWnd, TIMER_CHAT_CHECK_SESSIONSTATUS);
	KillTimer(m_hWnd, TIMER_CHAT_CHECK_INPUTTING);
    KillTimer(m_hWnd, TIMER_CHAT_CHECK_RECV_INPUTTING);

	RequestTyping(FALSE);
	//KillTimer(m_hWnd, );

	m_PaintManager.RemoveFontAt( m_PaintManager.GetFontIndex(GetDefaultFontFaceName(),DEFAULT_EDITCHAT_FONTSIZE,false,false,false));
	m_PaintManager.RemoveFontAt( m_PaintManager.GetFontIndex(GetDefaultFontFaceName(),DEFAULT_TYPESTATUS_FONTSIZE,false,false,false));


	g_pMessengerActor->GetWASActor()->UnRegisterObserver(this);

	CancelTransferFile();

	GET_APP()->m_pChatDialogManager->Remove((CDialog*)this, bRemoveChatItem); 

	
//	DeleteStickerData();

// 	if (false == willRestoreRoomID)
// 	{
// 		CFileTranslateAbnormalHandler::DeleteAbnormalFile(m_chatModel.GetRoomID());
// 
// 	}
	//DestroyWindow(m_hWnd);
	if (bCloseChat)
	{
		WindowImplBase::Close();
	}
	else
	{
		::ShowWindow(m_hWnd, SW_HIDE);
	}
}

void CChatDlg::CloseChatSession()
{
	if (m_pNtalk)
	{
		m_pNtalk->DestroyChatSession();
		delete m_pNtalk;
		m_pNtalk = NULL;
	}

	ProcUregFavoriteFromPOI();
}

void CChatDlg::EnableDragAndDrop(BOOL bEnable)
{
	m_bEnableDragAndDrop = bEnable;
}

BOOL CChatDlg::IsEnableDragAndDrop()
{
	return m_bEnableDragAndDrop;
}

ESession CChatDlg::GetSessionStatus()
{
	return m_chatModel.GetSessionCreateStatus();
}

EInitRoom CChatDlg::GetInitRoomStatus()
{
	return m_chatModel.GetInitRoomStatus();
}

EInviteList CChatDlg::GetInviteListStatus()
{
	return m_chatModel.GetInviteListStatus();
}

void CChatDlg::DisplayErrorSessionMessage(CString showChatErrorMessage)
{
	int nCntItem = m_chatModel.GetChatItemCount();

	if (nCntItem == 0 && 
		m_chatModel.GetChatRoomMakeType() != MAKETYPE_CREATE &&
		!IsWindowVisible(m_hWnd))
	{
		// 초대만 받은 상태(숨김창)에서 채팅서버가 재시작한 경우 빈 창이 뜨는 문제를 막기 위해
		// 아직 한번의 대화도 없는 초대받은 방의 경우(숨김창 상태) 메시지를 보이지 않는다.
		return;
	}

	CTime time(CTime::GetCurrentTime());
	GetLocaleTime(&time);


	CChatItem* pChItemLast = NULL;
	CChatModel *pChatModel = m_pChatMainView->GetChatModel();
	if (nCntItem > 0)
	{
		CChatItem *item = (CChatItem*)pChatModel->GetChatItem(nCntItem - 1);
		if (item)
		{
			ChatItemInfo *info = item->GetChatItemInfo();
			if (info->eMsgGB == CHAT_MSG_RECOVER_SESSION)
			{
				pChItemLast = item;
			}
		}
	}

	if (!pChItemLast)
	{
		ChatItemInfo stChatItemInfo(showChatErrorMessage, time, m_cf,CHAT_MSG_RECOVER_SESSION);
		m_pChatMainView->AddChatItem(&stChatItemInfo, true);
	}

	//m_pChatMainView->AddChatItem(_T(""), _T(""), _T(""), time, showChatErrorMessage, m_cf);

	// 대화창이 최소화된 상태에서 에러메시지가 발생할 경우 창을 복구시키지 않고 깜박임 효과만 준다
	// NEMESSENGER-3095	[클라이언트] 대화창이 최소화 상태에서 강제 퇴장을 당할 경우 대화창이 팝업되는 현상
	//ShowWindow(SW_SHOWNOACTIVATE);
	FlashEffect(false);
}

void CChatDlg::DisplayChatErrorMessage(CString showChatErrorMessage, bool bRestore, bool bFlashWindow)
{
	int nCntItem = m_chatModel.GetChatItemCount();

	if (nCntItem == 0 && 
		m_chatModel.GetChatRoomMakeType() != MAKETYPE_CREATE &&
		!IsWindowVisible(m_hWnd))
	{
		// 초대만 받은 상태(숨김창)에서 채팅서버가 재시작한 경우 빈 창이 뜨는 문제를 막기 위해
		// 아직 한번의 대화도 없는 초대받은 방의 경우(숨김창 상태) 메시지를 보이지 않는다.
		return;
	}

	CTime time(CTime::GetCurrentTime());
	GetLocaleTime(&time);

	ChatItemInfo stChatItemInfo(showChatErrorMessage, time, m_cf);
	m_pChatMainView->AddChatItem(&stChatItemInfo, bRestore);
	//m_pChatMainView->AddChatItem(_T(""), _T(""), _T(""), time, showChatErrorMessage, m_cf);

	// 대화창이 최소화된 상태에서 에러메시지가 발생할 경우 창을 복구시키지 않고 깜박임 효과만 준다
	// NEMESSENGER-3095	[클라이언트] 대화창이 최소화 상태에서 강제 퇴장을 당할 경우 대화창이 팝업되는 현상
	//ShowWindow(SW_SHOWNOACTIVATE);
	if (bFlashWindow)
	{
		FlashEffect(false);
	}
}

void CChatDlg::DisplayNetworkErrorMessage()
{
	// 네트워크 에러 메시지를 대화창에 보여주지 않고 상태표시줄에 나타나도록 변경 
	//if (m_wndChatStatus.GetSafeHwnd())m_wndChatStatus.SetStatusText(LoadStringFromResource(IDS_STRING247));	// 네트워크 오류로 메시지를 전달할 수 없습니다.
      //TODO--input status
	SetInputStatusText(LoadStringFromResource(IDS_STRING247));


}

void CChatDlg::DisplayServerSessionEndMessage()
{
	//if (m_wndChatStatus.GetSafeHwnd())m_wndChatStatus.SetStatusText(LoadStringFromResource(IDS_CHAT_SERVERSESSION_END));	// 네트워크 오류를 복구하고 있습니다.
  //TODO--input status
	SetInputStatusText(LoadStringFromResource(IDS_CHAT_SERVERSESSION_END));

}

void CChatDlg::DisplaySeverSessionRecoveryCompleted()
{
	//if (m_wndChatStatus.GetSafeHwnd())m_wndChatStatus.SetStatusText(LoadStringFromResource(IDS_CHAT_SERVERSESSION_COMPLETED));	// 오류 복구를 완료했습니다.
  //TODO--input status
	SetInputStatusText(LoadStringFromResource(IDS_CHAT_SERVERSESSION_COMPLETED));

}

//void CChatDlg::DisplayNetworkErrorAndCloseDialog()
//{
//	CString strMsg;
//	strMsg.LoadString(IDS_STRING162);
//	AfxMessageBox(strMsg);
//
//	CloseChatDialog();
//}

bool CChatDlg::RecoveryNetworkError()
{	
	//네트웍 오류로 세션이 끊김 재연결 시도.
	CloseChatSession();

	/* 무선 네트워크가 연결 해제 되자 마자 채팅방을 생성하면 대화창 생성 후
	 * GetNewRoom도 호출되지 않은 상태에서 이곳으로 떨어지는데, MAKETYPE_JOIN인 경우 GetNewRoom을 호출하지 않는다.
	 * 예를 들어 무선랜 해제 후 바로 채팅방을 생성하면 다시 네트워크 연결이 되어도 그 방은 방정보가 없기 때문에 대화를 할 수 없다.
	 * 코드 검토 결과 굳이 MakeType 을 JOIN으로 변경해야할 이유가 없는 것 같아 주석처리 하였으나 문제가 생길경우 원복을 해야 한다.
	 * 2013.03.27. Jinwoo Lee
	 */
	//m_chatModel.SetChatRoomMakeType(MAKETYPE_JOIN);
	m_chatModel.SetRoomType(_T("new"));
	m_chatModel.SetSessionReason(REASON_NETWORK_RECOVERY);
	m_chatModel.ResetCreateSessionCheckTimes();

	return NegotiateChatSession();
}

//BOOL CChatDlg::OnCommand(WPARAM wParam, LPARAM lParam)
//{
//	int nID = LOWORD(wParam);
//	switch (nID)
//	{
//	case ID_NEW_CHAT_SEND_MEMO:
//		{
//			DoChatSendMemo();
//		}
//		break;
//	case ID_NEW_CHAT_INVITE:
//		{
//			DoChatInvite();
//		}
//		break;
//	}
//
//	return __super::OnCommand(wParam, lParam);
//}

void CChatDlg::DoChatSendMemo()
{
	std::vector<ReceiverInfo> receiverVector;
	ReceiverInfo receiverInfo;

	CSingleLock lock(m_listChatUser.GetLockObject(), TRUE);
	int nCount = m_listChatUser.GetItemCount();

	CChatUserList::_chat_user_info* pUserInfo = NULL;
	for (int i = 0; i < nCount; i++)
	{
		pUserInfo = (CChatUserList::_chat_user_info*)m_listChatUser.GetItemData(i);
		if (pUserInfo)
		{
			receiverInfo.strID = pUserInfo->strUserID;
			receiverInfo.strName = pUserInfo->strUserName;
			receiverVector.push_back(receiverInfo);
		}
	}

	GET_APP()->m_pSendNoteManager->CreateReceiverInfoListNote(receiverVector);
}


void CChatDlg::DoChatSendFiles()
{
	CString strMultiPath = _T("");
	POSITION startPosition = NULL;

	CString strFileDlgFilter = _T("");
	CString str = _T("");
	str.LoadString(IDS_STRING167);
	strFileDlgFilter.Format(_T("%s(*.*)|*.*||"), str);

//////////////////////////////////////////
	
	CRect rtChatDlg(0, 0, 0, 0);
	GetWindowRect(m_hWnd, &rtChatDlg);
	
	int nSX = rtChatDlg.left+5;
	int nSY =  rtChatDlg.top + 35;

    TCHAR szCurrentPath[MAX_PATH] = {0};
	GetCurrentDirectory(MAX_PATH,szCurrentPath);

	CPoint pt(nSX, nSY);
	//CFileDialog fileDlg(TRUE, NULL, NULL, OFN_EXPLORER | OFN_HIDEREADONLY | OFN_ALLOWMULTISELECT, strFileDlgFilter, NULL);
   CFileDialogEx fileDlg(pt,strFileDlgFilter,this->wnd);
    //fileDlg.m_ofn.Flags |= OFN_ENABLESIZING;
///////////////////////////

	const int c_cbBuffSize = (MAX_TRANSLATE_FILES_COUNT * (MAX_PATH + 1)) + 1;
	fileDlg.GetOFN().lpstrFile = strMultiPath.GetBuffer(c_cbBuffSize);
	fileDlg.GetOFN().nMaxFile = c_cbBuffSize;
	fileDlg.GetOFN().lpstrInitialDir = m_strOpenDirInitPath;

	vector<CString> vecFilePath;
    GET_MESSENGER_DLG()->RegisterMfcModalDlg(&fileDlg);
    int nRet = fileDlg.DoModal();
    GET_MESSENGER_DLG()->UnRegisterMfcModalDlg(&fileDlg);

	if (nRet == IDOK)
	{
		startPosition = fileDlg.GetStartPosition();
		while (startPosition)
		{
			CString strPath = _T("");
			strPath = fileDlg.GetNextPathName(startPosition);
			vecFilePath.push_back(strPath);
		}
		if (!vecFilePath.empty())
		{
			m_strOpenDirInitPath = vecFilePath[0];
			PathRemoveFileSpec(m_strOpenDirInitPath.GetBuffer());
			m_strOpenDirInitPath.ReleaseBuffer();
		}
		this->SetSendFile(vecFilePath);
	}
	strMultiPath.ReleaseBuffer();


	SetCurrentDirectory(szCurrentPath);
}

void CChatDlg::DoChatInvite()
{
	GET_MESSENGER_DLG()->GetWorkGroupController()->OpenAddUserDlg(this->wnd, ADD_USER_FROM_CHAT);
	GET_MESSENGER_DLG()->GetWorkGroupController()->GetWorkView()->GetAddChatWnd()->SetParentChatDlg(this);
	GET_MESSENGER_DLG()->GetWorkGroupController()->GetWorkView()->GetAddChatWnd()->SetInChatRoom(m_chatModel.GetAllUserId());
}


void CChatDlg ::SetWindowPosition(CWindowWnd* pWnd, CWnd* pParentWnd, CRect rcParent,int ww,int hh) //GetWindowRect(pParent->GetSafeHwnd(), &rcParent);
{
	/* font dialog position 
	rcPos.top = rcPos.bottom - 222;

	rcPos.right = rcPos.left +m_rtSplitter.right;
	rcPos.left = rcPos.right - 340;*/
    CRect rcMonitor(0, 0, 0, 0);
	MONITORINFO oMonitor = {};
	oMonitor.cbSize = sizeof(oMonitor);
	::GetMonitorInfo(::MonitorFromWindow(pParentWnd->GetSafeHwnd(), MONITOR_DEFAULTTONEAREST), &oMonitor);
	rcMonitor = oMonitor.rcWork;
	int nLeft = rcParent.left - ww - 5;
	int nRight = rcParent.right + hh + 5;
	if (nLeft<rcMonitor.left && nRight>rcMonitor.right)
	{
		pWnd->CenterWindow();
		pWnd->ShowWindow(true, false);
	
		return;
	}
	if(nLeft < rcMonitor.left)
	{
		nLeft = rcParent.right + 5;
	}
	::SetWindowPos(pWnd->GetHWND(), NULL, nLeft, rcParent.bottom - hh, ww, hh, SWP_FRAMECHANGED | SWP_SHOWWINDOW);
}


LRESULT CChatDlg::OnAddUserToChat(WPARAM wParam, LPARAM lParam)
{
	Node* node = (Node*)wParam;
	vector<CChatUser*> vecUser;
	CString strID = node->data().value;
	GTUserStatusType nUserStatus = GET_MESSENGER_DLG()->GetWorkGroupController()->GetMemberStatus(strID);
	if (nUserStatus != ustOFFLINE)
	{
		CChatUser* pUser = new CChatUser();
		if (NULL != pUser)
		{
			const NE_MEMBER_DATA data = GET_MESSENGER_DLG()->GetWorkGroupController()->m_pModel->GetMember(strID);
			pUser->SetMemberData(data);

			pUser->SetStatus(ustUnknown);
			vecUser.push_back(pUser);
		}
	}//lint !e429
	else
	{
		AlertOfflineUser();
	}
    if (vecUser.size() > 1)
    {
		qsort_s(&(vecUser.at(0)), vecUser.size(), sizeof(CChatUser*), CChatModel::ItemComareFunc, this);

    }
	AddChatUserList(vecUser);

	return 0;
}

void CChatDlg::AddUser(std::vector<NE_MEMBER_DATA>& vAddUsers)
{
	vector<CChatUser*> vecUser;
	std::map<std::wstring, int> memberStatus;

	std::vector<NE_MEMBER_DATA>::const_iterator iter = vAddUsers.begin();

	for(; iter != vAddUsers.end(); ++iter)
	{
		NE_MEMBER_DATA data = *iter;
		GTUserStatusType nUserStatus = GET_MESSENGER_DLG()->GetWorkGroupController()->GetMemberStatus(data.strUserId.c_str());

		if (nUserStatus != ustOFFLINE)
		{
			CChatUser* pUser = new CChatUser();
			if (NULL != pUser)
			{
				pUser->SetMemberData(data);

				pUser->SetStatus(ustUnknown);
				vecUser.push_back(pUser);
			}
		}//lint !e429
        else
		{
			AlertOfflineUser();
		}
	}

	AddChatUserList(vecUser);
}

void CChatDlg::JudgeReadOnly()
{
    //check read only status accroding current status;
    //user can input message(FALSE == bUIReadOnly) when a combination of the following conditions is true
    //  1.(m_bForceLeave == FALSE);  <== NtalkClient_OnPushForceLeave
    //  2.(m_bReadOnlyByNetwork == FALSE) <== CNeMessengerDlg::DisableWindows(FALSE) -> SetReadOnlyAll(FALSE)
    //  3.(m_bRoomEnd == FALSE) <== NtalkClient_OnRoomEnd
    //    TODO: when reset m_bRoomEnd to FALSE ? can reuse Room again after RoomEnd? (add in OnInitRoom)
    //  4.CheckSessionCreateStatus(SESSION_SUCCESS)
    //  5.there is at least one on-line chat user
    //
    //TODO:
    //  6.m_bTryRecoverySession

	BOOL bUIReadOnly = FALSE;
    BOOL bCanInviteUser = TRUE;
    do 
    {
        if (m_bForceLeave)
        {
            //kicked out the room
            bUIReadOnly = TRUE;
            bCanInviteUser = FALSE;
            break;
        }

        if (m_bReadOnlyByNetwork)
        {
            bUIReadOnly = TRUE;
            bCanInviteUser = FALSE;
            break;
        }

        if (m_bRoomEnd)
        {
            bUIReadOnly = TRUE;
            bCanInviteUser = FALSE;
            break;
        }

        //if (!m_chatModel.CheckSessionCreateStatus(SESSION_SUCCESS))
        //{
        //    bUIReadOnly = TRUE;
        //    break;
        //}

        int nUserCnt = m_chatModel.GetChatUserMapCount();
        int nOnlineUser = 0;
        for(int i = 0; i < nUserCnt; i++)
        {
            if (m_chatModel.GetMyID().CompareNoCase(m_chatModel.GetChatUserID(i)) == 0)
                continue;
            if (m_chatModel.IsOfflineUser(m_chatModel.GetChatUserID(i)) == FALSE)
            {
                nOnlineUser++;
                break;
            }
        }
        if (0 == nOnlineUser)
        {
            bUIReadOnly = TRUE;
            break;
        }
    } while (0);


    _SetReadOnly(bUIReadOnly, bCanInviteUser);
}

void CChatDlg::SetChatInfo(int nSeqNumber, const vector<CChatUser*>& userList, EChatMakeType enumMakeType)
{
	m_chatModel.SetChatInfo(nSeqNumber, userList, enumMakeType);

	ProcUregFavoriteFromPOI();
}

BOOL CChatDlg::_IsReadOnlyStatus()
{
	BOOL bReadOnlyStatus = FALSE;

	//COLORREF backupColor =  m_editSend.SetBackgroundColor(FALSE, DEF_CHAT_SEND_EDIT_DISABLE_COLOR);
	//m_editSend.SetBackgroundColor(FALSE, backupColor);

	//if (backupColor ==  DEF_CHAT_SEND_EDIT_DISABLE_COLOR)
	//{
	//	bReadOnlyStatus = TRUE;
	//}

	//CRichEditUI* pEditChat =  static_cast<CRichEditUI*>(m_PaintManager.FindControl(_T("edit_chat")));

	if(m_pEditChat && m_pEditChat->IsReadOnly())
		bReadOnlyStatus = TRUE;

	return bReadOnlyStatus;
}


void CChatDlg::SetAllUserOffline()
{
	std::vector<CChatUser*> chatUsrArray;
	m_chatModel.GetChatUserArray(chatUsrArray);
	CChatLeftList* pChatList = static_cast<CChatLeftList*>(m_PaintManager.FindControl(kChatList));
	if (pChatList != NULL)
	{
		for(std::vector<CChatUser*>::iterator it = chatUsrArray.begin();
			it != chatUsrArray.end(); it++)
		{
			pChatList->UpdateStatus(*it, ustOFFLINE);
		}
	}
	
	m_chatModel.SetAllChatUserOffline();
}

void CChatDlg::_SetReadOnly( BOOL bReadOnly, BOOL bCanInviteUser)
{
	if (bReadOnly == _IsReadOnlyStatus())
		return;

	EnableDragAndDrop(!bReadOnly || bCanInviteUser);

	if (m_pEditChat)
	{
		m_pEditChat->SetReadOnly(bReadOnly);
		if (bReadOnly)
		{
			m_pEditChat->SetBkColor(0xFFc8c8c8);
			m_pEditChat->ShowCaret(FALSE);
			m_pEditChat->SetWantReturn(false);
		}
		else	// Enable
		{
			m_pEditChat->SetBkColor(0xFFFFFFFF);
			m_pEditChat->ShowCaret(TRUE);	
			m_pEditChat->SetWantReturn(true);
			InitRichEditCtrl();
			SetInputStatusText(_T(""));
			ProcRegiFavoriteToPOI();
		}
	}

	bool bEnable = !bReadOnly;
	if (m_pBtnFile)
	{
		m_pBtnFile->SetEnabled(bEnable);
	}
	if (m_pBtnSticker)
	{
		m_pBtnSticker->SetEnabled(bEnable);
	}
	if (m_pBtnText)
	{
		m_pBtnText->SetEnabled(bEnable);
	}
	if (m_pBtnAddUser)
	{
		m_pBtnAddUser->SetEnabled(bEnable || bCanInviteUser);
	}
	if (m_pBtnSearch)
	{
		m_pBtnSearch->SetEnabled(bEnable || bCanInviteUser);
	}
	if (m_pSearchEdit)
	{
		m_pSearchEdit->SetEnabled(bEnable || bCanInviteUser);
	}
	if (m_pSearchLabel)
	{
		m_pSearchLabel->SetEnabled(bEnable || bCanInviteUser);
	}
	wnd->Invalidate();
}

void CChatDlg::SetReadOnly(BOOL bReadOnly, BOOL bNetwork)
{
    ASSERT(bNetwork && TEXT("this public function can call just for network")); //lint !e506
    m_bReadOnlyByNetwork = bReadOnly;

    if (bNetwork)
    {
        if (bReadOnly)
        {
            //TODO
            //m_listChatUser need to be remove, 
            //And, CChatLeftList need it self's lock to ensure thread safe.
            CSingleLock lock(m_listChatUser.GetLockObject(), TRUE);

            //ProcRegiFavoriteToPOI only notify the user on line when the user does not 
            //change his/her status. so, when network error, set all user off line as default.
            SetAllUserOffline();	
        }
        else
        {
            if (RecoveryNetworkError() == true)
            {
                if (m_chatModel.GetChatUserMapCount() > 0)
                {
                    ProcRegiFavoriteToPOI();
                }			
            }
            else
            {
                SetTimer(m_hWnd, TIMER_CHAT_RECOVERY_NETWORK, 3000, NULL);
            }		
        }
    }

    JudgeReadOnly();    
}

CString	CChatDlg::GetAllUserNameFromList()
{
	CChatLeftList* pChatList = static_cast<CChatLeftList*>(m_PaintManager.FindControl(kChatList));
	if (pChatList == NULL)		return _T("");
	Node* node = NULL;
	bool bFirst = true;
	CString resultString(_T(""));
	if ( pChatList->GetRoot()->num_children() < 1)
		return LoadStringFromResource(IDS_STRING_NO_CONTACT);

	for (int i = 0; i < pChatList->GetRoot()->num_children(); i++)
	{
		node = pChatList->GetRoot()->child(i);
		if(!node || node->data().value.CompareNoCase(m_chatModel.GetMyID()) == 0)	//Modify by sevin, "value" is user ID
		{
			continue;
		}		
		if (bFirst)
		{
			bFirst = false;
		}
		else
		{
			resultString += SPLIT_STRING;
		}

		resultString += node->data().text_;
	}

	return resultString;
}

CString	CChatDlg::GetAllUserIDFromList()
{
	CChatLeftList* pChatList = static_cast<CChatLeftList*>(m_PaintManager.FindControl(kChatList));
	if (pChatList == NULL)	
	{
		return _T("");
	}
	Node* node = NULL;
	bool bFirst = true;
	CString strAllUserID = _T("");
	if ( pChatList->GetRoot()->num_children() == 0)
	{
		return _T("");
	}

	for (int i = 0; i < pChatList->GetRoot()->num_children(); i++)
	{
		node = pChatList->GetRoot()->child(i);
		if(!node || node->data().value.CompareNoCase(m_chatModel.GetMyID()) == 0)
		{
			continue;
		}		
		if (bFirst)
		{
			bFirst = false;
		}
		else
		{
			strAllUserID += SPLIT_STRING;
		}

		strAllUserID += node->data().value;
	}

	return strAllUserID;
}

void CChatDlg::ResortChatListByName()
{
	vector <CChatUser*> VectorMembers = m_chatModel.GetSortedChatUserVector();
	if(VectorMembers.size() > 1)
	{
		qsort_s(&(VectorMembers.at(0)), VectorMembers.size(), sizeof(CChatUser*), CChatModel::ItemComareFunc, this);
	}
	CChatLeftList* pChatList = static_cast<CChatLeftList*>(m_PaintManager.FindControl(kChatList));
    if (pChatList != NULL)
	{
        BOOL bChanged = FALSE;
        //check whether order has changed, so avoid unnecessarily remove all then add
        int nCount = pChatList->GetRoot()->num_children();
        if (nCount != VectorMembers.size())
        {
            bChanged = TRUE;
        }
        else
        {
            Node* node = NULL;
            for (int index = 0; index < nCount; index++)
            {
                node = pChatList->GetRoot()->child(index);
                if(node)
                {
                    if(VectorMembers[index]->GetName() != node->data().text_)
                    {
                        bChanged = TRUE;
                        break;
                    }
                }
            }
        }
        if (bChanged)
        {
			int ChildCount = pChatList->GetRoot()->num_children();
            CChatLeftList* pFriendsList = static_cast<CChatLeftList*>(m_PaintManager.FindControl(kChatList));
			vector<CChatUser*>::const_iterator itr = VectorMembers.begin();
			CString usrID ;
			int index = 0;
			for(; itr != VectorMembers.end(); ++itr)
			{
				CListContainerElementUI* pListElement = NULL;
				CChatUser* pr = *itr;
				usrID = pr->GetID();
				
				Node* foundNode = pFriendsList->FindNodeByUserID(usrID);
				if (foundNode)
				{
					pFriendsList->GetRoot()->reinsert_child(foundNode,index);////reinsert_child()请看cpp文件的函数说明。
					pListElement = foundNode->data().list_elment_;
					pFriendsList->SetItemIndex(pListElement,index);
					index ++;
				}

			}
            RefreshTitle(false);
        }
    }
}

CChatLeftList* CChatDlg::GetLeftList()
{
	return static_cast<CChatLeftList*>(m_PaintManager.FindControl(kChatList));
}



void CChatDlg::UpdateStatus(GTUserStatusType stStatus, int nItem, CString strUserID)
{	
	m_chatModel.SetChatUserStatus(strUserID, stStatus);
	m_chatModel.UpdateAllChatItemUserStatus(strUserID,stStatus );
	
	CTime CurTime(CTime::GetCurrentTime());
	CString szTime = CurTime.Format("'%Y-%m-%d %H:%M:%S'");
//	NTALK_LOG->Debug(_T("[%s][CChatDlg::UpdateStatus]GTUserStatusType stStatus(%d), CString strUserID(%s))"),szTime,(int)stStatus,strUserID);
	CChatLeftList* pChatList = static_cast<CChatLeftList*>(m_PaintManager.FindControl(kChatList));
	if (pChatList != NULL)
	{
		CChatUser* pChatUser = m_chatModel.GetChatUsrPtr(strUserID);
		if(NULL == pChatUser)
		{
			return;
		}
		pChatList->UpdateStatus(pChatUser, stStatus);
        

		ResortChatListByName();
	}
	
	if (m_chatModel.GetMyID().CompareNoCase(strUserID) == 0)
	{
		return;
	}

    JudgeReadOnly();
}

void CChatDlg::UpdateIPTStatus(NTIPTStatusType eIPTStatus, int nItem, CString strUserID)
{
	CSingleLock lock(m_listChatUser.GetLockObject(), TRUE);
	CChatUserList::_chat_user_info* pChInfo = (CChatUserList::_chat_user_info*)m_listChatUser.GetItemData(nItem);
	
	if (pChInfo)
		pChInfo->eIPTStatus = eIPTStatus;

	m_listChatUser.Update(nItem);

	m_chatModel.SetChatUserIptStatus(strUserID, eIPTStatus);
}

BOOL CChatDlg::InitChatRoom()
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);
	BOOL result = TRUE;

	if (m_chatModel.IsOldRoomType() == TRUE)
		return result;

	if (m_chatModel.CheckinitRoomStatus(INITROOM_SUCCESS))
		return result;

	if( m_chatModel.CheckinitRoomStatus(INITROON_UNINITIALIZED) )
	{
		m_chatModel.SetInitRoomStatus(INITROOM_ONGOING);
		
		if(m_pNtalk)
			result = m_pNtalk->RequestInitRoom();
		
		if(result == FALSE)
		{
            NTALK_LOG->Error(L"REQUESTINITROOM FAIL");
			m_chatModel.SetInitRoomStatus(INITROON_UNINITIALIZED);
			return result;
		}
	}

	int retryCount = 0;
	while (1)
	{
		if ( m_chatModel.CheckinitRoomStatus(INITROOM_SUCCESS) )
			break;
		else if ( m_chatModel.CheckinitRoomStatus(INITROOM_ERROR) )
		{
			result = FALSE;
			break;
		}
		else if ( m_chatModel.CheckinitRoomStatus(INITROOM_ONGOING) )
		{
			++retryCount;

			if (retryCount > RETRY_COUNT) 
			{
				result = FALSE;
				m_chatModel.SetInitRoomStatus(INITROON_UNINITIALIZED);
				break;
			}
			Sleep(RETRY_SLEEP);
		}
	}

	return result;
}

BOOL CChatDlg::RequestTyping(BOOL bFirstStatus)
{	
	CString str;
    //FTLTRACE(TEXT("RequestTyping: %d\n"), bFirstStatus);

    NTalkTyping state = bFirstStatus ? typeTyping : typeNonTyping;
	m_bBeforeStatusOfTyping = bFirstStatus;
	BOOL bRet = FALSE;
    if(m_pNtalk){
		bRet = m_pNtalk->RequestTyping(state);
    }

	return bRet;
}

void CChatDlg::PostNcDestroy()
{
	PostNcDestroy();

	g_pMessengerActor->GetWASActor()->UnRegisterObserver(this);	
	//g_pMessengerActor->UnRegisterObserver(this);

	delete this;
}

void CChatDlg::FlashEffect(bool bSound)
{
	DWORD dFlags = FLASHW_ALL | FLASHW_TIMER;;
	GTUserStatusType status = GET_MESSENGER_DLG()->GetMainFrame()->GetMyStatus();
	bool ShieldSoundOffline = false;


	int SoundChat = GET_CONFIG()->GetChatSound();
	int SoundNotOnline = GET_CONFIG()->GetSoundNotOnline();
	if ( !GET_CONFIG()->GetSoundNotOnline() && status != ustONLINE)
	{
		ShieldSoundOffline = true;
	}
   
	bool Forbidden1 =  (GET_CONFIG()->GetChatSound() == 0)? true:false;
	bool Forbidden2 = (true == ShieldSoundOffline) ? true:false;
	//bool Forbidden3 =  (GET_CONFIG()->GetNotifyOnMailOrSMS() == 0)? true:false;
	// Any one forbid of the three will off the sound, so all of them must be false; 
	if (bSound && !Forbidden1 && !Forbidden2 )
	{
		PlaySound(_T(".\\SOUNDS\\NT_tr.wav"), NULL, SND_ASYNC);
	}

	
	
	m_bFlashFlag=true;
	wnd->FlashWindowEx(dFlags,0,0);
}

bool CChatDlg::IsFocused()
{
	HWND hWndFocus = ::GetForegroundWindow();
	if (hWndFocus == m_hWnd)
		return true;

	return false;
}

void CChatDlg::DisplayPopupAndFlashEffect( CHAT_MSG* pItem, CString strMyID )
{
	GTUserStatusType status = GET_MESSENGER_DLG()->GetMainFrame()->GetMyStatus();
    bool ShieldSoundOffline = false;

	int SoundChat = GET_CONFIG()->GetChatSound();
	int SoundNotOnline = GET_CONFIG()->GetSoundNotOnline();
	if (!GET_CONFIG()->GetSoundNotOnline() && status != ustONLINE)
	{
		ShieldSoundOffline = true;
	}
	bool Forbidden1 =  (GET_CONFIG()->GetChatSound() == 0)? true:false;
	bool Forbidden2 = (true == ShieldSoundOffline) ? true:false;

	DWORD dFlags = FLASHW_ALL | FLASHW_TIMER;
	if ((0 != pItem->strID.CompareNoCase(strMyID) && false == IsFocused()) ||
		!IsWindowVisible(m_hWnd))
	{
		m_bFlashFlag = true;
		
		if (status != ustBUSY)
		{		
				
			if ( !Forbidden1&& !Forbidden2)
			{
				PlaySound(_T(".\\SOUNDS\\NT_dia.wav"), NULL, SND_ASYNC);
			}
		
			wnd->FlashWindowEx(dFlags, 0, 0);
		}
		
		GET_MESSENGER_DLG()->GetMainFrame()->UpdateUnReadMessage(TRUE, m_chatModel.GetRoomID());
		GET_MESSENGER_DLG()->GetMainFrame()->UpdateChatRoomList(this);
	}
	else
	{

	}

	if (IsIconic() && status != ustBUSY)
	{
		if(GET_CONFIG()->GetNotifyOnNews()){
			m_chatModel.SetTrayPopupInfo(pItem->strID,pItem->strName, pItem->pszMsg, pItem->msgType);
			PostMessage(WM_CHATMSGPOPUPTRAYDLG, 0, 0);
		}
	}
}

void CChatDlg::DisplayPopupAndFlashEffect(TranslateFileInfoPtr pFileInfo, CString strMyID )
{
	DWORD dFlags = FLASHW_ALL | FLASHW_TIMER;;
	GTUserStatusType status = GET_MESSENGER_DLG()->GetMainFrame()->GetMyStatus();
	bool ShieldSoundOffline = false;


	int SoundChat = GET_CONFIG()->GetChatSound();
	int SoundNotOnline = GET_CONFIG()->GetSoundNotOnline();
	if (!GET_CONFIG()->GetSoundNotOnline() && status != ustONLINE)
	{
		ShieldSoundOffline = true;
	}
	bool Forbidden1 =  (GET_CONFIG()->GetChatSound() == 0)? true:false;
	bool Forbidden2 = (true == ShieldSoundOffline) ? true:false;

	if ((0 != pFileInfo->m_strSenderID.CompareNoCase(strMyID) && false == IsFocused()) || !IsWindowVisible(m_hWnd))
	{
		m_bFlashFlag = true;
		if (status != ustBUSY)
		{
			if  (!Forbidden1 && !Forbidden2)
			{
				PlaySound(_T(".\\SOUNDS\\NT_dia.wav"), NULL, SND_ASYNC);
			}
		
			wnd->FlashWindowEx(dFlags, 0, 0);
		}
		
		GET_MESSENGER_DLG()->GetMainFrame()->UpdateUnReadMessage(TRUE, m_chatModel.GetRoomID());
		GET_MESSENGER_DLG()->GetMainFrame()->UpdateChatRoomList(this);
	}
	else
	{

	}
	if (IsIconic() && status != ustBUSY)
	{
		if(GET_CONFIG()->GetNotifyOnNews()){
			m_chatModel.SetTrayPopupInfo(pFileInfo->m_strSenderID, pFileInfo->m_strName, pFileInfo->m_fileInfo.fileName.c_str(), DEF_FTP_MSG_TYPE);
			PostMessage(WM_CHATMSGPOPUPTRAYDLG, 0, 0);
		}
		
	}
}

void CChatDlg::OnTimer(UINT_PTR nIDEvent,BOOL& bHandled)
{
	if (nIDEvent == TIMER_CHAT_RECOVERY_NETWORK)	// 네트워크 복구가 시도 되어야 하는 경우: SetReadOnly(FALSE)에서 호출된다.
	{
        //why kill it and start it again?
		KillTimer(m_hWnd, TIMER_CHAT_RECOVERY_NETWORK);
        JudgeReadOnly();
        //SetReadOnly(FALSE, TRUE); 
	}
	else if (nIDEvent == TIMER_CHAT_SENDMSG_ACK)	// 대화 전송 ACK 체크
	{
		KillTimer(m_hWnd, TIMER_CHAT_SENDMSG_ACK);
		CheckSendMsgAck();
	}
	else if (nIDEvent == TIMER_CHAT_CHECK_SESSIONSTATUS)	// 채팅 세션 연결 중 상태 체크
	{
		KillTimer(m_hWnd, TIMER_CHAT_CHECK_SESSIONSTATUS);
		CheckSessionStatus();
	}
	else if (nIDEvent == TIMER_CHAT_CHECK_PING)	// 채팅 서버 PING 체크
	{
		KillTimer(m_hWnd,TIMER_CHAT_CHECK_PING);

		// 채팅 세션이 복구되어야 하는 상황
		if( m_chatModel.CheckSessionCreateStatus(SESSION_ERROR) || m_pNtalk == NULL || m_nPingPongCount > 3 )
		{
			if (RecoveryNetworkError() == true)
			//	if (m_wndChatStatus.GetSafeHwnd())m_wndChatStatus.SetStatusText(_T(""));	// 스테이터스 바의 에러 메시지를 없앤다.
			{
				  //TODO--input status
				SetInputStatusText(_T(""));

			}

			m_nPingPongCount = 0;
		}
		// 채팅 세션이 정상
		else
		{
			if( m_chatModel.CheckSessionCreateStatus(SESSION_SUCCESS) )	// 채팅 세션이 정상이라고 속고있을 수 있으므로 PING체크
			{
				m_pNtalk->RequestSendPing();
				m_nPingPongCount++;
			}

			// 채팅 세션 연결 중인 상태 do nothing.
		}

		SetTimer(m_hWnd,TIMER_CHAT_CHECK_PING, INTERVAL_CHECK_PING, NULL);
	}
	else if (nIDEvent == TIMER_CHAT_REQUEST_EMP_INFO)
	{
		KillTimer(m_hWnd, TIMER_CHAT_REQUEST_EMP_INFO);
		RequestChatUserInfo();
	}
	else if(nIDEvent == TIMER_CHAT_CHECK_SENDFILE)
	{
		KillTimer(m_hWnd, TIMER_CHAT_CHECK_SENDFILE);
		CheckSendFileAck();
	}
	else if ( TIMER_CHAT_CHECK_INPUTTING == nIDEvent)
	{
        if (m_bBeforeStatusOfTyping)
        {
            DWORD dwCurTicket = GetTickCount();
            if (dwCurTicket > m_dwLastTypingTicket + INTERVAL_CHECK_TYPEING
                || dwCurTicket < m_dwLastTypingTicket) //overflow
            {
                RequestTyping(FALSE);
                m_dwLastTypingTicket = 0;
                m_dwLastSendTypingTicket = 0;
            }
        }
	}
    else if( TIMER_CHAT_CHECK_RECV_INPUTTING == nIDEvent)
    {
        if(m_chatModel.CheckInputActionUserTimeOut(MAX_CHECK_RECV_TYPEING_TIMEOUT))
        {
            CString strStatusMsg = _T("");
            CString strUserNames = m_chatModel.GetInputActionUserString();
            if (!strUserNames.IsEmpty())
            {
                strStatusMsg.Format(_T("%s %s"), strUserNames, LoadStringFromResource(IDS_STRING140));
            }
            SetInputStatusText(strStatusMsg);
        }
    }
	else
	{
		bHandled = FALSE;
	}
}

void CChatDlg::AssignDefaultFont()
{
	memset(&m_cf, 0, sizeof(CHARFORMAT2));  //lint !e1415
	m_cf.cbSize = sizeof(CHARFORMAT2);
	m_cf.dwMask = CFM_COLOR|CFM_SIZE|CFM_FACE|CFM_WEIGHT;
	m_cf.dwEffects = 0; // To disable CFE_AUTOCOLOR		
	m_cf.yOffset = 0;
	m_cf.crTextColor = RGB(0, 0, 0);

	if (CHAT_BUBBLE == GET_CONFIG()->GetChatDisplayType())
	{
		m_cf.yHeight = BUBBLE_SYSMSG_FONT_SIZE * 20;	
		_tcscpy_s(m_cf.szFaceName, LF_FACESIZE, DEFAULT_KOREAN_FONT_NAME_T);
	}
	else
	{
		m_cf.yHeight = PLAIN_SYSMSG_FONT_SIZE * 20;	
		_tcscpy_s(m_cf.szFaceName, LF_FACESIZE, DEFAULT_KOREAN_FONT_NAME_T);
	}

	m_chatModel.SetRecvChatViewDefaultFont(&m_cf);
}

BOOL CChatDlg::IsNeedMinimize(LPCTSTR strUserID)
{
	BOOL bRes = FALSE;

	if (m_chatModel.IsGroupRoom() == TRUE &&
		m_chatModel.GetChatRoomMakeType() == MAKETYPE_INVITE)
	{
		return FALSE;
	}

	if (!m_chatModel.IsExistChatUserItem() && 
		m_chatModel.GetChatRoomMakeType() != MAKETYPE_CREATE && 
		m_chatModel.GetChatRoomMakeType() != MAKETYPE_JOIN &&
		m_chatModel.GetChatRoomMakeType() != MAKETYPE_FORCEJOIN /*&&
		m_chatModel.GetMyID().CompareNoCase(strUserID) != 0*/)
	{
		bRes = TRUE;
	}

	return bRes;
}

void CChatDlg::AssignDropTarget()
{
	m_DT.Register(this->wnd);
	m_DT.SetChatDialog(this);

}

void CChatDlg::AssignMenuandIcon()
{
	SetIcon(IDR_MAINFRAME);
}

void CChatDlg::SetMyInfo()
{
	GT_MY_USER_DATA stMyData;
	g_pMessengerActor->GetMyUserInfo(stMyData);
	m_chatModel.SetMyUserData(&stMyData);
}

void CChatDlg::RegisterObserver()
{
	g_pMessengerActor->GetWASActor()->RegisterObserver(this);	
}

void CChatDlg::RequestNewRoom()
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);


	if (m_chatModel.GetChatRoomMakeType() == MAKETYPE_CREATE && !m_chatModel.IsValidServerInfo())
	{
		CString strMyName;
		strMyName.Format(_T("%s|%s"), m_chatModel.GetMyName(), m_chatModel.GetMyTalkName());

		CString strBuddyId = _T("");
		CString strBuddyName = _T("");

		if (!m_chatModel.IsGroupRoom())
		{
			strBuddyId = m_chatModel.GetChatUserID(0);
			strBuddyName.Format(_T("%s|%s"), m_chatModel.GetChatUserName(strBuddyId), m_chatModel.GetChatUserNickName(strBuddyId));
		}

		g_pMessengerActor->GetWASActor()->RequestGetNewRoom(m_chatModel.GetMyID(), strMyName, strBuddyId, strBuddyName, &m_trid);
	}
}

void CChatDlg::RegisterWindowandCreateButtons()
{
	CString strTmpClassName = _T("");
	
	strTmpClassName.Format(_T("Ntalk_ChatStatus_%X%X%X"),
		GetTickCount(),
		GetCurrentProcessId(),
		GetCurrentThreadId());
	::RegisterWindowClass(strTmpClassName);

	CRect rtChatStatus(0, 0, 0, 0);
	if (m_wndChatStatus.Create(strTmpClassName, _T("Ntalk_ChatStatus"), WS_CHILD /*| WS_VISIBLE */| WS_CLIPCHILDREN | WS_CLIPSIBLINGS, rtChatStatus, this->wnd, ID_NEW_CHAT_STATUS))
	{
		m_wndChatStatus.SetImgBGPath(_T("Chat_Status_BG.png"));
		m_wndChatStatus.SetFontConfig(g_defaultFontFaceName, 9, FontStyleRegular, Color(255, 126, 133, 148));
	}
}

void CChatDlg::AssignChatEditCharformat()
{
	CHARFORMAT2 cf;
	ZeroMemory(&cf, sizeof(CHARFORMAT2));

	if (GET_CONFIG()->LoadChatFont(&cf))
	{
        cf.yHeight = 9*20;
		m_pEditChat->SetDefaultCharFormat(cf);
		m_pEditChat->SetTextColor(0);    

		m_chatModel.SetSendChatViewUserFont(&cf);
	}
	else
	{
		CHARFORMAT2 defaultEditCf = m_cf;
        defaultEditCf.yHeight = 9 * 20;
		m_pEditChat->SetDefaultCharFormat(defaultEditCf);
		m_pEditChat->SetTextColor(0xFF000000);
		m_chatModel.SetSendChatViewUserFont(&m_cf);
	}
}

void CChatDlg::RemoveAllUser()
{
	m_chatModel.RemoveChatUserMap(TRUE);

	CSingleLock lock(m_listChatUser.GetLockObject(), TRUE);

	m_listChatUser.ClearUserListItem();
	CChatLeftList* pFriendsList = static_cast<CChatLeftList*>(m_PaintManager.FindControl(kChatList));
	if (pFriendsList != NULL)
	{
		pFriendsList->RemoveAll();
	}
	//AddMyInfoToChatUserList();	// 내 정보는 다시 넣어주어야 강제퇴장 후 다시 초대되었을때 내 정보가 빠지지 않는다.
}

void CChatDlg::RemoveUser(LPCTSTR strUserID)
{
	int nIndex = m_chatModel.FindUserMap(strUserID);
	if (nIndex >= 0)
	{
		m_chatModel.RemoveChatUserMap(FALSE, strUserID);
	}
    m_chatModel.SortChatUserVector();
	//그룹채팅일 경우 나간 유저를 리스트박스에서 지워준다.
	CChatUserList::_chat_user_info* pChInfo = NULL;

	CSingleLock lock(m_listChatUser.GetLockObject(), TRUE);
	CChatLeftList* pFriendsList = static_cast<CChatLeftList*>(m_PaintManager.FindControl(kChatList));
	if (pFriendsList != NULL)
	{
		pFriendsList->RemoveNodeByUserID(strUserID);
	}
	
	int nUserCount = m_listChatUser.GetItemCount();
	for(int i = 0; i < nUserCount; i++)
	{
		pChInfo = (CChatUserList::_chat_user_info*)m_listChatUser.GetItemData(i);
		if (pChInfo)
		{
			if (pChInfo->strUserID.CompareNoCase(strUserID) == 0)
			{
				//must first ensure then del
				m_listChatUser.EnsureVisible(0, FALSE);

				m_listChatUser.DeleteItem(i);
				delete pChInfo;
				break;
			}
		}
	}
}

void CALLBACK CChatDlg::NtalkClient_OnServerSessionEnd( INTalkClient* pNtClient )
{
	NTALK_LOG->Debug(L"[CHAT] OnServerSessionEnd, %d", GetRoomID());
	RecoveryServerSession();
}

void CChatDlg::RecoveryServerSession()
{
    NTALK_LOG->Debug(L"[CHAT] RecoveryServerSession, %d, %d", m_bTryRecoverySession, m_chatModel.GetRoomID());
	if (m_bTryRecoverySession != TRUE)
	{
		JudgeReadOnly();
		return;
	}

	DisplayServerSessionEndMessage();

	m_chatModel.SetSessionCreateStatus(SESSION_UNINITIALIZED);
	m_chatModel.SetChatRoomMakeType(MAKETYPE_JOIN);	// MAKETYPE_JOIN으로 설정해 주어야 세션 복구후 방에 자동으로 조인한다.
	m_chatModel.SetRoomType(_T("new"));

	m_chatModel.SetSessionReason(REASON_SESSION_RECOVERY);
	m_chatModel.ResetCreateSessionCheckTimes();

	NegotiateChatSession(); //실패했을때 어떻게 할건지..
	// ReadOnly 상태는 여기서 풀지 말고 복구가 되고 나면 풀어야 한다.

    JudgeReadOnly();
}

void CChatDlg::CheckSendMsgAck()
{
	BOOL bUpdateUI = FALSE;
	vector<CHAT_MYMSG*> vecMyMsg;
	m_chatModel.CheckSendMsgAck(vecMyMsg);	

	vector<CHAT_MYMSG*>::const_iterator fail_iter = vecMyMsg.begin();
	for (; fail_iter != vecMyMsg.end(); ++fail_iter)
	{
		bUpdateUI = TRUE;
		CHAT_MYMSG* pMyMsg = (CHAT_MYMSG*)(*fail_iter);		
		
// 		CString strFailMsg;
// 		strFailMsg.Format(_T("메세지 전송 실패 : %s"), pMyMsg->strMessage);
// 		CTime time(CTime::GetCurrentTime());
// 
// 		//m_pChatMainView->AddChatItem(_T(""), _T(""), _T(""), time, strFailMsg, m_cf);
// 		ChatItemInfo stChatItemInfo(strFailMsg, time, m_cf);
// 		m_pChatMainView->AddChatItem(&stChatItemInfo, true);


		m_chatModel.IncreaseFailCount(m_chatModel.GetMyID(),pMyMsg->nTid);
		SQLITE3.UpdateMsgStatus(m_chatModel.GetRoomID(),m_chatModel.GetMyID(),pMyMsg->nTid,CMS_FAIL);
		m_chatModel.UpdateMsgStatus(m_chatModel.GetMyID(),pMyMsg->nTid,CMS_FAIL);

		NTALK_LOG->Debug(L"[CHAT] CheckSendMsgAck, tid=%d",pMyMsg->nTid);
		m_chatModel.AckMyMessageTid((UINT)(pMyMsg->nTid));

		int nIndex = m_chatModel.GetChatItemIndex(m_chatModel.GetMyID(),pMyMsg->nTid);
		if (nIndex != -1)
		{
			m_pChatMainView->UpdateElementStateByIndex(nIndex);
		}

	}

	if (vecMyMsg.empty() == false)
	{
		NTALK_LOG->Debug(L"[CHAT] CheckSendMsgAck::네트워크 복구");
		RecoveryServerSession();
	}

	if (bUpdateUI)
	{
		m_pChatMainView->UpdateView();
	}

	SetTimer(m_hWnd, TIMER_CHAT_SENDMSG_ACK, 3000, NULL);
}

void CChatDlg::CancelTransferFile()
{
	vector<TranslateFileInfoPtr> vecMyTranFile;
	m_chatModel.CancelTransferFile(vecMyTranFile);	

	vector<TranslateFileInfoPtr>::const_iterator fail_iter = vecMyTranFile.begin();
	for (; fail_iter != vecMyTranFile.end(); ++fail_iter)
	{
		TranslateFileInfoPtr pTranslateFileInfo = (TranslateFileInfoPtr)(*fail_iter);		

		SQLITE3.UpdateMsgStatus(m_chatModel.GetRoomID(),m_chatModel.GetMyID(),pTranslateFileInfo->m_TidRequestFileTranslate,sUploadCancle);

		NTALK_LOG->Debug(L"[CHAT] CancelTransferFile, tid=%d",pTranslateFileInfo->m_TidRequestFileTranslate);
	}
}
void CChatDlg::CheckSendFileAck()
{
	BOOL bUpdateUI = FALSE;
	vector<TranslateFileInfoPtr> vecMyTranFile;
	m_chatModel.CheckSendFileMsgAck(vecMyTranFile);	

	vector<TranslateFileInfoPtr>::const_iterator fail_iter = vecMyTranFile.begin();
	for (; fail_iter != vecMyTranFile.end(); ++fail_iter)
	{
		bUpdateUI = TRUE;
		TranslateFileInfoPtr pTranslateFileInfo = (TranslateFileInfoPtr)(*fail_iter);		
		//SendFileNotify(pTranslateFileInfo);

		m_chatModel.IncreaseFailCount(pTranslateFileInfo->m_strSenderID,pTranslateFileInfo->m_TidRequestFileTranslate);
		SQLITE3.UpdateMsgStatus(m_chatModel.GetRoomID(),m_chatModel.GetMyID(),pTranslateFileInfo->m_TidRequestFileTranslate,sUploadError);
		m_chatModel.UpdateMsgStatus(m_chatModel.GetMyID(),pTranslateFileInfo->m_TidRequestFileTranslate,sUploadError);

		NTALK_LOG->Debug(L"[CHAT] CheckSendFileAck, tid=%d",pTranslateFileInfo->m_TidRequestFileTranslate);

        //send file notify fail
        //m_chatModel.AckMyTranslateTid((UINT)(pTranslateFileInfo->m_TidRequestFileTranslate));
        pTranslateFileInfo->SetResultByLastError(ERROR_LOST_WRITEBEHIND_DATA_NETWORK_SERVER_ERROR);

		int nIndex = m_chatModel.GetChatItemIndex(m_chatModel.GetMyID(),pTranslateFileInfo->m_TidRequestFileTranslate);
		if (nIndex != -1)
		{
			m_pChatMainView->UpdateElementStateByIndex(nIndex);
		}
	}

	//if (vecMyTranFile.empty() == false)
	//{
	//	//GT_FLOG_NOARG(L"CheckSendMsgAck::네트워크 복구");
	//	RecoveryServerSession();
	//}

	if (bUpdateUI)
	{
		m_pChatMainView->UpdateView();
	}
	SetTimer(m_hWnd, TIMER_CHAT_CHECK_SENDFILE, 3000, NULL);
}
void CChatDlg::OnChangeDisplayStyle()
{
	m_pChatMainView->SetChatDisplayType(GET_CONFIG()->GetChatDisplayType());
	m_pChatMainView->UpdateScrollInfo();
	m_pChatMainView->ScrollToLastchatItem();
	m_pChatMainView->UpdateView();
}

void CChatDlg::CheckSessionStatus()
{
	TRACE("%s %d\n", __FUNCTION__, __LINE__);

	if (m_chatModel.CheckSessionCreateStatus(SESSION_SUCCESS))
	{
		m_chatModel.SetSessionReason(REASON_NONE);
	}
	else if (m_chatModel.CheckSessionCreateStatus(SESSION_ERROR))
	{		
		m_chatModel.SetSessionReason(REASON_SESSION_RECOVERY);
		m_chatModel.ResetCreateSessionCheckTimes();
		NegotiateChatSession();
	}
	else if (m_chatModel.CheckSessionCreateStatus(SESSION_ONGOING))
	{
		SetTimer(m_hWnd, TIMER_CHAT_CHECK_SESSIONSTATUS, INTERVAL_CHECK_SESSIONSTATUS, NULL);
	}	

    JudgeReadOnly();
}

unsigned int __stdcall CChatDlg::InviteChatUserThd( LPVOID pArg )
{
	CChatDlg* pDlg = (CChatDlg*)pArg;
	pDlg->InitChatRoom();
	pDlg->InviteChatUser();

	_endthreadex(0);
	return 1;
}

// 대화 상대의 변화에 따라 사용자 리스트 영역과 메인 창의 크기를 조절한다 
void CChatDlg::ResizeUserListCtrlHeight(int nUserCount)
{
	if (nUserCount < USERLIST_RESIZING_MINIMUM_USER_NO)			// 사용자 리스트에 보여질 최소 사용자 수
		nUserCount = USERLIST_RESIZING_MINIMUM_USER_NO;
	else if (nUserCount > USERLIST_RESIZING_MAXIMUM_USER_NO)	// 사용자 리스트에 보여질 최대 사용자 수
		nUserCount = USERLIST_RESIZING_MAXIMUM_USER_NO;

    CRect rtChatUserList(0, 0, 0, 0);
	m_listChatUser.GetWindowRect(&rtChatUserList);

	// DoSplitter의 파라미터로 기존 크기에서 변화된 값을 넘겨주어야 하기 때문에 현재의 유저 리스트 윈도의 높이를 빼준다.
	// 리스트 컨트롤의 아이템 간격이 1이어서 +1을 더한 후 유저수를 곱하여 높이를 계산한다.
	int nUserListCtrlHeight = (DEF_CHAT_USERLIST_ITEM_HEIGHT) * nUserCount - rtChatUserList.Height();
	//m_wndChatSplitter.DoSplitter(nUserListCtrlHeight);

	CRect rtChatDlg(0, 0, 0, 0);
	GetWindowRect(m_hWnd, &rtChatDlg);
	rtChatDlg.InflateRect(0, 0, 0, nUserListCtrlHeight);
	//MoveWindow(rtChatDlg);
}


void CChatDlg::OnMenuKickUser()
{
	for (size_t i=0; i<m_vecSelectItems.size(); ++i)
	{
		
 		CString strUserID = m_vecSelectItems[i]->data().value;
		//Modify by sevin for bts:NTALKCL-1137
// 		if (m_chatModel.IsInvitedUser(strUserID) == FALSE && m_chatModel.GetChatUserStatus(strUserID) != ustMOBILE)
// 		{
// 			RemoveUser(strUserID);
// 			HideShowLeftList();
// 			RefreshTitle();
// 		}
// 		else
// 		{
			if (!m_pNtalk)
				continue;

			m_pNtalk->RequestForceLeave(strUserID, m_chatModel.GetChatUserName(strUserID), m_chatModel.GetChatUserNickName(strUserID));

			ProcUregFavoriteFromPOI( strUserID.GetBuffer() );

			//모바일 사용자를 초대 하지 않은 상태면 퇴장 패킷을 보내고 리스트에서 직접 삭제도 해야함.
			//Modify by sevin for bts:NTALKCL-1154
			if (m_chatModel.IsInvitedUser(strUserID) == FALSE/* && m_chatModel.GetChatUserStatus(strUserID) == ustMOBILE*/)
			{
				RemoveUser(strUserID);
				HideShowLeftList();
				RefreshTitle();
				JudgeReadOnly();
			}
//		}
	}
}

void CChatDlg::OnMenuUserProfile()
{
	int nSelectCount = m_listChatUser.GetSelectedCount();

	if (nSelectCount < 0)
	{
		NMessageBox(this->wnd, LoadStringFromResource(IDS_STRING218));
	}

	CSingleLock lock(m_listChatUser.GetLockObject(), TRUE);
	POSITION pos = m_listChatUser.GetFirstSelectedItemPosition();

	while (pos)
	{
		int nIndex = m_listChatUser.GetNextSelectedItem(pos);
		CChatUserList::_chat_user_info* pChInfo = (CChatUserList::_chat_user_info*)m_listChatUser.GetItemData(nIndex);

		if (!pChInfo)
        {
			return;
        }
		CPoint pt(0, 0);
		GetCursorPos(&pt);
//		GET_MESSENGER_DLG()->GetProfileDlgController()->CreateProfileDlg(pChInfo->strUserID, pt, GetSafeHwnd());
	}
	m_listChatUser.UnSelectAll();
}

void CChatDlg::OnMenuChatHistoryOnTopMenu()
{
	CSingleLock lock(m_listChatUser.GetLockObject(), TRUE);
	CChatUserList::_chat_user_info* pChInfo = (CChatUserList::_chat_user_info*)m_listChatUser.GetItemData(0);
	if (!pChInfo)
	{
		return;
	}

	GET_MESSENGER_DLG()->OpenChatHistoryDlg(pChInfo->strUserID);
	m_listChatUser.UnSelectAll();
}

void CChatDlg::OnMenuChatHistory()
{
	int nSelectCount = m_listChatUser.GetSelectedCount();

	if (nSelectCount < 0)
	{
		NMessageBox(this->wnd, LoadStringFromResource(IDS_STRING218));
	}

	CSingleLock lock(m_listChatUser.GetLockObject(), TRUE);
	POSITION pos = m_listChatUser.GetFirstSelectedItemPosition();

	int nIndex = m_listChatUser.GetNextSelectedItem(pos);
	CChatUserList::_chat_user_info* pChInfo = (CChatUserList::_chat_user_info*)m_listChatUser.GetItemData(nIndex);

	if (!pChInfo)
		return;

	GET_MESSENGER_DLG()->OpenChatHistoryDlg(pChInfo->strUserID);
	m_listChatUser.UnSelectAll();
}

BOOL CChatDlg::IsInChat( CString strSearchText )
{
	BOOL bResult = FALSE;
	CSingleLock l(m_chatModel.GetChatItemCS(), TRUE);
	int nCount = m_chatModel.GetChatItemCount();

	if (0 == nCount)
		return FALSE;

	for (int i = nCount - 1; i >= 0; i--)
	{
		CChatItem *pChItem = (CChatItem*)m_chatModel.GetChatItemArray()->GetAt(i);

		if (pChItem == NULL)
			continue;

		LPChatItemInfo pInfo = pChItem->GetChatItemInfo();

		if (pInfo->eMsgGB == CHAT_MSG_CHAT || pInfo->eMsgGB == CHAT_MSG_SYS)
		{
			CChatMsgItem* pItem = dynamic_cast<CChatMsgItem*>(pChItem);
			if (pItem->FindString(strSearchText) && !bResult)
			{
				m_pSearchChatItem = pItem;
				bResult = TRUE;
			}
			else
			{
				pItem->GetSelectRange()->Reset();
			}
		}
	}

	if (bResult)
	{
		AdjustChatWindowToSearchResult();
	}

	return bResult;
}

void CChatDlg::AdjustChatWindowToSearchResult()
{
	if (NULL == m_pSearchChatItem)
		return;

	m_pChatMainView->ScrollToChatItem(m_pSearchChatItem);
}

void CChatDlg::InitChatUserListCtrl()
{
	CRect rtChatUser(0, 0, 0, 0);
	if (m_listChatUser.Create(WS_CHILD | WS_VISIBLE | LVS_REPORT | LVS_ALIGNLEFT | LVS_NOCOLUMNHEADER | LVS_SINGLESEL | LVS_OWNERDRAWFIXED, rtChatUser, this->wnd, ID_NEW_CHAT_USER_LIST))
	{
		m_listChatUser.SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_DOUBLEBUFFER);
		m_listChatUser.ModifyStyle(WS_HSCROLL, 0);		
		m_listChatUser.SetRowHeight(DEF_CHAT_USERLIST_ITEM_HEIGHT );	// 인자로 넘긴 크기만큼의 Pixel 로 높이가 계산되지 않기 때문에 임의로 2를 빼준다.
		m_listChatUser.SetBkColor(CU_COLOR_NORMAL_BK);
		m_listChatUser.ShowScrollBar(SB_VERT, FALSE);
		m_listChatUser.ShowScrollBar(SB_HORZ, FALSE);
		m_listChatUser.SetEnableHoveFlag(true);
	}

	// 리스트에 사용할 이미지 리스트
	if (m_ilStatus.Create(24, 18, ILC_COLOR32 | ILC_COLOR | ILC_MASK, 14, 3))
	{
		COLORREF crMask = RGB(0, 0, 0);

		const BYTE nStatusCnt = 14;
		for( BYTE i = 0; i < nStatusCnt; i++ )
		{
			CString strImageFilePath = GET_APP()->GetBuddyPresenceImageFilePath( (GTUserStatusType)(i > ustMEETING ? i - (ustMEETING+1) | ustMOBILE : i));

			CBitmap bmStatus;
			LoadBitmapFromPath(bmStatus, strImageFilePath);
			m_ilStatus.Add(&bmStatus, crMask);
			bmStatus.DeleteObject();
		}
	}

	// 리스트에 사용할 IPT 상태 이미지 리스트
	if (m_ilIPTStatus.Create(18, 18, ILC_COLOR32 | ILC_COLOR | ILC_MASK, 12, 3))
	{
		COLORREF crMask = RGB(0, 0, 0);

		const BYTE nStatusCnt = 9;
		for( BYTE i = 0; i < nStatusCnt; i++ )
		{
			CString strImageFilePath = GET_APP()->GetBuddyIPTPresenceImageFilePath( (NTIPTStatusType)i);

			CBitmap bmStatus;
			LoadBitmapFromPath(bmStatus, strImageFilePath);
			m_ilIPTStatus.Add(&bmStatus, crMask);
			bmStatus.DeleteObject();
		}
	}

	// 리스트 컬럼 헤더 제목(헤더가 없기 때문에 공백으로 설정함)
	CStringArray arrListHeaderTitle;
	arrListHeaderTitle.Add(_T(""));		// 상태 아이콘
	arrListHeaderTitle.Add(_T(""));		// 이름+내선번호
	arrListHeaderTitle.Add(_T(""));		// IPT

	m_listChatUser.SetImageList(&m_ilStatus, LVSIL_SMALL);

	LV_COLUMN lvcolumn;
	memset(&lvcolumn, 0, sizeof(lvcolumn));
	lvcolumn.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_MINWIDTH;

	for (int i = 0; i < arrListHeaderTitle.GetCount(); i++)
	{
		lvcolumn.fmt = LVCFMT_LEFT;
		lvcolumn.pszText = (LPTSTR)(LPCTSTR)arrListHeaderTitle.GetAt(i);
		lvcolumn.iSubItem = i;
		lvcolumn.cxMin = 0;
		m_listChatUser.InsertColumn(i, &lvcolumn);
	}

	// 리스트 컬럼 Width
	int colWidthList[] = {
		40,		// 상태
		120,	// 이름+내선번호
		35,		// IPT
		-1
	};

	for (int i = 0; colWidthList[i] != -1; i++)
	{
		m_listChatUser.SetColumnWidth(i, colWidthList[i]);
	}

	m_listChatUser.SetIPTPresenceImageList(&m_ilIPTStatus);
}

void CChatDlg::OnMenuIPT(WPARAM wParam)
{
	if (GET_APP()->IsAvailableIPT() != TRUE)
		return;

	if (m_listChatUser.GetSelectedCount() != 1)
		return;

	CSingleLock lock(m_listChatUser.GetLockObject(), TRUE);
	POSITION pos = m_listChatUser.GetFirstSelectedItemPosition();
	int nIndex = m_listChatUser.GetNextSelectedItem(pos);

	CChatUserList::_chat_user_info ChInfo;
	{
		CChatUserList::_chat_user_info* pChInfo = (CChatUserList::_chat_user_info*)m_listChatUser.GetItemData(nIndex);

		if (!pChInfo)
			return;

		ChInfo = *pChInfo;
	}

	int nID = (int)wParam;
	CString strTelNo = _T("");

	switch (nID)
	{
	case ID_MENU_COMPANY_PHONE:
	case ID_MENU_IPT_CORP_PHONE:
		strTelNo = ChInfo.strIncoTel;
		break;

	case ID_MENU_CELL_PHONE:
	case ID_MENU_IPT_CELLPHONE:
		strTelNo = ChInfo.strCellphone;
		break;

	case ID_MENU_EXT_PHONE:
	case ID_MENU_IPT_EXT_PHONE:
		strTelNo = ChInfo.strExtensionTel;
		break;
	}

	NE_MEMBER_DATA userData;
	userData.strUserId = ChInfo.strUserID;
	userData.strName = ChInfo.strUserName;
	userData.strJobPos = ChInfo.strJobPos;
	userData.strJobDuty = ChInfo.strJobDuty;
	userData.strDept = ChInfo.strUserDepart;

	CallToIPT(userData, strTelNo);
}

void CChatDlg::CallToIPT(NE_MEMBER_DATA userData, CString strTel)
{
	if (strTel.IsEmpty())
		return;

	CDialPadManager* pManager = CDialPadManager::GetDialpadManager();

	if (pManager)
		pManager->MakeCall(userData, strTel);

	m_listChatUser.UnSelectAll();	
}

void CChatDlg::SetWindowTop()
{
	wnd->SetWindowPos(&wnd->wndTop, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
}

void CChatDlg::SetForegroundWindowForce(HWND hWnd)
{
	if ( GetStyle() & WS_MINIMIZE )
	{
		::ShowWindow(m_hWnd, SW_SHOWNOACTIVATE);
		UpdateWindow(m_hWnd);
	}
	if( ::IsZoomed(m_hWnd) ) 
	{
		CControlUI* pControl = static_cast<CControlUI*>(m_PaintManager.FindControl(_T("maxbtn")));
		if( pControl ) 
		{
			pControl->SetVisible(false);
		}
		pControl = static_cast<CControlUI*>(m_PaintManager.FindControl(_T("restorebtn")));
		if( pControl ) 
		{
			pControl->SetVisible(true);
		}
	}
	else 
	{
		CControlUI* pControl = static_cast<CControlUI*>(m_PaintManager.FindControl(_T("maxbtn")));
		if( pControl ) 
		{
			pControl->SetVisible(true);
		}
		pControl = static_cast<CControlUI*>(m_PaintManager.FindControl(_T("restorebtn")));
		if( pControl ) 
		{
			pControl->SetVisible(false);
		}
	}

	HWND hWndForeground = ::GetForegroundWindow();
	if(hWndForeground == hWnd) return;

	DWORD Strange = ::GetWindowThreadProcessId(hWndForeground, NULL);
	DWORD My = ::GetWindowThreadProcessId(hWnd, NULL);
	::AttachThreadInput(Strange, My, TRUE); 
	::SetForegroundWindow(hWnd);
	::BringWindowToTop(hWnd);
	::SetFocus(hWnd);
	::AttachThreadInput(Strange, My, FALSE);
}

void CChatDlg::AddChatToMainView(CHAT_MSG* pItem)
{
	/* 내 언어설정과 상대방 언어설정이 다른 경우 이름이 상대방 언어 기준으로 오게 되서 문제가 있다.
	 * (나는 영어 설정인데, 상대방이 중국어인 경우 상대방 이름이 중국어로 옴)
	 * 그런데 대화자 List 에는 GetEmployeeInfo를 해서 다국어 이름을 가지고 있으므로, 
	 * 채팅 메시지의 이름이 다르면 List 기준으로 변경해준다.
	 */
	CString strNameToMyLanguage = ConvertUserNameToMyLanguage(pItem->strID);

	if (!strNameToMyLanguage.IsEmpty())
		pItem->strName = strNameToMyLanguage;

	m_pChatMainView->AddChatItem(pItem);
	//CFileTranslateAbnormalHandler::Enable(m_chatModel.GetRoomID(), false);
	AddRecentContact();
}

CString CChatDlg::ConvertUserNameToMyLanguage(CString strUserID)
{
	CSingleLock lock(m_listChatUser.GetLockObject(), TRUE);

	int nCount = m_listChatUser.GetItemCount();
	CChatUserList::_chat_user_info* pChInfo = NULL;

	for (int i = 0; i < nCount; i++)
	{
		pChInfo = (CChatUserList::_chat_user_info*)m_listChatUser.GetItemData(i);

		if (!pChInfo)
			continue;

		if (pChInfo->strUserID.CompareNoCase(strUserID) == 0)
		{
			return pChInfo->strUserName;
		}
	}

	return _T("");
}

trid_t CChatDlg::GetChatTrid()
{
	return m_chatModel.GetChatTrid();
}

int CChatDlg::FindUserMap( LPCTSTR strUserID )
{
	return m_chatModel.FindUserMap(strUserID);
}

BOOL CChatDlg::IsEqualChatDlg(const std::vector<CChatUser *>& userList, LPCTSTR strAddress, int nPort, int nRoomID )
{
	return m_chatModel.IsEqualChatDlg(userList, strAddress, nPort, nRoomID);
}

void CChatDlg::SetServerInfo( LPCTSTR strSrvAddress, int nSrvPort, int nRoomID, LPCTSTR strRoomType )
{
	m_chatModel.SetServerInfo(strSrvAddress, nSrvPort, nRoomID, strRoomType);

	int nMaxNid = SQLITE3.GetMaxMsgId(nRoomID,m_chatModel.GetMyID());
	m_chatModel.SetChatMsgTid(nMaxNid);	
	m_pChatMainView->ShowRecentMessage();
}

UIElement* CChatDlg::AddChatItem( CString strUserID, CString strName, CString strTalkName, 
						   CTime time, CString strChatMsg, CHARFORMAT2 cf, UINT nTid /*= 0*/, 
						   UINT nMsgSeq /*= 0*/, BYTE msgType /*= DEF_CHAT_MSG_TYPE_CHAT*/,TranslateFileInfoPtr typeData, bool bRestore )
{
	UIElement *pUIElement = NULL;
	ChatItemInfo stChatItemInfo;
	if (strUserID.IsEmpty() || msgType == DEF_CHAT_MSG_TYPE_STICKER || msgType == DEF_CHAT_MSG_TYPE_CHAT)
	{		
		if(strUserID.IsEmpty())
		  stChatItemInfo.eMsgGB = CHAT_MSG_SYS;	
		else if (msgType == DEF_CHAT_MSG_TYPE_STICKER)
		{
			stChatItemInfo.eMsgGB = CHAT_MSG_STICKER;	
		}
		else if (msgType == DEF_CHAT_MSG_TYPE_CHAT)
		{
	       stChatItemInfo.eMsgGB = CHAT_MSG_CHAT;
		}
		stChatItemInfo.strUserID = strUserID;
		stChatItemInfo.strNameTalkName = strTalkName;
		stChatItemInfo.strUserName = strName;
		stChatItemInfo.cf = cf;
		stChatItemInfo.nMsgSeq = nMsgSeq;
		stChatItemInfo.nTid = nTid;
		stChatItemInfo.time = time;
		stChatItemInfo.strMsg = strChatMsg;
		stChatItemInfo.nUserCount = m_pChatMainView->GetChatModel()->GetUserCount();
		pUIElement = m_pChatMainView->AddChatItem(&stChatItemInfo, bRestore);
	}
	else if (msgType == DEF_FTP_MSG_TYPE)
	{
	    //ChatItemInfo  stChatItemInfo;
		stChatItemInfo.eMsgGB = CHAT_MSG_FTP;
		stChatItemInfo.strUserID = strUserID;
		stChatItemInfo.strNameTalkName = strTalkName;
		stChatItemInfo.strUserName = strName;
		stChatItemInfo.cf = cf;
		stChatItemInfo.nMsgSeq = nMsgSeq;
		stChatItemInfo.nTid = nTid;
		stChatItemInfo.time = time;
		stChatItemInfo.strMsg = strChatMsg;
		CChatFileItem chatFileItem(stChatItemInfo);		
		chatFileItem.SetTranslateFileInfo(typeData);
		pUIElement = m_pChatMainView->AddTranslateFileItem(&stChatItemInfo, typeData, bRestore);
		
	}

	m_pChatMainView->GetChatModel()->SetChatMsgTid(nTid);
	GET_MESSENGER_DLG()->GetMainFrame()->UpdateChatRoomList(this);

	return pUIElement;
}

BOOL CChatDlg::IsScrollLocked()
{
	return m_bScrollock;
}

LRESULT CChatDlg::_OnCommandMenuTopMost(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled)
{
	OnMenuTopMost();
	return 0;
}

LRESULT CChatDlg::_OnCommandMenuKickUser(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled)
{
	OnMenuKickUser();
	return 0;
}

LRESULT CChatDlg::_OnCommandMenuChatHistory(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled)
{
	OnMenuChatHistoryOnTopMenu();
	return 0;
}	

LRESULT CChatDlg::_OnCommandMenuInvite(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled)
{
	OnMenuInvite();
	return 0;
}

LRESULT CChatDlg::_OnCommandMenuSendFiles(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled)
{
	OnMenuSendFiles();
	return 0;
}

LRESULT CChatDlg::_OnCommandMenuSendMemo(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled)
{
	OnMenuSendMemo();
	return 0;
}

void CChatDlg::OnMenuTopMost()
{
	if (m_bTopMost)
	{
		m_bTopMost = false;
		wnd->SetWindowPos(&wnd->wndNoTopMost, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE);

		CButtonUI* pBtnPin = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("btn_pin")));
		pBtnPin->SetNormalImage(_T("btn_chat_pin_off.png"));
		pBtnPin->SetToolTip(LoadStringFromResource(IDS_STRING_CHAT_TOOLTIP_3_1));
	}
	else
	{
		m_bTopMost = true;
		wnd->SetWindowPos(&wnd->wndTopMost, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE);
		CButtonUI* pBtnPin = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("btn_pin")));
		pBtnPin->SetNormalImage(_T("btn_chat_pin_on.png"));
		pBtnPin->SetToolTip(LoadStringFromResource(IDS_STRING_CHAT_TOOLTIP_3_2));
	}
}

void CChatDlg::OnMenuSendMemo()
{
	DoChatSendMemo();
}

void CChatDlg::OnMenuSendFiles()
{
	DoChatSendFiles();
}

void CChatDlg::OnMenuInvite()
{
	DoChatInvite();
}

void CChatDlg::InitRichEditCtrl()
{
    ASSERT(m_pEditChat);
	if(m_pEditChat)
	{
        m_PaintManager.SetInitFocus(m_pEditChat);
		//m_PaintManager.SetFocusNeeded(m_pEditChat);
	}
}

bool CChatDlg::CreateChatMainView()
{
	CRect rtChatMain(0, 0, 0, 0);

	m_pChatMainView->SetChatModel(&m_chatModel);

	//if (CHAT_BUBBLE == GET_CONFIG()->GetChatDisplayType())
	{
		CString strTmpClassName;

		strTmpClassName.Format(_T("Ntalk_ChatMain_%X%X%X"),
			GetTickCount(),
			GetCurrentProcessId(),
			GetCurrentThreadId());
		::RegisterWindowClass(strTmpClassName);

		if (m_pChatMainView->CreateElementList(strTmpClassName, _T("Ntalk_Chat_Main"), WS_CHILD|WS_VISIBLE|WS_CLIPCHILDREN|WS_CLIPSIBLINGS, 
			rtChatMain, this->wnd, ID_NEW_CHAT_MAIN, GET_CONFIG()->GetChatDisplayType()))
		{
			m_pChatMainView->SetImgDateBGPath(_T("img_chat_talk_date_l_01.png"), 0);
			m_pChatMainView->SetImgDateBGPath(_T("img_chat_talk_date_c_01.png"), 1);
			m_pChatMainView->SetImgDateBGPath(_T("img_chat_talk_date_r_01.png"), 2);
			m_pChatMainView->SetImgSysMsgArrow(_T("img_chat_notiarrow_icon.png"));
			m_pChatMainView->SetImgSendFail(_T("icon_notice20_r.bmp"));
		}
		else
		{
			return false;
		}
	}

	return true;
}

void CChatDlg::AddMyInfoToChatUserList()
{
	// 나 자신을 대화상대 리스트에 추가
	AddChatUserToListCtrl(m_chatModel.GetMyID(), m_chatModel.GetMyName(), m_chatModel.GetMyTalkName(), m_chatModel.GetMyStatus(), 
		m_chatModel.GetMyPage().strExtensionTelNo, m_chatModel.GetMyPage().strCphNo, m_chatModel.GetMyPage().strJbpsName, 
		m_chatModel.GetMyPage().strJbdtName, m_chatModel.GetMyPage().strDeptName);
}

BOOL CChatDlg::IsAnyFTProcessRunning()
{
	int nDoingJobCount = 0;
	int nWaittingJobCount = 0;
	m_pInternetTransfer->GetRunningStatus(&nDoingJobCount, &nWaittingJobCount);
	return (BOOL)(nDoingJobCount || nWaittingJobCount);
}

//void CChatDlg::ResendFileItem( CChatItem* pChatItem )
//{
//	CChatFileItem* pChatFileItem = dynamic_cast<CChatFileItem*>(pChatItem);
//	ASSERT(pChatFileItem);
//	TranslateFileInfoPtr pFileInfo = pChatFileItem->GetTranslateFileInfo();
//	ASSERT(!pFileInfo->IsUploadJob());
//
//	StartDownloadFile(pFileInfo);
//}

CChatModel* CChatDlg::GetChatModel()
{
	return &m_chatModel;

}

LRESULT CChatDlg::OnListNotifyHover(WPARAM wParam,LPARAM lParam)
{
	int iType = (int)lParam;
	if(iType == 1)
	{
       HideWorkStatusPopup();
	}
	else if(iType == 0)
	{
	    int nIndex = (int)wParam;
	    ShowWorkStatusPopup( nIndex);
	}

	return false;
}

void CChatDlg::ShowWorkStatusPopup( int nIndex )
{
	if(nIndex < 0)
      return;

	CString strWorkStatus; 

	CChatUserList::_chat_user_info* pInfo = (CChatUserList::_chat_user_info*)m_listChatUser.GetItemData(nIndex);

	if(pInfo == NULL )
	{
		return ;
	}
	
   GTUserStatusType stStatus;
   stStatus =  this->GetChatModel()->GetChatUserStatus(pInfo->strUserID);
  
	strWorkStatus = GetPresenceTip(stStatus);
	
	if (strWorkStatus.IsEmpty())
		return;
	if(!m_bshowtip)
    m_bshowtip = ShowTooltip(m_listChatUser.GetSafeHwnd(),strWorkStatus);
}

void CChatDlg::HideWorkStatusPopup()
{
	m_bshowtip = HideTooltip(m_listChatUser.GetSafeHwnd( ) ) ;

}
// 
// BOOL CChatDlg::AddRecentUsedStickers(int recentSticker){
//   
// 	RecentStickerVec::iterator itr =  find(m_vecRecentSticker.begin(), m_vecRecentSticker.end(), recentSticker);
// 	if (itr !=m_vecRecentSticker.end())
// 	{
// 		m_vecRecentSticker.erase(itr);
// 	}	
// 
// 	if (m_vecRecentSticker.size() > 11)
// 	{
// 		m_vecRecentSticker.pop_back();
// 	}
// 	m_vecRecentSticker.insert(m_vecRecentSticker.begin(),recentSticker);
// 	GET_CONFIG()->SaveRecentUsedStickerInfo(&m_vecRecentSticker);
// 
//    return TRUE;
// }


BOOL CChatDlg::AddRecentContact()
{
	if(GetChatUserMapCount() != 1 || IsGroupRoom())
	{
		return FALSE;
	}

	CString strContactUserId = GetChatUserID(0);
	CString strMyUserId = GetMyUserID();
	CTime timeContact = CTime::GetCurrentTime();

	CRecentContacts* pRecentContact = NULL;
	if(GET_MESSENGER_DLG()->GetMainFrame())
		pRecentContact = GET_MESSENGER_DLG()->GetMainFrame()->GetRecentContacts();

	BOOL bRet = FALSE;
	bRet = pRecentContact->NotifyController(strContactUserId);
	if(!bRet)
	{
		return FALSE;
	}
	bRet = pRecentContact->AddContact(strMyUserId, strContactUserId, timeContact);
	
	return bRet;
}

void CChatDlg::DrawSlideBar(HDC hDC)
{
	Graphics graph(hDC);
	graph.SetSmoothingMode(SmoothingModeAntiAlias);
	graph.SetPageUnit(UnitPixel);

	Image* slidebar_bg = CFTImageMapInt::Instance()->GetImageByID(slide_bar_bg);
	Image* slidebar_fg = CFTImageMapInt::Instance()->GetImageByID(slide_bar_fg);
	Image* slidebar_btn = CFTImageMapInt::Instance()->GetImageByID(slide_bar_btn);

	if (slidebar_btn && slidebar_bg && slidebar_fg)
	{	
		graph.DrawImage(slidebar_bg, m_rtSlideBar.left, m_rtSlideBar.top, m_rtSlideBar.Width(), m_rtSlideBar.Height());

		int nPosWidth = m_nSlidePos * m_rtSlideBar.Width() / 100;
		graph.DrawImage(slidebar_fg, m_rtSlideBar.left, m_rtSlideBar.top, nPosWidth, m_rtSlideBar.Height());

		CRect rtBtn = GetSlideBtnRect(m_rtSlideBar, m_nSlidePos);

		graph.DrawImage(slidebar_btn, rtBtn.left, rtBtn.top, rtBtn.Width(), rtBtn.Height());
	}
}

void CChatDlg::SetAlpha(int nValue)
{
	//wnd->SetLayeredWindowAttributes(0, nValue, LWA_ALPHA);
	m_PaintManager.SetTransparent(nValue);
}

void CChatDlg::RemoveItem(LPCTSTR strUserID)
{
	//RemoveUser(strUserID);

    //TODO: why this function is empty but there is caller in ChatDialogManager::RemoveBuddy
    ASSERT(FALSE);
}

bool CChatDlg::SyncFileTranslateInfo( TranslateFileInfoPtr& pUploadFileInfo )
{
	if (IsScrollLocked())
	{
		SetScrollLock(false);
	}

	CTime time(CTime::GetCurrentTime());
	GetLocaleTime(&time);

	CString strUserNickName = g_pMessengerActor->GetTalkName();	
	ChatItemInfo stItemInfo;
	stItemInfo.eMsgGB = CHAT_MSG_FTP;
	stItemInfo.strUserID = m_chatModel.GetMyID();
	stItemInfo.strUserName = m_chatModel.GetMyName();
	stItemInfo.strNameTalkName = strUserNickName;
	stItemInfo.time = time;
	pUploadFileInfo->m_bUpload = true;
	m_pChatMainView->AddTranslateFileItem(&stItemInfo, pUploadFileInfo);
	pUploadFileInfo->SetStatus(sUploadSuccess);
	AddRecentContact();

	return true;
}

BOOL CChatDlg::IsFocuseOnSearchEdit()
{
	BOOL bFocuse = FALSE;
	CEditUI* searchEdit = static_cast<CEditUI*>(m_PaintManager.FindControl(kChatSearchEdit));
	if (searchEdit != NULL && searchEdit->IsFocused())
	{
		bFocuse = TRUE;
	}
	return bFocuse;
}

void CChatDlg::CloseChatSearchWnd(BOOL bClearSearchEdit, BOOL bSetFocusToRichEdit)
{
	if ((g_pProfileWnd != NULL) && (m_pChatSearchWnd != NULL) && (g_pProfileWnd->GetParentHwnd() == m_pChatSearchWnd->GetHWND()))
	{
		g_pProfileWnd->CloseProfileWnd();
	}
	if (m_pChatSearchWnd != NULL && ::IsWindow(m_pChatSearchWnd->GetHWND()))
	{
		m_pChatSearchWnd->Close();
	}
	
	CEditUI* searchEdit = static_cast<CEditUI*>(m_PaintManager.FindControl(kChatSearchEdit));
	if (searchEdit != NULL && bClearSearchEdit)
	{
		m_strSearchWord = _T("");//msg.pSender->GetText();
		searchEdit->SetText(m_strSearchWord);
		searchEdit->SetVisible(false);

		CButtonUI* searchLabel = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSearchLabel));
		if (searchLabel != NULL)
		{
			searchLabel->SetVisible();
			searchLabel->SetText(LoadStringFromResource(IDS_STRING_CHAT_DEFAULT_SEARCH));
			searchLabel->SetToolTip(LoadStringFromResource(IDS_STRING_CHAT_DEFAULT_SEARCH));
		}
	}
	
	CVerticalLayoutUI* search_cancel = static_cast<CVerticalLayoutUI*>(m_PaintManager.FindControl(kChatSearchCancel)); 
	if (search_cancel != NULL)
	{
		search_cancel->SetVisible(false);
	}

	//CRichEditUI* pEditChat =  static_cast<CRichEditUI*>(m_PaintManager.FindControl(_T("edit_chat")));
	if (m_pEditChat != NULL && bSetFocusToRichEdit)
	{
		m_PaintManager.SetFocus(m_pEditChat);
	}
}

void CChatDlg::OnSearchUser()
{
	CEditUI* searchEdit = static_cast<CEditUI*>(m_PaintManager.FindControl(kChatSearchEdit));
	if (searchEdit != NULL)
	{
		m_strSearchWord = searchEdit->GetText();
		CString strSearch = m_strSearchWord.Trim(_T("% "));;
		if (strSearch.GetLength() > 1)
		{
			if (m_pChatSearchWnd == NULL || !::IsWindow(m_pChatSearchWnd->GetHWND()))
			{
				m_pChatSearchWnd = new CChatSearchWnd(this);
				m_pChatSearchWnd->Create(GetHWND(), _T("ChatSearchWnd"), WS_CHILD, WS_EX_WINDOWEDGE, NULL);
			}
			GET_MESSENGER_DLG()->GetMainFrame()->SetCurChatSearchWnd(m_pChatSearchWnd);
			CRect rcSearch(0, 0, 0, 0);
			GetClientRect(m_hWnd, &rcSearch);
			rcSearch.bottom -= 37;
			rcSearch.top = rcSearch.bottom - m_pChatSearchWnd->GetChatSearchHeight();
			rcSearch.left += 1;
			rcSearch.right = m_rtSplitter.left - 1;
			m_pChatSearchWnd->SetClientRect(rcSearch);
			::ShowWindow(m_pChatSearchWnd->GetHWND(), SW_HIDE);
			if ((g_pProfileWnd != NULL) && (m_pChatSearchWnd != NULL) && (g_pProfileWnd->GetParentHwnd() == m_pChatSearchWnd->GetHWND()))
			{
				g_pProfileWnd->CloseProfileWnd();
			}
	
			if(GET_MESSENGER_DLG()->GetMainFrame())
			{
				GET_MESSENGER_DLG()->GetMainFrame()->SetRequestSearch(strSearch, CHAT_ORG_SEARCH);
				
			}
			CLabelUI* pSearchResult = m_pChatSearchWnd->GetNosearchResultLabel();
			if (pSearchResult != NULL)
			{
				pSearchResult->SetVisible(false);
			}
			//CEditUI* searchEdit = static_cast<CEditUI*>(m_PaintManager.FindControl(kChatSearchEdit));
			CButtonUI* searchLabel = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSearchLabel));
			if (searchEdit != NULL && searchLabel != NULL)
			{
				m_strSearchWord = searchEdit->GetText();
				searchEdit->SetVisible(false);
				searchLabel->SetVisible(true);
			}

			CVerticalLayoutUI* search_cancel = static_cast<CVerticalLayoutUI*>(m_PaintManager.FindControl(kChatSearchCancel));
			if (search_cancel != NULL)
			{
				search_cancel->SetVisible(true);
			}
			SetFocus(m_pChatSearchWnd->GetHWND());
		}
		else
		{
			NMessageBox(CWnd::FromHandle(m_hWnd), LoadStringFromResource(IDS_STRING169));
			searchEdit->SetVisible(true);
			searchEdit->SetFocus();
			
		}
	}	
}

CChatLeftList* CChatDlg::GetFriendsCtrl()
{
	CChatLeftList* pFriendsList = static_cast<CChatLeftList*>(m_PaintManager.FindControl(kChatList));
	return pFriendsList;
}

LRESULT CChatDlg::OnNcLButtonDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	bHandled = FALSE;
	//CRichEditUI* pEditChat =  static_cast<CRichEditUI*>(m_PaintManager.FindControl(_T("edit_chat")));

	if (m_pEditChat != NULL )
	{
		m_PaintManager.SetFocus(m_pEditChat);
	}

	return 0;
}

LRESULT CChatDlg::OnKillFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	CRichEditUI* pEditChat =  static_cast<CRichEditUI*>(m_PaintManager.FindControl(_T("edit_chat")));

	if (pEditChat != NULL && pEditChat->IsFocused())
	{
		HWND hWndFocus = (HWND)wParam;
		//if(m_pChatMainView->GetChatSafeHwnd() != hWndFocus)
		//{
			m_PaintManager.SetFocus(NULL, false);
		//}
	}
    bHandled = TRUE;
    return 0;

	//return WindowImplBase::OnKillFocus(uMsg, wParam, lParam, bHandled);
}
